Package: MOSim
Title: Multi-Omics Simulation (MOSim)
Version: 2.6.0
Authors@R: c(person("Carolina", "Monzó", email = "carolmonzoc@gmail.com", role = c("aut")), person("Carlos", "Martínez", email = "cmarmir@gmail.com", role = "aut"), person("Sonia", "Tarazona", email = "sotacam@gmail.com", role = c("cre", "aut")))
Description: MOSim package simulates multi-omic experiments that mimic regulatory mechanisms within the cell, allowing flexible experimental design including time course and multiple groups.
Encoding: UTF-8
Depends: R (>= 4.2.0)
License: GPL-3
LazyData: false
biocViews: Software, TimeCourse, ExperimentalDesign, RNASeq
BugReports: https://github.com/ConesaLab/MOSim/issues
URL: https://github.com/ConesaLab/MOSim
Imports: HiddenMarkov, zoo, IRanges, S4Vectors, dplyr, ggplot2,
        lazyeval, matrixStats, methods, rlang, stringi, stringr, scran,
        Seurat, Signac, edgeR, Rcpp
Suggests: testthat, knitr, rmarkdown, codetools, BiocStyle, stats,
        utils, purrr, scales, tibble, tidyr, Biobase, scater,
        SingleCellExperiment, decor, markdown, Rsamtools, igraph,
        leiden, bluster
Collate: 'AllClass.R' 'AllGeneric.R' 'Simulator.R' 'SimulatorRegion.R'
        'ChIP-seq.R' 'DNase-seq.R' 'MOSim-package.R' 'functions.R'
        'Simulation.R' 'MOSim.R' 'RNA-seq.R' 'data.R'
        'simulate_WGBS_functions.R' 'methyl-seq.R' 'miRNA-seq.R'
        'sc_MOSim.R' 'sc_coexpression.R' 'sparsim_functions.R' 'zzz.R'
RoxygenNote: 7.3.2
VignetteBuilder: knitr
LinkingTo: cpp11, Rcpp
git_url: https://git.bioconductor.org/packages/MOSim
git_branch: RELEASE_3_22
git_last_commit: 3eff748
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 05:18:41 UTC; biocbuild
Author: Carolina Monzó [aut],
  Carlos Martínez [aut],
  Sonia Tarazona [cre, aut]
Maintainer: Sonia Tarazona <sotacam@gmail.com>

# MOSim
MOSim is an R package for the simulation of multi-omic bulk and single cell experiments that mimic regulatory mechanisms within the cell. 
Gene expression (RNA-seq count data) is the central data type simulated by MOSim, while the rest of available omic data types 
provide gene regulation information. For bulk simulation, regulators include ATAC-seq (DNase-seq), ChIP-seq, miRNA-seq and Methyl-seq. In addition to these omics, 
regulation by transcription factors (TFs) can also be modeled. While for single-cell simulation, the regulators included are scATAC-seq and TFs.  
MOSim has great flexibility in defining experimental designs, DEGs, and active regulators making it a versatile tool for a variety of different applications: 
i) validating methods aimed at modelling complex, multi-layered regulatory networks, ii) benchmarking multi-omics data integration pipelines, 
iii) benchmarking GRN inference tools, iv) evaluating differential expression and accessibility analysis tools, v) testing single-cell data clustering methods, 
vi) evaluating multi-omics visualization tools etc.  

### Installation

MOSim is a Bioconductor R package, and we strongly recommend that it is installed from the Bioconductor repository. 
To install MOSim, open the R console and run:

  ```
  if (!requireNamespace("BiocManager", quietly = TRUE)) 
      install.packages("BiocManager")

  BiocManager::install("MOSim")
  ```

The developer version (which now includes the sc_mosim functionalities) can be installed from GitHub using the devtools R package:
	
  ```
  install.packages("devtools")
  devtools::install_github("ConesaLab/MOSim")
  ```

### Documentation

Vignettes and documentation can be accessed from [MOSim's Bioconductor site](http://bioconductor.org/packages/release/bioc/html/MOSim.html), 
or by running the following line in the R console:

	browseVignettes("MOSim")


### Citation

If you used MOSim for your research, please cite:

- Monzó C, Aguerralde-Martin M, Martínez-Mira C, Arzalluz-Luque A,  Conesa A, Tarazona S (2025). MOSim: bulk and single-cell multi-layer regulatory network simulator. Briefings in Bioinformatics, Volume 26, Issue 5. DOI: 10.1093/bib/bbaf110
  
sc_mosim strongly relies on functionality from SPARSim. If you use the sc_mosim module to simulate multi-omics single cell data, please also cite:  
- Baruzzo G, Patuzzi I, Di Camillo B (2020). SPARSim single cell: a count data simulator for scRNA-seq data. Bioinformatics, Volume 36, Issue 5, Pages 1468-1475. DOI: 10.1093/bioinformatics/btz752

#' Check if a variable is declared.
#'
#' @param object Variable name to check
#' @param key Optional key to check inside object.
#'
#' @return TRUE or FALSE indicating if the variable is initialized & non-empty.
#'
is.declared <- function(object, key = NULL) {

    if (! is.null(key)) {

        if (! isS4(object)) {
            if (! exists(key, where = object))
                return(FALSE)

            object <- get(key, object)
        } else {
            object <- slot(object, key)
        }
    }

    # Check length, is.null, etc
    check <- ! is.null(object)

    # Check empty matrix
    if (check) {
        if (! is.null(dim(object))) {
            check <- ! all(is.na(object))
        } else {
            check <- as.logical(length(object))
        }
    }

    return(check)
}

#' @include AllClass.R
NULL

################################################################################
# General
################################################################################
#' Simulate [internal use]
#'
#' @rdname Generics
#' @section Shared methods:
#'
#' This generic can dispatch methods for two types of classes: \describe{
#' \item{\linkS4class{MOSimulation}}{in which case triggers the simulation on
#' every simulator loaded.}
#' \item{\linkS4class{MOSimulator}}{performs the simulation based on already
#' initialized simulation settings.} }
#'
#' @param object Object of class \linkS4class{MOSimulator} or \linkS4class{MOSimulation}.
#' @param simulation Only in \linkS4class{MOSimulator} class. Initialized instance of Simulation class
#' @param ... Extra parameters for extensibility.
#'
#' @return A \linkS4class{MOSimulator} object containing the simulation data inside @simData
#'  if called on a \linkS4class{MOSimulator} class, or a \linkS4class{MOSimulation} object with all @simulators
#'  containing simulated data.
#' @keywords internal
#' @noRd
#'
setGeneric("simulate", function(object, ...) standardGeneric("simulate"))

#' Simulate [internal use]
#'
#' @rdname Generics
#' @section Shared methods:
#'
#' This generic can dispatch methods from two types of classes:
#' \describe{
#'      \item{\linkS4class{MOSimulation}}{show the general simulation settings (experimental design, default depth...)}
#'      \item{\linkS4class{MOSimulator}}{individual omic options (depth, regulator effect...)}
#' }
#'
#' @param object Object of class \linkS4class{MOSimulator} or \linkS4class{MOSimulation}.
#' @return The simulation settings used for the general process (for MOSimulation class) or the individual omic (MOSimulator class).
#' @keywords internal
#' @noRd
#'
setGeneric("simSettings", function(object) standardGeneric("simSettings"))

################################################################################
# Simulator
################################################################################



#' Initialize data
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' This method will clone the seed data once per group to simulate and
#' establish differences using the simulation settings.
#'
#' @param object Instance of MOSimulator class.
#' @param simulation Instance of MOSimulation class.
#'
#' @return An instance of MOSimulator class with modified options.
#' @noRd
#'
setGeneric("initializeData", function(object, simulation) standardGeneric("initializeData"))

#' postSimulation
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Method called after performing the simulation, allowing different actions
#' like adjusting depth, rounding values and so on, on a simulator basis.
#'
#' @param object Instance of MOSimulator class.
#' @param simulation Instance of MOSimulation class.
#'
#' @return An instance of MOSimulator class with modified options.
#' @keywords internal
#' @noRd

#'
setGeneric("postSimulation", function(object, simulation) standardGeneric("postSimulation"))

#' IDfromGenes
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Method for transforming genes to IDs (regions, miRNA...)
#'
#' @param object Instance of a MOSimulator class
#' @param geneNames Names of genes to look up in the association table.
#'
#' @return IDs corresponding to the genes.
#' @keywords internal
#' @noRd
#'
setGeneric("IDfromGenes", function(object, geneNames, simplify = TRUE) standardGeneric("IDfromGenes"))


#' IDtoGenes
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Method for transforming IDs (regions, miRNAs, ...) to genes
#'
#' @param object Instance of a MOSimulator class.
#' @param idNames IDs to look up in the association table.
#'
#' @return Genes corresponding to the IDs.
#' @keywords internal
#' @noRd
#'
setGeneric("IDtoGenes", function(object, idNames, simplify = TRUE) standardGeneric("IDtoGenes"))

#' simulateParams
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Method to allow individual simulator classes to change the default behaviour
#' of generating noise and time coefficients.
#'
#' @param object Instance of a MOSimulator class.
#' @param simulation  Instance of a MOSimulation class
#' @param counts Initial count values to simulate.
#' @param profiles Generated simulation settings for the group being simulated.
#' @param group Group being simulated.
#' @param ids ID of every row.
#'
#' @return List with the following elements:
#' \describe{
#'      \item{randomCounts}{numeric vector containing random count values.}
#'      \item{noiseValues}{numeric vector containing noise values generated with the noise function and parameters specified.}
#'      \item{m}{numeric vector of lower values comparing original and random counts.}
#'      \item{M}{numeric vector of maximum values comparing original and random counts.}
#' }
#' @keywords internal
#' @noRd
#'
setGeneric("simulateParams", function(object, simulation, counts, profiles, group, ids, ...) standardGeneric("simulateParams"))

#' adjustProfiles
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Modify the configuration profile generated when initializing simulation settings
#' to allow for certain constrainsts if necessary.
#'
#' @param object Instance of MOSimulator class.
#' @param simulation Instance of MOSimulation class.
#' @param profiles Data frame containing the generated profile configuration for the
#'  simulator.
#' @param step Two possible options "Effect" and "Groups" indicating in which point
#' of the settings simulation is called.
#'
#' @return The data.frame profile with the necessary modifications depending on
#' each child class.
#' @keywords internal
#' @noRd
#'
setGeneric("adjustProfiles", function(object, simulation, profiles, step) standardGeneric("adjustProfiles"))


################################################################################
# MOSimulatorRegion
################################################################################
#' locGRanges
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Creates a very basic GRanges object based on locations
#'
#' @param object Instance of a MOSimulatorRegion class
#' @param locs Positions of locations
#'
#' @return GRanges object with 1 as seqname and locs as starting positions.
#' @keywords internal
#' @noRd
#'
setGeneric("locGRanges", function(object, locs) standardGeneric("locGRanges"))

#' regionNames
#'
#' @rdname Generics
#' @section Simulator methods:
#'
#' Creates a valid string of a region
#'
#' @param object Instace of a MOSimulatorRegion class
#' @param chrNumber IDs of the chromosomes
#' @param start Starts positions of the regions
#' @param end End positions of the regions
#'
#' @return A character vector with the format "<chr>_<start>_<end>"
#' @keywords internal
#' @noRd
#'
setGeneric("regionNames", function(object, chrNumber, start, end=NULL) standardGeneric("regionNames"))

#' @include Simulator.R
NULL

# setMethod("initialize", signature="SimRNAseq", function(.Object, ...) {
#     .Object <- callNextMethod(.Object, ...)
#
#     return(.Object)
# })
#
# setMethod("initializeData", signature="SimRNAseq", function(object, simulation) {
#
#     message("Initializing RNA-seq data.")
#
#     # Call parent method AFTER correcting zero counts
#     object <- callNextMethod()
#
#     return(object)
# })
#
#
# setMethod("postSimulation", signature="SimRNAseq", function(object, simulation) {
#     object <- callNextMethod()
#
#     return(object)
# })

setMethod("IDfromGenes", signature="SimRNAseq", function(object, geneNames) {
    return(geneNames)
})

setMethod("IDtoGenes", signature="SimRNAseq", function(object, idNames) {
    return(idNames)
})

#' @include Simulation.R
#' @import ggplot2
#' @importFrom dplyr %>%
#' @importFrom rlang := !! .data
#' @importFrom stats setNames
NULL

# Avoid harmless note with R CMD check
if(getRversion() >= "2.15.1")  utils::globalVariables(c(".", "n", "sampleData",
          "Block", "Counts", "DE", "DE.Gene", "DE.TF", "Effect", 
          "Exclude", "Gene", "ID", "ID.y", "IsLagged",
          "Lagged", "LinkedGene", "Mean", "Measure", "Omic", 
          "Point", "Profile", "Rep", "SE", "ScaledMean",
          "ScaledSE", "Symbol", "TFgene", "Time", "chr", "end", 
          "start"))

#' MOSim
#'
#' Multiomics simulation package.
#'
#'
#' @docType package
#' @name MOSim-package
#' @keywords internal
"_PACKAGE"
NULL
#> NULL

# The default 'mosim' values should be identical to the prototype values of
# simulation class. To avoid warnings checking the package we use
defaultPrototypeValues <- getClass("MOSimulation")@prototype

#' mosim
#'
#' Performs a multiomic simulation by chaining two actions: 1) Creating the
#' "MOSimulation" class with the provided params. 2) Calling "simulate" method on
#' the initialized object.
#'
#' @param omics Character vector containing the names of the omics to simulate,
#'   which can be "RNA-seq", "miRNA-seq", "DNase-seq", "ChIP-seq" or
#'   "Methyl-seq"  (e.g. c("RNA-seq", "miRNA-seq")). It can also be a list with
#'   the omic names as names and their options as values, but we recommend to
#'   use the argument omicSim to provide the options to simulated each omic.
#' @param omicsOptions List containing the options to simulate each omic. We
#'   recommend to apply the helper method \link{omicSim} to create this list in
#'   a friendly way, and the function \link{omicData} to provide custom data
#'   (see the related sections for more information). Each omic may have
#'   different configuration parameters, but the common ones are:
#'   \describe{
#'       \item{simuData/idToGene}{Seed sample and association tables for
#'       regulatory omics. The helper function \link{omicData} should be used to
#'       provide this information (see the following section).}
#'       \item{regulatorEffect}{For regulatory omics. List containing the
#'       percentage of effect types (repressor, activator or no effect) over the
#'       total number of regulators. See vignette for more information.}
#'       \item{totalFeatures}{Number of features to simulate. By default, the
#'       total number of features in the seed dataset.}
#'       \item{depth}{Sequencing depth in millions of reads. If not provided,
#'       it takes the global parameter passed to \link{mosim} function.}
#'       \item{replicateParams}{List with parameters \emph{a} and \emph{b} for
#'       adjusting the variability in the generation of replicates using the
#'       negative binomial. See vignette for more information.}
#'    }
#' @param diffGenes  Number of differentially expressed genes to simulate, given
#'   in percentage (0 - 1) or in absolute number (> 1). By default 0.15
#' @param numberReps Number of replicates per experimetal condition (and time
#'   point, if time series are to be generated). By default 3.
#' @param numberGroups Number of experimental groups or conditions to simulate.
#' @param times Vector of time points to consider in the experimental design.
#' @param TFtoGene A logical value indicating if default transcription factors
#'   data should be used (TRUE) or not (FALSE), or a 3 column data frame
#'   containing custom associations. By default FALSE.
#' @param depth Sequencing depth in millions of reads.
#' @param profileProbs Numeric vector with the probabilities to assign each of
#'   the patterns. Defaults to 0.2 for each.
#' @param minMaxFC Numeric vector of length 2 with minimum and maximum fold-change
#'   for differentially expressed features, respectively.
#'
#' @return Instance of class "MOSimulation" containing the multiomic simulation
#'   data.
#' @export
#'
#' @examples
#'
#'  moSimulation <- mosim(
#'      omics = c("RNA-seq"),
#'      numberReps = 3,
#'      times = c(0, 2, 6, 12, 24)
#'  )
#'
#'  # Retrieve simulated count matrix for RNA-seq
#'  dataRNAseq <- omicResults(moSimulation, "RNA-seq")
#'
#'
mosim <-
    function(omics,
             omicsOptions,
             diffGenes,
             numberReps,
             numberGroups,
             times,
             depth,
             profileProbs,
             minMaxFC,
             TFtoGene
    ) {

    # Check for mandatory parameters
    if (missing(omics))
        stop("You must provide the vector of omics to simulate.")
      
    # Params to initialize simulation instance
    mosimCall <- as.list(match.call(expand.dots = FALSE))[-1]
    simParams <- mapply(function(argName, argValue) {
        if (is.symbol(argValue))
            return(get(argName))

        return(argValue)
    }, names(mosimCall), mosimCall, SIMPLIFY = FALSE, USE.NAMES = TRUE)

    # Select unique names
    omics <- if (is.list(omics)) omics[unique(names(omics))] else unique(omics)

    # 'omics' parameter alias of 'simulators'
    simParams$simulators <- omics

    # If it is a plain vector, transform it to a list of empty lists
    if (! is.list(simParams$simulators)) {
        simParams$simulators <- setNames(rep(list(list()), length(simParams$simulators)),
                                         simParams$simulators)
    }

    if (! missing(omicsOptions)) {
        if (! all(names(omicsOptions) %in% names(simParams$simulators)))
            stop("There are keys in 'omicOptions' not present on 'omics' list.")

        # Set options (not required)
        for (omicName in names(omicsOptions)) {
            omicParams <- omicsOptions[[omicName]]

            # Transform the "regulatorEffect" parameter to change "activator" to "enhancer"
            # effect.
            if (is.element("regulatorEffect", names(omicParams))) {
                names(omicParams$regulatorEffect) <- gsub("activator", "enhancer", names(omicParams$regulatorEffect))
            }

            # Modify the param list or the slots directly
            if (! inherits(simParams$simulators[[omicName]], "MOSimulator")) {
                simParams$simulators[[omicName]] <- omicParams
            } else {
                # Override every slot manually
                for (slotName in names(omicParams)) {
                    slot(simParams$simulators[[omicName]], slotName) <- omicParams[[slotName]]
                }
            }
        }
    }

    # Remove keys not present in 'MOSimulation' class slots
    simParams <- simParams[names(simParams) %in% slotNames("MOSimulation")]

    oSim <- do.call(new, c("Class"="MOSimulation", simParams))
    oSim <- simulate(oSim)

    return(oSim)
}

#' Set customized data for an omic.
#'
#' @param omic The name of the omic to provide data.
#' @param data Data frame with the omic identifiers as row names and just one
#'   column named Counts containing numeric values used as initial sample for
#'   the simulation.
#' @param associationList Only for regulatory omics, a data frame with 2
#'   columns, the first called containing the regulator ID and the second called
#'   Gene with the gene identifier.
#'
#' @return Initialized simulation object with the given data.
#' @export
#'
#' @examples
#'
#' # Take a subset of the included dataset for illustration
#' # purposes. We could also load it from a csv file or RData,
#' # as long as we transform it to have 1 column named "Counts"
#' # and the identifiers as row names.
#'
#' data(sampleData)
#'
#' custom_rnaseq <- head(sampleData$SimRNAseq$data, 100)
#'
#' # In this case, 'custom_rnaseq' is a data frame with
#' # the structure:
#' head(custom_rnaseq)
#' ##                    Counts
#' ## ENSMUSG00000000001   6572
#' ## ENSMUSG00000000003      0
#' ## ENSMUSG00000000028   4644
#' ## ENSMUSG00000000031      8
#' ## ENSMUSG00000000037      0
#' ## ENSMUSG00000000049      0
#'
#'
#' # The helper 'omicData' returns an object with our custom data.
#' rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)
#'
omicData <- function(omic, data = NULL, associationList = NULL) {
    # Convert the name to the proper class name
    omicClass <- paste0("Sim", gsub("-", "", omic))

    if (is(data, "ExpressionSet")) {
        data <- as.data.frame(Biobase::exprs(data))
    }

    # Create the new instance
    omicSim <- new(omicClass,
                   "data" = data,
                   "idToGene" = associationList)

    return(omicSim)
}

#' Set the simulation settings for an omic.
#'
#' @param omic Name of the omic to set the settings.
#' @param depth Sequencing depth in millions of counts. If not provided will
#'   take the global parameter passed to mosim function.
#' @param totalFeatures Limit the number of features to simulate. By default
#'   include all present in the dataset.
#' @param regulatorEffect only for regulatory omics. Associative list containing
#'   the percentage of effects over the total number of regulator, including
#'   repressor, association and no effect (NE).
#'
#' @return A list with the appropiate structure to be given as options in mosim
#'   function.
#' @export
#'
#' @examples
#'
#' omic_list <- c("RNA-seq", "miRNA-seq")
#'
#' rnaseq_options <- c(omicSim("miRNA-seq", totalFeatures = 2500))
#'
#' # The return value is an associative list compatible with
#' # 'omicsOptions'
#' rnaseq_simulation <- mosim(omics = omic_list,
#'                            omicsOptions = rnaseq_options)
#'
omicSim <- function(omic, depth = NULL, totalFeatures = NULL, regulatorEffect = NULL) {

    paramList <- list(
        "totalFeatures" = totalFeatures,
        "regulatorEffect" = regulatorEffect,
        "depth" = depth
    )

    paramList <- setNames(list(Filter(Negate(is.null), paramList)), omic)

    return(paramList)
}


#' Retrieves the settings used in a simulation
#'
#' @param simulation A MOSimulation object.
#' @param omics List of omics to retrieve the settings.
#' @param association A boolean indicating if the association must also be
#'   returned for the regulators.
#' @param reverse A boolean, swap the column order in the association list in
#'   case we want to use the output directly and the program requires a
#'   different ordering.
#' @param only.linked Return only the interactions that have an effect.
#' @param prefix Logical indicating if the name of the omic should prefix the
#'   name of the regulator.
#' @param include.lagged Logical indicating if interactions with transitory
#'   profile and different minimum/maximum time point between gene and regulator
#'   should be included or not.
#'
#' @return A list containing a data frame with the settings used to simulate
#'   each of the indicated omics. If association is TRUE, it will be a list with
#'   3 keys: 'associations', 'settings' and 'regulators', with the first two
#'   keys being a list containing the information for the selected omics and the
#'   last one a global data frame giving the merged information.
#' @export
#'
#' @examples
#'
#' omic_list <- c("RNA-seq", "miRNA-seq")
#' multi_simulation <- mosim(omics = omic_list)
#'
#' # This will be a data frame with RNA-seq settings (DE flag, profiles)
#' rnaseq_settings <- omicSettings(multi_simulation, "RNA-seq")
#'
#' # This will be a list containing all the simulated omics (RNA-seq
#' # and DNase-seq in this case)
#' all_settings <- omicSettings(multi_simulation)
#'
omicSettings <- function(simulation, omics = NULL, association = FALSE, reverse = FALSE, only.linked = FALSE, prefix = FALSE, include.lagged = TRUE) {
    # Select all omics by default
    if (is.null(omics)) {
        omics <- lapply(simulation@simulators, slot, name = "name")
    } else {
        names(omics) <- paste0("Sim", gsub("-", "", omics))
    }

    # Convert the name to the proper class name
    omicsClasses <- setNames(paste0("Sim", gsub("-", "", omics)), omics)

    selectedSettings <- simulation@simSettings$geneProfiles[omicsClasses]

    outputList <- setNames(selectedSettings, omics)

    # Remove Effect from settings and rename Effect.Linked to Effect
    # selectedSettings <- lapply(selectedSettings, function(x) {
    #     if (is.element("Effect", colnames(x))) {
    #         x <- dplyr::select(x, -Effect) %>%
    #                          dplyr::rename(Effect = Effect.Linked)
    #     }
    #
    #     return(x)
    # })

    # Retrieve gene settings always to calculate lagged relationships.
    geneSettings <- simulation@simSettings$geneProfiles[["SimRNAseq"]]


    filter_valid_effect <- function(df) {
        filtered_settings <- df %>%
            dplyr::filter_at(dplyr::vars(dplyr::starts_with("Effect")),
                             dplyr::any_vars(! is.na(.)))

        return(filtered_settings)
    }

    # Remove & rename effects from data frames
    replace_effect_filter <- function(df) {
        df <- dplyr::mutate_at(df, dplyr::vars(dplyr::starts_with("Effect.Group")),
                               list(~gsub("enhancer", "activator", .)))

        if (all(c("Group1", "Effect") %in% colnames(df))) {

            propagate_profile <- function(group_values, effects) {
                with_effect <- ! is.na(effects)

                if (any(with_effect)) {
                    # Everything with an effect should be the same
                    return(group_values[with_effect][1])
                }

                return(group_values)
            }

            add_lagged_info <- function(pipedDF) {

                replaceTmax <- function(col, fullDF) {
                    groupName <- gsub("Tmax.", "", deparse(substitute(col)))
                    profilePatterns <- fullDF %>% dplyr::pull(groupName)

                    return(ifelse(grepl("transitory", profilePatterns), col, NA))
                }

                # Replace Tmax with NA when flat profile
                pipedDF <- pipedDF %>% dplyr::mutate_at(dplyr::vars(dplyr::starts_with("Tmax.Group")), replaceTmax, pipedDF)

                mergedDF <- pipedDF %>% dplyr::left_join(geneSettings,
                                                         suffix = c(".x", ".y"), by = c("Gene" = "ID"))

                for (groupNumber in seq_len(simulation@numberGroups)) {
                    newColName <- paste0("Lagged.Group", groupNumber)

                    regTmaxCol <- rlang::sym(paste0("Tmax.Group", groupNumber, ".x"))
                    geneTmaxCol <- rlang::sym(paste0("Tmax.Group", groupNumber, ".y"))

                    laggedValue <- mergedDF %>%
                        dplyr::mutate(Lagged = !!(regTmaxCol) != !!(geneTmaxCol)) %>%
                        dplyr::pull(Lagged)

                    pipedDF <- pipedDF %>% dplyr::mutate(!!newColName :=  laggedValue)
                }

                return(pipedDF)
            }

            # Assign the same effect to regulator rows.
            df <- dplyr::group_by(df, ID) %>%
                dplyr::mutate_at(dplyr::vars(dplyr::starts_with("Group")),
                                 list(~propagate_profile(., Effect))) %>%
                dplyr::ungroup() %>%
                add_lagged_info()

            if (! include.lagged) {
                df <- dplyr::mutate(df, IsLagged = purrr::pmap_int(dplyr::select(df, dplyr::starts_with("Lagged.Group")), sum, na.rm=TRUE)) %>%
                    dplyr::filter(IsLagged == FALSE) %>%
                    dplyr::select(-IsLagged, -dplyr::starts_with("Lagged"))
            }

            if (only.linked) {
                df <- filter_valid_effect(df)
            }
        }

        return(df[, colnames(df) != "Effect"])
    }


    # Add the associations
    if (association) {

        regClasses <- omicsClasses[grep("SimRNAseq", omicsClasses, invert = TRUE)]

        associationLists <- setNames(lapply(simulation@simulators[regClasses],
                                   slot, name = "idToGene"), regClasses)

        # Include only those regulators having an effect on genes
        if (only.linked) {
            associationLists <- sapply(names(associationLists), function(x) {
                omic.settings <- filter_valid_effect(selectedSettings[[x]])

                omic.association <- associationLists[[x]] %>%
                    dplyr::filter(ID %in% omic.settings$ID)

                return(omic.association)
            }, simplify = FALSE)
        }

        # Prepend the name of the omic to the regulator ID
        if (prefix) {
            associationLists <- sapply(names(associationLists), function(x) {

                prefix.settings <- associationLists[[x]] %>% dplyr::mutate(ID = paste0(x, ID))

                return(prefix.settings)
            }, simplify = FALSE)
        }

        if (reverse) {
            associationLists <- lapply(associationLists, function(x) if(ncol(x) > 1) x[, c(2,1)] else x)
        }

        # Generate a global table containing the associated regulator per gene and omic
        globalTable <- do.call(rbind, lapply(regClasses, function(x) {
            x.data <- selectedSettings[[x]]
            x.settings <- outputList[[omics[[x]]]]

            # Select only the effect
            x.settings <- dplyr::filter(x.settings, !is.na(Effect)) %>%
                dplyr::select(ID, dplyr::starts_with("Group")) %>%
                dplyr::distinct()

            output.df <- dplyr::select(x.data, Gene, ID, Effect, dplyr::starts_with("Effect.Group"), dplyr::starts_with("Tmax.Group")) %>%
                dplyr::mutate(Omic = x) %>% dplyr::left_join(x.settings, by = c("ID" = "ID")) %>%
                dplyr::mutate_at(dplyr::vars(dplyr::starts_with("Group")), list(~ifelse(is.na(.), "flat", .)))

            if (only.linked) {
                linked.IDs <- dplyr::filter_at(output.df, dplyr::vars(dplyr::starts_with("Effect")), dplyr::any_vars(! is.na(.)))$ID

                output.df <- dplyr::filter(output.df, ID %in% linked.IDs)
            }

            return(output.df)
        }))

        # Restore correct names
        associationLists <- setNames(associationLists, names(omicsClasses)[match(names(associationLists), omicsClasses)])

        outputList <- list(
            "association" = associationLists,
            "settings" = sapply(outputList, replace_effect_filter, simplify = FALSE, USE.NAMES = TRUE),
            "regulators" = replace_effect_filter(globalTable)
        )
    } else {
        # Replace effects on settings
        outputList <- sapply(outputList, replace_effect_filter, simplify = FALSE, USE.NAMES = TRUE)
    }

    ## Filter out regulators not linked to a gene
    # This function is passed to purr and run on all regulatory omics
    #filter_reg_nogene <- function(vec){
    #  if("Gene" %in% colnames(vec))
    #  {vec %>% tidyr::drop_na("Gene")} else {vec}
    #}

    ## When returning the settings, removing rows where gene is NA


    if (length(omics) > 1 || length(outputList) > 1) {
        #return (purrr::map(outputList, filter_reg_nogene))
        return(outputList)
    } else {
        return(outputList[[unlist(omics)]])
    }
}

#' Retrieves the simulated data.
#'
#' @param simulation A MOSimulation object.
#' @param omics List of the omics to retrieve the simulated data.
#' @param format Type of object to use for returning the results
#'
#' @return A list containing an element for every omic specifiec, with the
#'   simulation data in the format indicated, or a numeric matrix with simulated
#'   data if the omic name is directly provided.
#' @export
#'
#' @examples
#'
#' omic_list <- c("RNA-seq")
#' rnaseq_simulation <- mosim(omics = omic_list)
#' #' # This will be a data frame with RNA-seq counts
#' rnaseq_simulated <- omicResults(rnaseq_simulation, "RNA-seq")
#'
#' #                    Group1.Time0.Rep1 Group1.Time0.Rep2 Group1.Time0.Rep3 ...
#' # ENSMUSG00000073155              4539              5374              5808 ...
#' # ENSMUSG00000026251                 0                 0                 0 ...
#' # ENSMUSG00000040472              2742              2714              2912 ...
#' # ENSMUSG00000021598              5256              4640              5130 ...
#' # ENSMUSG00000032348               421               348               492 ...
#' # ENSMUSG00000097226                16                14                 9 ...
#' # ENSMUSG00000027857                 0                 0                 0 ...
#' # ENSMUSG00000032081                 1                 0                 0 ...
#' # ENSMUSG00000097164               794               822               965 ...
#' # ENSMUSG00000097871                 0                 0                 0 ...
#'
omicResults <- function(simulation, omics = NULL, format = "data.frame") {
    # Select all omics by default
    if (is.null(omics)) {
        omics <- lapply(simulation@simulators, slot, name = "name")
    }
    
    ## If TFtoGene true, add TF to the list of dataframes to return
    if (! is.null(simulation@TFtoGene)){
        omics <- append(omics, "TF")
    }
    # Convert the name to the proper class name
    omicsClasses <- paste0("Sim", gsub("-", "", omics))

    selectedSimulators <- lapply(simulation@simulators[omicsClasses], slot, name = "simData")

    formatedSimulators <- lapply(selectedSimulators, function (simuData) {
        formatedData <- switch(
            format,
            "data.frame" = data.frame(simuData, stringsAsFactors = FALSE),
            "ExpressionSet" = Biobase::ExpressionSet(assayData = simuData)
        )

        return(formatedData)
    })

    outputList <- setNames(formatedSimulators, omics)

    if (length(omics) > 1) {
        return(outputList)
    } else {
        return(outputList[[omics]])
    }
    # Remove TF from omics to go back to previous configuration
    if (! is.null(simulation@TFtoGene)){
      omics[! omics == "TF"]
    }
}

#' Retrieves the experimental design
#'
#' @param simulation A MOSimulation object
#'
#' @return A data frame containing the experimental design used to simulate the
#'   data.
#' @export
#'
#' @examples
#'
#' omic_list <- c("RNA-seq")
#' rnaseq_simulation <- mosim(omics = omic_list)
#' # This will be a data frame with RNA-seq counts
#'
#' design_matrix <- experimentalDesign(rnaseq_simulation)
#'
experimentalDesign <- function(simulation) {
    sampleNames <- colnames(simulation@simulators$SimRNAseq@simData)

    outputDF <- data.frame(
        Group = gsub("Group([0-9]+)\\..*", "\\1", sampleNames),
        Time = as.numeric(gsub(".*Time([0-9]+)\\..*", "\\1", sampleNames)),
        Rep = gsub(".*Rep([0-9]+)", "\\1", sampleNames),
        row.names = sampleNames
    )

    outputDF$Condition <- paste(outputDF$Group, outputDF$Time, sep = ".")

    return(outputDF)
}

#' Generate a plot of a feature's profile for one or two omics.
#'
#' @param simulation A MOSimulation object
#' @param omics Character vector of the omics to simulate.
#' @param featureIDS List containing the feature to show per omic. Must have the
#'   omics as the list names and the features as values.
#' @param drawReps Logical to enable/disable the representation of the
#'   replicates inside the plot.
#' @param groups  Character vector indicating the groups to plot in the form
#'   "GroupX" (i.e. Group1)
#'
#' @return A ggplot2 object.
#' @export
#'
#' @examples
#' omic_list <- c("RNA-seq", "miRNA-seq")
#' 
#' rnaseq_options <- c(omicSim("miRNA-seq", totalFeatures = 2500))
#' rnaseq_simulation <- mosim(omics = omic_list,
#'                            omicsOptions = rnaseq_options)
#'
#' #plotProfile(rnaseq_simulation,
#' #     omics = c("RNA-seq", "miRNA-seq"),
#' #   featureIDS = list("RNA-seq"="ENSMUSG00000007682", "miRNA-seq"="mmu-miR-320-3p")
#' #)
#'
plotProfile <-
    function(simulation,
             omics,
             featureIDS,
             drawReps = FALSE,
             groups = NULL) {

    numberOfReps <- simulation@numberReps

    if (is.null(groups)) {
        groups <- paste0("Group", seq_len(simulation@numberGroups))
    }

    calculateRowMeans <- function(colPattern, df, sd = FALSE) {

        colName <- gsub(".Rep", "", colPattern)

        if (! sd) {
            output <- as.data.frame(df) %>%
                dplyr::mutate(!!colName := purrr::pmap_dbl(dplyr::select(., dplyr::contains(colPattern)),
                                                           function(...) mean(c(...)))) %>%
                dplyr::select(colName)
        } else {
            meanCol <- rlang::sym(paste0(colName, ".Mean"))
            seCol <- rlang::sym(paste0(colName, ".SE"))
            sdCol <- rlang::sym(paste0(colName, ".SD"))

            std <- function(x) sd(x)/sqrt(length(x))

            output <- as.data.frame(df) %>%
                dplyr::mutate(!!meanCol := purrr::pmap_dbl(dplyr::select(., dplyr::contains(colPattern)),
                                                           function(...) mean(c(...))),
                              !!seCol := purrr::pmap_dbl(dplyr::select(., dplyr::contains(colPattern)),
                                                         function(...) std(c(...))),
                              !!sdCol := purrr::pmap_dbl(dplyr::select(., dplyr::contains(colPattern)),
                                                         function(...) sd(c(...)))) %>%
                dplyr::select(!!meanCol, !!seCol, !!sdCol)
        }
        rownames(output) <- rownames(df)

        return(output)
    }

    calculateRepMeans <- function(omicDF) {
        column_names_simu <- unique(stringr::str_extract(colnames(omicDF), "Group[0-9]+\\.Time[0-9]+\\.Rep"))
        data_means_simu <- do.call(cbind, lapply(column_names_simu, calculateRowMeans, omicDF, sd = TRUE))

        return(data_means_simu)
    }

    getOmicFeaturesDF <- function(omicName, feature) {
        simuData <- omicResults(simulation, omicName)
        simuSettings <- omicSettings(simulation, omicName)

        groupColRegex <- paste0(paste(paste0(groups, "\\."), collapse="|"), ".*")

        simuData <- dplyr::select(simuData, dplyr::matches(groupColRegex))

        if (! feature %in% simuSettings$ID) {
            stop(sprintf("Feature %s does not exists for omic %s.", feature, omicName))
        }

        featureData <- simuData[feature, , drop=FALSE]

        timeProfile <- dplyr::filter(simuSettings, ID == feature) %>%
                dplyr::select(dplyr::starts_with("Group")) %>%
                tidyr::unite("Profile") %>%
                dplyr::pull(Profile) %>%
                unique()

        featureMeansSE <- calculateRepMeans(featureData)

        yRange <-  range(featureData)

        timeProfiles <- unique(gsub(".*(Time[0-9]+).*", "\\1", colnames(featureData)))

        outputDF <- rbind(data.frame(), featureMeansSE %>%
                              tibble::rownames_to_column("ID") %>%
                              tidyr::gather(key = "Time", value = "Counts", -c(ID)) %>%
                              tidyr::extract(Time, c("Group", "Point", "Measure"), "(.*)\\.(Time[0-9]+)\\.(.*)") %>%
                              tidyr::spread(Measure, Counts) %>%
                              dplyr::mutate(Point = factor(Point, levels = unique(timeProfiles), ordered = TRUE)) %>%
                              dplyr::mutate(Omic = as.factor(omicName))) %>%
                              dplyr::mutate(Rep = "Mean") %>%
                              dplyr::mutate(Point = factor(Point, levels = unique(timeProfiles), ordered = TRUE))

        # if(drawReps) {
        #     repDF <- tibble::rownames_to_column(data.frame(featureData)) %>%
        #         tidyr::gather(key = .data$Time, value = .data$Mean, -c(.data$rowname)) %>%
        #         tidyr::extract(.data$Time, c("Group", "Point", "Rep"), "(.*)\\.(Time[0-9]+)\\.(.*)") %>%
        #         dplyr::mutate(SD = 0, SE = 0, Profile = .data$timeProfile, Point = factor(.data$Point, levels = unique(.data$timeProfiles), ordered = TRUE), Omic = as.factor(.data$omicName)) %>%
        #         dplyr::rename(ID = .data$rowname)
        #
        #     outputDF <- outputDF %>% dplyr::bind_rows(repDF)
        # }

        return(outputDF)
    }


    if (length(omics) > 1) {
        # Currently limited to 2 omics
        omicNames <- utils::head(intersect(omics, names(featureIDS)), 2)

        omicsDF <- sapply(omicNames, function(omicName) {
            # Only 1 feature per omic
            omicFeature <- utils::head(featureIDS[[omicName]], 1)

            omicDF <- getOmicFeaturesDF(omicName, omicFeature)

            return(omicDF)
        }, simplify = FALSE, USE.NAMES = TRUE)

        featureIDS <- featureIDS[omicNames]

        # Reorder keeping the bigger in the first position
        omicsDF <- omicsDF[order(unlist(lapply(omicsDF, function(df) max(df$Mean))), decreasing = TRUE)]
        primaryDF <- omicsDF[[1]]

        # Scale range based on the total mean plus/minus SE
        scaleValues <- range(c(primaryDF$Mean + primaryDF$SE,
                               primaryDF$Mean - primaryDF$SE))

        omicsDF <- sapply(omicsDF, function(omicDF) {

            meanSE.scaled <- scales::rescale(c(omicDF$Mean,
                        omicDF$Mean + omicDF$SE,
                        omicDF$Mean - omicDF$SE),
                        scaleValues)

            outDF <- omicDF %>%
                dplyr::mutate(ScaledMean = utils::head(meanSE.scaled, nrow(omicDF)),
                              ScaledSE = (ScaledMean*SE)/Mean)

            return(outDF)
        }, simplify = FALSE, USE.NAMES = TRUE)

    } else {
        featureIDS <- setNames(utils::head(unlist(featureIDS), 1), omics)
        omicNames <- omics
        omicsDF <- list(getOmicFeaturesDF(omics, featureIDS))
    }

    primaryDF <- omicsDF[[1]]
    primaryOmic <- omicNames[[1]]

    if (drawReps) {
        outputGgplot <- ggplot2::ggplot(data=primaryDF,
                                        ggplot2::aes(x=Point, y=Mean, group=Rep, color=Rep))
    } else {
        outputGgplot <- ggplot2::ggplot(data=primaryDF,
                                        ggplot2::aes(x=Point, y=Mean, group=Omic, color=Omic))
    }

    outputGgplot <- outputGgplot +
        ggplot2::geom_errorbar(ggplot2::aes(ymin=Mean-SE, ymax=Mean+SE), width=.1) +
        ggplot2::geom_line() +  ggplot2::geom_point()

    plotTitle <- featureIDS[[primaryOmic]]

    if (length(omics) > 1) {
        secondaryDF <- omicsDF[[2]]
        secondaryOmic <- omicNames[[2]]

        absoluteRange <- range(c(secondaryDF$Mean + secondaryDF$SE,
                                 secondaryDF$Mean - secondaryDF$SE))

        outputGgplot <- outputGgplot +
            ggplot2::geom_line(data = secondaryDF, ggplot2::aes(x = Point, y = ScaledMean, group = Omic)) +
            ggplot2::scale_y_continuous(limits = scaleValues, sec.axis = ggplot2::sec_axis(~scales::rescale(., absoluteRange), name = featureIDS[[secondaryOmic]])) +
            ggplot2::geom_errorbar(data = secondaryDF, ggplot2::aes(ymin=ScaledMean-ScaledSE, ymax=ScaledMean+ScaledSE), width=.1) +
            ggplot2::geom_point(data = secondaryDF, ggplot2::aes(y = ScaledMean)) +
            ggplot2::labs(color = "Omic")

        plotTitle <- paste0(plotTitle, ' - ', featureIDS[[secondaryOmic]])
    }

    outputGgplot <- outputGgplot +
        ggplot2::ggtitle(plotTitle) +
        ggplot2::ylab(featureIDS[[primaryOmic]]) +
        ggplot2::xlab("Time point") +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45, hjust = 1)) +
        ggplot2::facet_grid(. ~ Group)

    return(outputGgplot)
    }


#' Discretize ChIP-Seq counts to simulate a binary dataset
#'
#' @param df A MOSimulated object
#' @param omic Character string of the omic to transform into binary data
#'
#' @return A regulator dataframe of 0 and 1
#' @export
#'
#' @examples
#' omic_list <- c("RNA-seq", "ChIP-seq")
#' rnaseq_simulation <- mosim(omics = omic_list, 
#'     omicsOptions = c(omicSim("ChIP-seq", totalFeatures = 2500)))
#' rnaseq_simulated <- omicResults(rnaseq_simulation, omic_list)
#' discrete_ChIP <- discretize(rnaseq_simulated, "ChIP-seq")
#' 
discretize <- function(df, omic) {
  # Extract omic data from a simulated dataset
  df <- df[[omic]]
  ## Transform into relative percentages per sample (sum of column is 1)
  df <- df/colSums(df)
  ## And now per gene
  df <- df/rowSums(df)
  # Threshold is the relative abundance if the genes are the same in the samples
  threshold <- 1/length(colnames(df))
  # If below the threshold, 0, if above 1
  for (i in 1:ncol(df)) {
    df[,i] <- ifelse(df[,i] < threshold, 0, 1)
  }
  return(df)
}


#' Default data
#'
#' Dataset with base counts and id-gene tables.
#'
#' @details List with 6 elements:
#' \describe{
#'   \item{SimRNAseq}{\describe{
#'   \item{data}{Dataframe with base counts with gene id as rownames.}
#'   \item{geneLength}{Length of every gene.}}}
#'   \item{SimChIPseq}{\describe{
#'   \item{data}{Dataframe with base counts with regions as rownames.}
#'   \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
#'   \item{SimDNaseseq}{\describe{
#'   \item{data}{Dataframe with base counts with regions as rownames.}
#'   \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
#'   \item{SimMiRNAseq}{\describe{
#'   \item{data}{Dataframe with base counts with miRNA id as rownames.}
#'   \item{idToGene}{Dataframe with miRNA as "ID" column and gene name on "Gene" column.}}}
#'   \item{SimMethylseq}{\describe{
#'   \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
#'   \item{CpGisland}{Dataframe of CpG to be used as initialization data, located on "Region" column}
#' }
#' @usage data("sampleData")
"sampleData"

test_that("profileprobs settings", {

    no_induction <- list(
        continuous.induction = 0,
        continuous.repression = .2,
        transitory.induction = 0,
        transitory.repression = .2,
        flat = .2
    )

    sim_no_induction <- mosim(omics = "RNA-seq", omicsOptions = list(
        "RNA-seq"=list(totalFeatures=300)), profileProbs = no_induction)

    # Check the presence of induction profiles in settings
    expression_profiles <- sim_no_induction@simSettings$geneProfiles$SimRNAseq

    if (any(grepl("induction", expression_profiles$Group1),
            grepl("induction", expression_profiles$Group2)))
        fail("detected invalid expression profiles")

    succeed()
})

context("Convenience functions")

# Test for convenience user functions
data(sampleData)

# Test data
# Select the first 10 rows
test_data_rna <- head(sampleData$SimRNAseq$data, 10)
test_data_dnase <- head(sampleData$SimDNaseseq$data, 10)
test_assoc_dnase <- dplyr::filter(sampleData$SimDNaseseq$idToGene,
                                  ID %in% rownames(test_data_dnase))

test_that("omicData with custom data", {
    expect_is(omicData("RNA-seq", data = test_data_rna), "SimRNAseq")
    expect_is(omicData("DNase-seq", data = test_data_dnase, associationList = test_assoc_dnase), "SimDNaseseq")
    expect_error(omicData("DNase-seq", data = test_data_dnase, associationList = NULL))
})

test_that("omicSim with multiple omics", {
    expect_named(omicSim("RNA-seq", totalFeatures = 20, depth = 15), "RNA-seq")
    expect_named(omicSim("DNase-seq", totalFeatures = 20, depth = 15), "DNase-seq")
})


test_that("mosim with custom data", {

    paramsRNAseq <- omicSim("RNA-seq", totalFeatures = 20, depth = 15)
    paramsDNaseseq <- omicSim("DNase-seq", totalFeatures = 20, depth = 15)

    mosim(
        omics = c("RNA-seq", "DNase-seq"),

        omicsOptions = c(paramsRNAseq, paramsDNaseseq),

        numberGroups = 2,
        times = c(1, 3, 7),
        numberReps = 3
    )

})

#' @include Simulator.R
NULL

setMethod("initialize", signature="MOSimulatorRegion", function(.Object, ...) {
    .Object <- callNextMethod(.Object, ...)

    message("Configuring simulator ", .Object@name)

    # Split rownames using an specified character, with the convention:
    # chr_start_end
    splitRegions <- function(rLocs) {
        rLocs <- unique(rLocs)

        rData <- strsplit(rLocs, .Object@splitChar)

        rData <- matrix(unlist(rData), ncol = length(rData[[1]]), byrow = TRUE)

        return(data.frame(
            chr = rData[, 1],
            start = as.numeric(rData[, 2]),
            end = as.numeric(rData[, ncol(rData)]),
            ID = rLocs # Keep the rownames as a column for easier joins
        , row.names = rLocs, stringsAsFactors = FALSE))
    }

    # Check rownames format
    if (is.declared(.Object@data)) {

        rLocs <- rownames(.Object@data)

        # If not null, the rownames must follow the scheme:
        # chr_start_<end>
        #
        # Being end optional when there's no associated range, only the
        # location of 1 pb.
        if (is.null(rLocs))
            stop("Rownames on data are required on simulators with region names.")

        .Object@locs <- splitRegions(rLocs)
    } else if (is.declared(.Object@locs)) {

        if (! is.data.frame(.Object@locs)) {
            .Object@locs <- splitRegions(.Object@locs)
        }
    } else if (is.declared(.Object@idToGene)) {
        rLocs <- .Object@idToGene$ID

        # If not null, the rownames must follow the scheme:
        # chr_start_<end>
        #
        # Being end optional when there's no associated range, only the
        # location of 1 pb.
        if (is.null(rLocs))
            stop("Rownames on data are required on simulators with region names.")

        .Object@locs <- splitRegions(rLocs)
    } else {
        stop("No regions provided.")

        # .Object@chGRanges <- list(NULL)
        # .Object@locs <- NULL
    }

    return(.Object)
})

# setValidity("SimulatorRegion", function(object) {
#     return(getValidity(getClassDef("MOSimulator"))(object))
# })


# .SimulatorRegion.regionNames <- function(object, chrNumber, start, end=NULL) {
#     end <- if(is.null(end)) start else end
#
#     paste(chrNumber, start, end, sep="_")
# }

# .SimulatorRegion.getLengths <- function(object) {
#     width(object@locs)
# }


# setMethod("regionNames", signature="SimulatorRegion", .SimulatorRegion.regionNames)
# setMethod("locGRanges", signature="SimulatorRegion", .SimulatorRegion.locGRanges)
# setMethod("nearestGenes", signature="SimulatorRegion", .SimulatorRegion.nearestGenes)
# setMethod("getLengths", signature="SimulatorRegion", .SimulatorRegion.getLengths)

## ----figure1, echo=FALSE, eval=TRUE, warning=FALSE----------------------------
library(ggplot2)
library(gridExtra)

# Define the data for lines
line_data <- data.frame(
  x = c(5, 5, 5, 5, 5),
  xend = c(6, 6, 6, 5.5, 5.5),
  y = c(0, -1.8, -2.7, -4.8, -5.7),
  yend = c(0, -1.2, -3.3, -4.2, -6.3),
  curve = c(FALSE, FALSE, FALSE, TRUE, TRUE)
)

# Create plot
p <- ggplot() +
  geom_segment(data = subset(line_data, !curve),
               aes(x = x, y = y, xend = xend, yend = yend),
               color = "red", size = 1) +
  geom_curve(data = subset(line_data, curve),
             aes(x = x, y = y, xend = xend, yend = yend),
             curvature = 0.5, color = "red", size = 1) +
  annotate("text", x = 0, y = 0, label = "Flat", hjust = 0) +
  annotate("text", x = 0, y = -1.5, label = "Continuous induction (CI)", hjust = 0) +
  annotate("text", x = 0, y = -2.7, label = "Continuous repression (CR)", hjust = 0) +
  annotate("text", x = 0, y = -4.8, label = "Transitory induction (TI)", hjust = 0) +
  annotate("text", x = 0, y = -5.7, label = "Transitory repression (TR)", hjust = 0) +
  theme_void()

# Display the figure
grid.arrange(p)

## ----code, echo=TRUE, eval=FALSE----------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("MOSim")

## ----code1, echo=TRUE, eval=FALSE---------------------------------------------
# library(devtools)
# 
# devtools::install_github("ConesaLab/MOSim")

## ----load, echo=FALSE, eval=TRUE, include=TRUE--------------------------------
library(MOSim)

## ----code2, echo=TRUE, eval=TRUE----------------------------------------------
library(MOSim)

omic_list <- c("RNA-seq")

rnaseq_simulation <- mosim(omics = omic_list)

## ----code3, echo=TRUE, eval=TRUE, include=TRUE--------------------------------
rnaseq_simulation <- mosim(omics = c("RNA-seq"),
                           times = 0,
                           numberGroups = 2,
                           numberReps = 4)

## ----code4, echo=TRUE, eval=FALSE, include=TRUE, error=TRUE-------------------
try({
# rnaseq_simulation <- mosim(omics = c("RNA-seq"),
#                            times = 0,
#                            numberGroups = 1,
#                            numberReps = 4)
})

## ----code5, echo=TRUE, eval=FALSE, include=TRUE-------------------------------
# multi_simulation <- mosim(omics = c("RNA-seq", "DNase-seq"),
#                           times = c(0, 5, 10),
#                           numberGroups = 2,
#                           numberReps = 4,
#                           diffGenes = .3)
# 
# dnase_simulation <- mosim(omics = c("DNase-seq"),
#                           times = c(0, 5, 10),
#                           numberGroups = 2,
#                           numberReps = 4,
#                           diffGenes = .3)

## ----code6, echo=TRUE, eval=TRUE,cache=TRUE, tidy=FALSE, results='hide', message=FALSE----
# Take a subset of the included dataset for illustration
# purposes. We could also load it from a csv file or RData,
# as long as we transform it to have 1 column named "Counts"
# and the identifiers as row names.
data("sampleData")

custom_rnaseq <- head(sampleData$SimRNAseq$data, 100)

# In this case, 'custom_rnaseq' is a data frame with
# the structure:
head(custom_rnaseq)
##                    Counts
## ENSMUSG00000000001   6572
## ENSMUSG00000000003      0
## ENSMUSG00000000028   4644
## ENSMUSG00000000031      8
## ENSMUSG00000000037      0
## ENSMUSG00000000049      0


# The helper 'omicData' returns an object with our custom data.
rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)

# We use the associative list of 'omics' parameter to pass
# the RNA-seq object.
rnaseq_simulation <- mosim(omics = list("RNA-seq" = rnaseq_customdata))

## ----code7, echo=TRUE, eval=TRUE, tidy=FALSE, include=TRUE, results='hide', message=FALSE----
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_dnaseseq <- head(sampleData$SimDNaseseq$data, 100)

# Retrieve a subset of the default association list.
dnase_genes <- sampleData$SimDNaseseq$idToGene
dnase_genes <- dnase_genes[dnase_genes$ID %in%
                               rownames(custom_dnaseseq), ]

# In this case, 'custom_dnaseseq' is a data frame with
# the structure:
head(custom_dnaseseq)
##                       Counts
## 1_63176480_63177113      513
## 1_125435495_125436168   1058
## 1_128319376_128319506     37
## 1_139067124_139067654    235
## 1_152305595_152305752    105
## 1_172490322_172490824    290

# The association list 'dnase_genes' is another data frame
# with the structure:
head(dnase_genes)
##                      ID               Gene
## 29195 1_3670777_3670902 ENSMUSG00000051951
## 29196 1_3873195_3873351 ENSMUSG00000089420
## 29197 1_4332428_4332928 ENSMUSG00000025900
## 29198 1_4346315_4346445 ENSMUSG00000025900
## 29199 1_4416827_4416973 ENSMUSG00000025900
## 29200 1_4516660_4516798 ENSMUSG00000096126

dnaseseq_customdata <- omicData("DNase-seq",
                                data = custom_dnaseseq,
                                associationList = dnase_genes)

multi_simulation <- mosim(omics = list(
    "RNA-seq" = rnaseq_customdata,
    "DNase-seq" = dnaseseq_customdata)
    )

## ----code8, echo=TRUE, eval=TRUE, tidy=FALSE, include = TRUE, results='hide', message=FALSE----
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_tf <- head(sampleData$SimRNAseq$TFtoGene, 100)
#      TF             TFgene         LinkedGene
# 1  Aebp2 ENSMUSG00000030232 ENSMUSG00000000711
# 2  Aebp2 ENSMUSG00000030232 ENSMUSG00000001157
# 3  Aebp2 ENSMUSG00000030232 ENSMUSG00000001211
# 4  Aebp2 ENSMUSG00000030232 ENSMUSG00000001227
# 5  Aebp2 ENSMUSG00000030232 ENSMUSG00000001305
# 6  Aebp2 ENSMUSG00000030232 ENSMUSG00000001794

multi_simulation <- mosim(omics = list(
    "RNA-seq" = rnaseq_customdata,
    "DNase-seq" = dnaseseq_customdata),
    # The option is passed directly to mosim function instead of
    # being an element inside "omics" parameter.
    TFtoGene = custom_tf
    )

## ----code9, echo=TRUE, eval=TRUE, tidy=FALSE, results='hide', message=FALSE----
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_cpgs <- head(sampleData$SimMethylseq$idToGene, 100)

# The ID column will be splitted using the "_" char
# assuming <chr>_<start>_<end>.
#
# These positions will be considered as CpG sites
# and used to generate CpG islands and other elements.
#
# Please refer to MOSim paper for more information.
#
#                    ID               Gene
# 1  11_3101154_3101154 ENSMUSG00000082286
# 2  11_3101170_3101170 ENSMUSG00000082286
# 3  11_3101229_3101229 ENSMUSG00000082286
# 4  11_3101287_3101287 ENSMUSG00000082286
# 5  11_3101329_3101329 ENSMUSG00000082286
# 6  11_3101404_3101404 ENSMUSG00000082286

## ----code10, echo=TRUE, eval=FALSE, tidy = FALSE, results='hide', message=FALSE----
# omic_list <- c("RNA-seq")
# 
# rnaseq_options <- omicSim("RNA-seq", totalFeatures = 2500)
# 
# # The return value is an associative list compatible with
# # 'omicsOptions'
# rnaseq_simulation <- mosim(omics = omic_list,
#                            omicsOptions = rnaseq_options)

## ----code11, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE----
omics_list <- c("RNA-seq", "DNase-seq")

# In R concatenaning two lists creates another one merging
# its elements, we use that for 'omicsOptions' parameter.
omics_options <- c(omicSim("RNA-seq", totalFeatures = 2500, depth = 74),
                   omicSim("DNase-seq",
                           # Limit the number of features to simulate
                           totalFeatures = 1500,
                           # Modify the percentage of regulators with effects.
                           regulatorEffect = list(
                                'activator' = 0.68,
                                'repressor' = 0.3,
                                'NE' = 0.02
                            )))

set.seed(12345)

multi_simulation <- mosim(omics = omics_list,
                          omicsOptions = omics_options)

## ----code12, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE----
rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)
rnaseq_options <- omicSim("RNA-seq", totalFeatures = 100)

rnaseq_simulation <- mosim(omics = list("RNA-seq" = rnaseq_customdata),
                           omicsOptions = rnaseq_options)

## ----code13, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE----
# This will be a data frame with RNA-seq settings (DE flag, profiles)
rnaseq_settings <- omicSettings(multi_simulation, "RNA-seq")

# This will be a list containing all the simulated omics (RNA-seq
# and DNase-seq in this case)
all_settings <- omicSettings(multi_simulation)

## ----table1, echo = FALSE, eval = TRUE, warning = FALSE-----------------------
# Create the data frame
df <- data.frame(
  ID = c("ENSMUSG00000017204", "ENSMUSG00000097082", "ENSMUSG00000055493", 
         "ENSMUSG00000017221", "ENSMUSG00000020205", "ENSMUSG00000087802"),
  DE = c(TRUE, TRUE, TRUE, TRUE, TRUE, FALSE),
  Group1 = c("transitory.induction", "transitory.induction", "transitory.induction", 
             "transitory.induction", "transitory.induction", "flat"),
  Group2 = c("continuous.repression", "transitory.induction", "continuous.repression", 
             "continuous.induction", "continuous.induction", "flat"),
  Tmax_Group1 = c(2.57, 1.46, 2.37, 2.63, 2.83, NA),
  Tmax_Group2 = c(NA, 2.23, NA, NA, NA, NA)
)

# Generate the table
print(df, row.names = FALSE)

## ----table2, echo = FALSE, eval = TRUE, warning = FALSE-----------------------
df <- data.frame(
  ID = c("10_111588324_111588448", "10_111588324_111588448", 
         "10_11358301_11358431", "10_11358301_11358431", 
         "11_98682094_98682786", "11_98682094_98682786"),
  Gene = c("ENSMUSG00000097082", "ENSMUSG00000020205", 
           "ENSMUSG00000055493", "ENSMUSG00000087802", 
           "ENSMUSG00000017204", "ENSMUSG00000017221"),
  Effect_Group1 = c("activator", "activator", "activator", "NA", "repressor", "repressor"),
  Effect_Group2 = c("activator", "NA", "activator", "NA", "activator", "repressor"),
  Group1 = c("transitory.induction", "transitory.induction", 
             "transitory.induction", "transitory.induction", 
             "transitory.repression", "transitory.repression"),
  Group2 = c("transitory.induction", "transitory.induction", 
             "continuous.repression", "continuous.repression", 
             "continuous.repression", "continuous.repression"),
  Extra = rep("...", 6) # Placeholder for extra columns
)

# Print the table in a readable format
print(df, row.names = FALSE)

## ----code14, echo=TRUE, eval=TRUE, tidy=FALSE, results='hide', message=FALSE----
# This will be a list with 3 keys: settings, association and regulators
dnase_settings <- omicSettings(multi_simulation, "DNase-seq",
                               association = TRUE)

## ----code15, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE----
# multi_simulation is an object returned by mosim function.

# This will be a data frame with RNA-seq counts
rnaseq_simulated <- omicResults(multi_simulation, "RNA-seq")

#                    Group1.Time0.Rep1 Group1.Time0.Rep2 Group1.Time0.Rep3 ...
# ENSMUSG00000073155              4539              5374              5808 ...
# ENSMUSG00000026251                 0                 0                 0 ...
# ENSMUSG00000040472              2742              2714              2912 ...
# ENSMUSG00000021598              5256              4640              5130 ...
# ENSMUSG00000032348               421               348               492 ...
# ENSMUSG00000097226                16                14                 9 ...
# ENSMUSG00000027857                 0                 0                 0 ...
# ENSMUSG00000032081                 1                 0                 0 ...
# ENSMUSG00000097164               794               822               965 ...
# ENSMUSG00000097871                 0                 0                 0 ...

# This will be a list containing RNA-seq and DNase-seq counts
all_simulated <- omicResults(multi_simulation)

## ----code16, echo=TRUE, eval=TRUE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE----
# Generate a simulation object
omic_list <- c("RNA-seq")
rnaseq_simulation <- mosim(omics = omic_list)

# This will be a data frame with RNA-seq counts
design_matrix <- experimentalDesign(rnaseq_simulation)
design_matrix

## ----code17, echo=TRUE, eval=FALSE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE----
# 
# # The methods returns a ggplot plot, if called directly
# # it will be automatically plotted.
# plotProfile(multi_simulation,
#             omics = c("RNA-seq", "DNase-seq"),
#             featureIDS = list(
#                 "RNA-seq" = "ENSMUSG00000024691",
#                 "DNase-seq" = "19_12574278_12574408"
#             ))

## ----code18, echo=TRUE, eval=FALSE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE----
# library(ggplot2)
# 
# # Store the plot in a variable
# profile_plot <- plotProfile(multi_simulation,
#             omics = c("RNA-seq", "DNase-seq"),
#             featureIDS = list(
#                 "RNA-seq" = "ENSMUSG00000024691",
#                 "DNase-seq" = "19_12574278_12574408"
#             ))
# 
# # Modify the title and print
# profile_plot +
#     ggtitle("My custom title") +
#     theme_bw() +
#     theme(legend.position="top")

## ----code19, echo=TRUE, eval=TRUE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE----
rnaseq_simulation <- mosim(omics = c("RNA-seq", "ChIP-seq"))
rnaseq_simulated <- omicResults(rnaseq_simulation, c("RNA-seq", "ChIP-seq"))
discrete_ChIP <- discretize(rnaseq_simulated, "ChIP-seq")

#' @import dplyr
#' @import Seurat
#' @import Signac
#' @import stringr
NULL

# Avoid harmless note with R CMD check
if(getRversion() >= "2.15.1")  utils::globalVariables(c(".", "n",
                                              "feature", "seurat_annotations"))


#' sc_omicData
#'
#' Checks if the user defined data is in the correct format, or loads the default
#' multiomics pbmc dataset, a subset from SeuratData package
#'
#' @param omics_types A list of strings which can be either "scRNA-seq" or "scATAC-seq"
#' @param data A user input matrix with genes (peaks in case of scATAC-seq) as 
#'    rows and cells as columns. By default, it loads the example data.
#'    If a user input matrix is included, cell columns must be sorted by cell t
#'    ype.
#' @return a named list with omics type as name and the count matrix as value
#' @export
#'
#' @examples
#' # Simulate from PBMC
#' omicsList <- sc_omicData(list("scRNA-seq", "scATAC-seq"))
#'
sc_omicData <- function(omics_types, data = NULL){
  # Check for mandatory parameters
  if (missing(omics_types)){
    stop("You must provide the vector of omics to simulate.")
  }
  
  for (omics in omics_types){
    if (omics != "scRNA-seq" && omics != "scATAC-seq"){
      stop("Omics must be a either 'scRNA-seq' or 'scATAC-seq'")
    }
  }
  
  omics_list <- list()
  # If no data, load default
  if (is.null(data)) {
    cell_types <- list(
      'Treg' = c(1:11),
      'cDC' = c(12:22),
      'CD4_TEM' = c(13:33),
      'Memory_B' = c(14:44)
    )
    message("Loading the default dataset, the cell_types are: 
            list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
      'Memory_B' = c(31:40))")
    for (omics in omics_types){
      if (omics == "scRNA-seq"){
        data_env <- new.env(parent = emptyenv())
        data("scrna", envir = data_env, package = "MOSim")
        counts <- data_env[["scrna"]]
      } else if (omics == "scATAC-seq"){
        data_env <- new.env(parent = emptyenv())
        data("scatac", envir = data_env, package = "MOSim")
        counts <- data_env[["scatac"]]
      }
      omics_list[[omics]] <- counts
    }
    
  } else {
    # If data was inputted by the user, first check
    if (!is.list(data) || length(data) != 1 && length(data) != 2){
      message(paste0("The length of data is ", length(data)))
      stop("Data must be NULL (default) or a list of 1 or 2 elements")
    }
    
    N_data <- length(data)
    for (i in 1:N_data){
      # Then save in a named list
      if (!is.matrix(data[[i]]) && class(data[[i]])[1] != "Assay"){
        stop("Each element of data must be either a matrix or a Seurat object")
      } else if (is.matrix(data[[i]])){
        omics_list[[omics_types[[i]]]] <- data[[i]]
      } else if ("Assay" %in% class(data[[i]]) && omics_types[[i]] == "scRNA-seq"){
        counts <- as.matrix(data[[i]]@counts)
        omics_list[[omics_types[[i]]]] <- counts
      } else if ("Assay" %in% class(data[[i]]) && omics_types[[i]] == "scATAC-seq"){
        counts <- as.matrix(data[[i]]@counts)
        omics_list[[omics_types[[i]]]] <- counts
      }
    }
  }
  return(omics_list)
}
  

#' sc_param_estimation
#'
#' Evaluate the users parameters for single cell simulation and use SPARSim
#' to simulate the main dataset. Internal function
#'
#' @param omics named list containing the omics to simulate as names, which can 
#'    be "scRNA-seq" or "scATAC-seq".
#' @param cellTypes list where the i-th element of the list contains the column 
#'    indices for i-th cell type. List must be a named list.
#' @param diffGenes If number groups > 1, Percentage DE genes to simulate.
#'    List of vectors (one per group to compare to group 1) where the vector
#'    contains absolute number of genes for Up and Down ex: c(250, 500) or a 
#'    percentage for up, down ex: c(0.2, 0.2). The rest will be NE
#' @param minFC Threshold of FC below which are downregulated, by default 0.25
#' @param maxFC Threshold of FC above which are upregulated, by default 4
#' @param numberCells vector of numbers. The numbers correspond to the number 
#'    of cells the user wants to simulate per each cell type. The length of the 
#'       vector must be the same as length of \code{cellTypes}.
#' @param mean vector of numbers of mean depth per each cell type. Must be specified 
#'    just if \code{numberCells} is specified.
#' @param sd vector of numbers of standard deviation per each cell type. Must be 
#'    specified just if \code{numberCells} is specified.
#' @param noiseGroup OPTIONAL. Number indicating the desired standard deviation
#'      between treatment groups
#' @param group Group for which to estimate parameters
#' @param genereggroup List with information of genes, clusters and regulators
#'      that must be related to each other
#' @return a list of Seurat object, one per each omic.
#' @return a named list with simulation parameters for each omics as values.
#' @export
#' @examples
#' omicsList <- sc_omicData(list("scRNA-seq"))
#' cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#' 'Memory_B' = c(31:40))
#' #estimated_params <- sc_param_estimation(omicsList, cell_types)
#' 
sc_param_estimation <- function(omics, cellTypes, diffGenes = list(c(0.2, 0.2)), 
                                minFC = 0.25, maxFC = 4, numberCells = NULL, 
                                mean = NULL, sd = NULL, noiseGroup = 0.5, 
                                group = 1, genereggroup){
  # Check for mandatory parameters
  if (missing(omics)){
    stop("You must provide the vector of omics to simulate.")
  }
  
  if (missing(cellTypes)) {
    stop("You must provide the correspondence of cells and celltypes")
  }
  
  all_missing <- is.null(numberCells) && is.null(mean) && is.null(sd)
  all_specified <- !is.null(numberCells) && !is.null(mean) && !is.null(sd)
  only_cellnum <- !is.null(numberCells) && is.null(mean) && is.null(sd)
  
  if( !(all_missing || all_specified || only_cellnum)){
    
    stop("The user must either not provide the optional arguments, provide them 
         all or only provide cell numbers")
    
  }
  
  N_omics <- length(omics)
  
  ## Make association dataframe
  if (N_omics > 1){
    
    prov <- MOSim::make_association_dataframe(group, genereggroup, 
                                              dim(omics$`scRNA-seq`)[[1]], 
                                              dim(omics$`scATAC-seq`)[[1]],
                                              minFC, maxFC)
    associationMatrix <- prov$associationMatrix
    
    rownames(omics[[1]]) <- prov$dfGeneNames
    rownames(omics[[2]]) <- prov$dfPeakNames
    
    dfGeneNames <- prov$dfGeneNames
    dfPeakNames <- prov$dfPeakNames
    
    ## Also improve the association gene-regulator
    res <- MOSim::match_gene_regulator_cluster(omics[[1]], omics[[2]], cellTypes, associationMatrix)

    omics[[1]] <- res$rna
    omics[[2]] <- res$atac
    
  } else {
    # If only scRNA define the matrix here with the same format
    dfGeneNames <- rownames(omics[[1]])
    dfPeakNames <- NA
    columns <- c("Gene_ID", "Peak_ID", "RegulatorEffect", "Gene_cluster", "Peak_cluster", 
                 "Gene_DE", "Peak_DE")
    
    associationMatrix <- data.frame(matrix(nrow = length(dfGeneNames), ncol = length(columns)))
    colnames(associationMatrix) <- columns
    
    associationMatrix["Gene_ID"] <- dfGeneNames
    associationMatrix["Peak_ID"] <- rep(NA, length(dfGeneNames))
    associationMatrix["RegulatorEffect"] <- rep("NE", length(dfGeneNames))
    clus <- rep(1:length(genereggroup$`Clusters_scRNA-seq`), 
                each = length(genereggroup$`Clusters_scRNA-seq`[[1]]))
    associationMatrix["Gene_cluster"] <- c(clus, rep(0, length(dfGeneNames) - length(clus)))
    associationMatrix["Peak_cluster"] <- rep(NA, length(dfGeneNames))
    associationMatrix["Gene_DE"] <- c(rep("Up", length(genereggroup[[paste0("GeneExtraUp_G", group)]])),
                                      rep("Down", length(genereggroup[[paste0("GeneExtraDown_G", group)]])),
                                      rep("NE", length(dfGeneNames) - length(genereggroup[[paste0("GeneExtraUp_G", group)]]) - length(genereggroup[[paste0("GeneExtraDown_G", group)]])))
    associationMatrix$Gene_FC <- 1
    associationMatrix$Peak_FC <- NA
  }
  
  # Normalize using scran method, we had to suppress warnings because
  # ATAC has too many zeroes for the normalization to be super comfortable
  norm <- function(om) {
    o <- SingleCellExperiment::SingleCellExperiment(assays=list(counts=as.matrix(om)))
    o <- suppressWarnings(scran::computeSumFactors(o, sizes = seq(20, 100, 5),
                                                   positive = FALSE))
    # Apply normalization factors
    o <- scater::normalizeCounts(o, log = FALSE)
    o[is.na(o)] <- 0
    o[!is.finite(o)] <- 0
    o <- abs(o)
    
    return(o)
  }
  
  norm_list <- lapply(omics, norm)
  param_est_list <- list()
  FC_used_list <- list()
  
  if (group > 1){
    # if its from group 2 upwards, we make the differences by multiplying
    # Times a fold change vector, thus we generate it
    FClist <- list()
    VARlist <- list()
    
    #We cant move this out of the function because it takes the variability
    # of the group into account
    for(i in 1:N_omics){
      message(paste0("Estimating distribution from original data type: ", i))
      param_est <- MOSim::sparsim_estimate_parameter_from_data(raw_data = omics[[i]],
                                                               norm_data = norm_list[[i]],
                                                               conditions = cellTypes)
      param_est_list[[paste0("param_est_", names(omics)[i])]] <- param_est
      
      
      #### Make the variability vector
      VARlist[[paste0("Var_", names(omics)[i])]] <- data.frame(matrix(0, 
             ncol = length(colnames(omics[[i]])), nrow = length(rownames(omics[[i]]))))
      var_group <- stats::rnorm(nrow(as.data.frame(omics[[i]])), 0, noiseGroup)
      # Add variability to each omic compared to group 1
      # transform the matrix into TRUE when > 0 false when 0
      sim_trueFalse <- (omics[[i]] > 0)
      # Multiply the variability vector by a 1/0 to keep the zeros.
      for (c in 1:length(colnames(omics[[i]]))){
        sim_trueFalse[, c] <- as.integer(as.logical(sim_trueFalse[,c]))
        omics[[i]][,c] <- omics[[i]][,c] + (sim_trueFalse[, c] * var_group)
        VARlist[[paste0("Var_", names(omics)[i])]][, c] <- (sim_trueFalse[, c] * var_group)
          
      }
      omics[[i]] <- abs(omics[[i]])
      
    }
  } else if (group == 1){
    # If its the first group, we dont need to add FC, so we multiply by one
    # Instead of a fold change vector
    
    for(i in 1:N_omics){
      message(paste0("Estimating distribution from original data type: ", i))
      param_est <- MOSim::sparsim_estimate_parameter_from_data(raw_data = omics[[i]],
                                                               norm_data = norm_list[[i]],
                                                               conditions = cellTypes)
      param_est_list[[paste0("param_est_", names(omics)[i])]] <- param_est
      
    }
    
    FClist <- list()
    VARlist <- list()
    
    for(i in 1:N_omics){
      # Dont add variability for first group
      VARvec <- rep(1, dim(omics[[i]])[[1]])
      VARlist[[paste0("Var_", names(omics)[i])]] <- VARvec
    }
  }

  N_param_est_list<- length(param_est_list)
  N_cellTypes <- length(cellTypes)
  param_est_list_mod <- list()
  
  for(i in 1:N_param_est_list){
    cell_type_list <- list()
    message(paste0("Creating parameters for omic: ", i))
    
    if (identical(names(omics)[i], "scRNA-seq")){
      FClist[[paste0("FC_est_", names(omics)[i])]] <- as.numeric(stats::na.omit(associationMatrix$Gene_FC))
    } else {
      FClist[[paste0("FC_est_", names(omics)[i])]] <- as.numeric(stats::na.omit(associationMatrix$Peak_FC))
    }
    
    for(j in 1:N_cellTypes){
      message(paste0("Creating parameters for cell type: ", j))
      # Estimate library size  
      if(all_missing){
        libs_param <- param_est_list[[i]][[j]][["lib_size"]]
      } else if (all_specified){
        libs_param <- round(stats::rnorm(n = numberCells[j], mean = mean[j], sd = sd[j]))
      } else if (only_cellnum){
        libs_param <- sample(param_est_list[[i]][[j]][["lib_size"]], 
                             size = numberCells[j], replace = TRUE)
      }
      
      # Since we add the foldchange as a scalar, it's multiplied on top of all
      # celltypes, not only one.
      cond_param <- MOSim::sparsim_create_simulation_parameter(
        intensity = param_est_list[[i]][[j]][["intensity"]] * as.numeric(FClist[[i]]),
        variability = param_est_list[[i]][[j]][["variability"]],
        library_size = libs_param,
        condition_name = param_est_list[[i]][[j]][["name"]],
        feature_names = names(param_est_list[[i]][[j]][["intensity"]]))
      
      cell_type_list[[names(cellTypes)[j]]] <- cond_param
      
    }
    param_est_list_mod[[paste0("param_est_", names(omics)[i])]] <- cell_type_list
  }
  
  return(list(param_list = param_est_list_mod, FClist = FClist,
              VARlist = VARlist, 
              associationMatrix = associationMatrix, dfPeakNames = dfPeakNames, 
              dfGeneNames = dfGeneNames))
}



#' sc_mosim
#'
#' Performs multiomic simulation of single cell datasets
#'
#' @param omics named list containing the omic to simulate as names, which can 
#'     be "scRNA-seq" or "scATAC-seq".
#' @param cellTypes list where the i-th element of the list contains the column 
#'     indices for i-th experimental conditions. List must be a named list.
#' @param numberReps OPTIONAL. Number of replicates per group
#' @param numberGroups OPTIONAL. number of different groups
#' @param diffGenes OPTIONAL. If number groups > 1, Percentage DE genes to simulate.
#'    List of vectors (one per group to compare to group 1) where the vector
#'    contains absolute number of genes for Up and Down ex: c(250, 500) or a 
#'    percentage for up, down ex: c(0.2, 0.2). The rest will be NE
#' @param minFC OPTIONAL. Threshold of FC below which are downregulated, by 
#'    default 0.25
#' @param maxFC OPTIONAL. Threshold of FC above which are upregulated, by default 4
#' @param numberCells OPTIONAL. Vector of numbers. The numbers correspond to the number of 
#'     cells the user wants to simulate per each cell type. The length of the 
#'         vector must be the same as length of \code{cellTypes}.
#' @param mean OPTIONAL. Vector of numbers of mean depth per each cell type. Must be specified 
#'     just if \code{numberCells} is specified.The length of the vector must be 
#'         the same as length of \code{cellTypes}.
#' @param sd OPTIONAL. Vector of numbers of standard deviation per each cell type. Must be 
#'     specified just if \code{numberCells} is specified.The length of the vector 
#'         must be the same as length of \code{cellTypes}.
#' @param noiseRep OPTIONAL. Number indicating the desired standard deviation 
#'      between biological replicates.
#' @param noiseGroup OPTIONAL. Number indicating the desired standard deviation
#'      between treatment groups
#' @param regulatorEffect OPTIONAL. To simulate relationship scRNA-scATAC, list 
#'      of vectors (one per group) where the vector contains absolute number of
#'      regulators for Activator and repressor ex: c(150, 200) or a percentage
#'      for Activator and repressor ex: c(0.2, 0.1). The rest will be NE. If not
#'      provided, no table of association between scRNA and scATAC is outputted.
#' @param associationList REQUIRED A 2 columns dataframe reporting peak ids 
#'      related to gene names. If user doesnt have one, load from package
#'      data("associationList")
#' @param feature_no OPTIONAL. If only scRNA-seq to simulate or scRNA and scATAC
#'      but no regulatory constraints, total number of features to be distributed 
#'      between the coexpression clusters.
#' @param clusters OPTIONAL. Number of co-expression patterns the user wants
#'      to simulate
#' @param cluster_size OPTIONAL. It may be inputted by the user. Recommended: 
#'      by default, its the number of features divided by the number of patterns 
#'      to generate.
#' @param TF OPTIONAL default is FALSE, if true, extract TF dataframe
#' @param TFdf OPTIONAL, default is NULL. If an association matrix of TF and 
#'        Target_gene is given the TF expression values are extracted. If no data.frame
#'        is given, using the association of human TF from 
#'        {https://tflink.net/}
#' @return a list of Seurat object, one per each omic.
#' @export
#'
#' @examples
#' omic_list <- sc_omicData(list("scRNA-seq"))
#' cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#' 'Memory_B' = c(31:40))
#' sim <- sc_mosim(omic_list, cell_types)
#'
sc_mosim <- function(omics, cellTypes, numberReps = 1, numberGroups = 1, 
                    diffGenes = NULL, minFC = 0.25, maxFC = 4,
                    numberCells = NULL, mean = NULL, sd = NULL, noiseRep = 0.1 , 
                    noiseGroup = 0.5, regulatorEffect = NULL, associationList = NULL, 
                    feature_no = 8000, clusters = 3, cluster_size = NULL,
                    TF = FALSE, TFdf = NULL){
  
  # Check for mandatory parameters
  if (missing(omics)){
    stop("You must provide the vector of omics to simulate.")
  }
  
  if (missing(cellTypes)) {
    stop("You must provide the correspondence of cells and celltypes")
  }
  
  cellTypesCoex <- cellTypes
  if (is.null(numberCells)){
    numberCells <- lengths(cellTypes)
  }

  ## Check that number of groups and number of differentially expressed
  # probabilities makes sense
  if (numberGroups > 1){
    if (is.null(diffGenes) || length(diffGenes) != (numberGroups - 1)){
      stop(paste0("Number of elements in diffGenes must have a length equal to",
                  " numberGroups -1"))
    }
  }
  
  ## Check that columns of association list are c("Peak_ID", "Gene_ID")
  if (!is.null(associationList) && !identical(colnames(associationList), c("Peak_ID", "Gene_ID"))){
    stop("Column names of the user-inputted association list should be 'Peak_ID' and 'Gene_ID'")
  } else if (is.null(associationList)){
    ## Get the association list loaded in the package
    message("Loading default association list from MOSim package")
    data_env <- new.env(parent = emptyenv())
    data("associationList", envir = data_env, package = "MOSim")
    associationList <- data_env[["associationList"]]
  }
  
  # Check if we have to extract TF
  if (isTRUE(TF)){
    if (is.null(TFdf)){
      # Extract TF from the TF_human vector loaded in the package
      data_env <- new.env(parent = emptyenv())
      data("TF_human", envir = data_env, package = "MOSim")
      TF_human <- data_env[["TF_human"]]
    } else {
      if (!is.data.frame(TFdf) || dim(TFdf)[1] <= 1) {
        stop("Error: variable 'TFdf' is not a dataframe of TF and Target_gene")
      } else{
        TF_human <- TFdf
      }
    }
  }
  
  if (is.null(regulatorEffect) && identical(names(omics[2]), "scATAC-seq")){
    stop("You requested a simulation of scATAC-seq data but did not provide information for variable <regulatorEffect>")
  }
  
  if (numberGroups > 0 && identical(names(omics[2]), "scATAC-seq")){
    if (is.null(regulatorEffect) || length(regulatorEffect) != (numberGroups)){
      stop(paste0("Number of elements in regulatorEffect must have a length equal to",
                  " numberGroups"))
    }
  }
  
  ## Message the experimental dessign
  message(paste0("The experimental design includes: 
                 - ", numberReps, " Biological replicates
                 - ", numberGroups, " Experimental groups
                 - ", paste0(diffGenes), " Differentially expressed genes (Up/Down) per group
                 - ", minFC, " FC below which a gene is downregulated
                 - ", maxFC, " FC above which a gene is upregulated
                 - ", paste0(numberCells), " Number of cells per celltype
                 - ", paste0(regulatorEffect), " Regulators (activator/repressor) per group
                 - ", clusters, " Gene co-expression patterns")[1])
  
  ## format number regulators, if its relative, make absolute
  numfeat <- length(associationList$Gene_ID)
  genereggroup <- list()
  
  if (length(omics) > 1){
    for (i in 1:numberGroups){
      if (regulatorEffect[[i]][1] < 1) {
        # If relative, make absolute numbers
        numActivator <- round(regulatorEffect[[i]][1]*numfeat, digits = 0)
        numRepressor <- round(regulatorEffect[[i]][2]*numfeat, digits = 0)
      } else {
        numActivator <- regulatorEffect[[i]][1]
        numRepressor <- regulatorEffect[[i]][2]
        if (numActivator + numRepressor > numfeat){
          stop(paste0("Number of requested Activators and Repressors is bigger
                    than the possible regulators according to the association
                    dataframe. Activators plus repressors must be below: ",
                      numfeat))
        }
      }
      # Get names of regulators per group
      numActivator <- sample(associationList$Peak_ID, numActivator)
      numRepressor <- sample(setdiff(associationList$Peak_ID, numActivator), numRepressor)
      
      # If group 2 onwards
      if (i > 1){
        ## Get activated, repressed and other diffexp for genes
        if (diffGenes[[i -1]][1] < 1) {
          numup <- round(diffGenes[[i -1]][1]*nrow(omics[[1]]), digits = 0)
          numdown <- round(diffGenes[[i -1]][2]*nrow(omics[[1]]), digits = 0)
        } else {
          numup <- diffGenes[[i -1]][1]
          numdown <- diffGenes[[i -1]][2]
          if (numup + numdown > nrow(omics[[1]])){
            stop(paste0("Number of requested Upregulated and Downregulated genes
                    is bigger than the number of total genes: ", nrow(omics[[1]])))
          }
        }
        
        
        # Get the genes corresponding to the activator regulators and repressors
        genesActivated <- associationList[associationList$Peak_ID %in% numActivator, ]
        genesRepressed <- associationList[associationList$Peak_ID %in% numRepressor, ]
        
        # And add other random genes (not in the association list)
        u <- abs(numup - length(genesActivated[[2]]))
        d <- abs(numdown - length(genesRepressed[[2]]))
        
        availGenes <- setdiff(rownames(omics[[1]]), as.vector(associationList[[2]]))
        genesUp <- sample(availGenes, u)
        availGenes <- setdiff(availGenes, genesUp)
        genesDown <- sample(availGenes, d)
        
        remaining <- setdiff(rownames(omics[[1]]), genesActivated[[2]])
        remaining <- setdiff(remaining, genesRepressed[[2]])
        remaining <- setdiff(remaining, genesUp)
        remaining <- setdiff(remaining, genesDown)
        genereggroup[[paste0("GeneActivated_G", i)]] <- genesActivated
        genereggroup[[paste0("GeneRepressed_G", i)]] <- genesRepressed
        genereggroup[[paste0("GeneExtraUp_G", i)]] <- genesUp
        genereggroup[[paste0("GeneExtraDown_G", i)]] <- genesDown
        genereggroup[[paste0("GeneRemaining_G", i)]] <- remaining
        
        # Here the up and down, have to be as many as possible from the association
        # list, so take rows where its activator and make them up, when its repressor
        # make them down
        if (numup < length(numActivator) || numdown < length(numRepressor)){
          stop("You have asked for many regulators, but there aren't enough 
           differentially expressed genes to be regulated")
        }
        # Get the info for the ATAC
        u <- numup - length(unique(genesActivated[[1]]))
        d <- numdown - length(unique(genesRepressed[[1]]))
        availFeat <- setdiff(rownames(omics[[2]]), unique(associationList[[1]]))
        regAct <- sample(availFeat, u)
        availFeat <- setdiff(availFeat, regAct)
        regRep <- sample(availFeat, d)
        
        remaining <- setdiff(rownames(omics[[2]]), as.vector(genesActivated[[1]]))
        remaining <- setdiff(remaining, as.vector(genesRepressed[[1]]))
        remaining <- setdiff(remaining, regAct)
        remaining <- setdiff(remaining, regRep)
        
        genereggroup[[paste0("FeatExtraUp_G", i)]] <- regAct
        genereggroup[[paste0("FeatExtraDown_G", i)]] <- regRep
        genereggroup[[paste0("FeatRemaining_G", i)]] <- remaining
      } else {
        ## Here say what to put in the genereggroup if we dont have two groups
        activated_genes <- associationList[associationList$Peak_ID %in% numActivator, ]
        repressed_genes <- associationList[associationList$Peak_ID %in% numRepressor, ]
        genereggroup[["FeatExtraUp_G1"]] <- numActivator
        genereggroup[["FeatExtraDown_G1"]] <- numRepressor
        genereggroup[["FeatRemaining_G1"]] <- setdiff(rownames(omics[[2]]), c(numActivator, numRepressor))
        genereggroup[["GeneActivated_G1"]] <- activated_genes
        genereggroup[["GeneRepressed_G1"]] <- repressed_genes
        genereggroup[["GeneExtraUp_G1"]] <- NA
        genereggroup[["GeneExtraDown_G1"]] <- NA
        genereggroup[["GeneRemaining_G1"]] <- setdiff(rownames(omics[[1]]), c(as.character(activated_genes$Gene_ID), as.character(repressed_genes$Gene_ID)))
      }
    }
  } else {
    if (numberGroups > 1){
      ## Here say what to do if we don't have ATAC-seq
      for (i in 2:numberGroups){
        if (diffGenes[[i -1]][1] < 1) {
          numup <- round(diffGenes[[i -1]][1]*nrow(omics[[1]]), digits = 0)
          numdown <- round(diffGenes[[i -1]][2]*nrow(omics[[1]]), digits = 0)
        } else {
          numup <- diffGenes[[i -1]][1]
          numdown <- diffGenes[[i -1]][2]
          if (numup + numdown > nrow(omics[[1]])){
            stop(paste0("Number of requested Upregulated and Downregulated genes
                      is bigger than the number of total genes: ", nrow(omics[[1]])))
          }
        }
        u <- sample(rownames(omics[[1]]), numup)
        availGenes <- setdiff(rownames(omics[[1]]), u)
        d <- sample(availGenes, numdown)
        genereggroup[[paste0("GeneExtraUp_G", i)]] <- u
        genereggroup[[paste0("GeneExtraDown_G", i)]] <- d
        genereggroup[[paste0("GeneRemaining_G", i)]] <- setdiff(availGenes, d)
      }
    }
  }

  
  ### Start working on the data
  
  N_omics <- length(omics)
  
  ## Subset only columns of interest (our celltypes)
  for (om in 1:N_omics){
    omics[[om]] <- omics[[om]][, unname(unlist(cellTypes))]
  }
  # Reorganize our cellTypes variable according to the subset
  createRangeList <- function(vector, nam) {
    rangeList <- list()
    totalValues <- sum(vector)
    start <- 1
    
    for (i in 1:length(vector)) {
      end <- start + vector[i] - 1
      rangeList[[i]] <- seq(start, end)
      start <- end + 1
    }
    names(rangeList) <- nam
    return(rangeList)
  }
  
  cellTypes <- createRangeList(numberCells, names(cellTypes))
  
  # Make the patterns to simulate coexpression
  lpatterns <- make_cluster_patterns(length(cellTypes), clusters = clusters)
  # Get also the indices of cluster patterns that are opposite and will be 
  # important for the regulators
  genereggroup[["opposite_indices"]] <- lpatterns$opposite_indices
  patterns <- lpatterns$patterns
  
  # Simulate coexpression
  for (i in 1:N_omics){
    coexpr_results <- MOSim::simulate_coexpression(omics[[i]],
                                            feature_no = feature_no, cellTypes = cellTypesCoex,
                                            patterns = patterns, cluster_size = cluster_size)
    
    # Get the coexpressed matrix out
    omics[[i]] <- as.data.frame(coexpr_results$sim_matrix)
    rownames(omics[[i]]) <- omics[[i]]$feature
    omics[[i]]$feature <- NULL
    # Get the clusters out
    genereggroup[[paste0("Clusters_", names(omics)[[i]])]] <- coexpr_results$sim_clusters
  }
  
  ## Check if there is any group that is asking for more repressors
  # than what is possible according to the number of opposing genes or peaks 
  # we have available.
  if (N_omics > 1){
    for (i in 1:numberGroups){
      # Check repressors
      repre <- dim(genereggroup[[paste0("GeneRepressed_G", i)]])[1]
      repre_avail <- t(as.data.frame(lengths(genereggroup$`Clusters_scRNA-seq`)))
      repre_avail <- repre_avail[genereggroup$opposite_indices[[1]]]
      repre_avail <- sum(repre_avail)
      if (repre > repre_avail){
        stop(paste0("You have asked for ", repre, " repressors (regulatorEffect for group_", 
                    i, " = ", regulatorEffect[[i]][2], 
                    "). But since you only allowed for ", clusters, " clusters and ",
                    feature_no, " features to be split between them, there are only ",
                    repre_avail, " regulators available to be repressor. We recommend you either request less repressors, or increase the number of features that can be clustered."))
      }
    }
  }
  
  # Start the lists we will need to include in the output
  seu_groups <- list()
  Association_list <- list()
  FC_used_list <- list()
  VAR_used_list <- list()
  param_list <- list()
  
  for (g in 1:numberGroups){
    seu_replicates <- list()

    message(paste0("Estimating parameters for experimental group ", g))
    
    param_l <- MOSim::sc_param_estimation(omics, cellTypes, diffGenes, minFC, maxFC, 
                                          numberCells, mean, sd, noiseGroup, g, 
                                          genereggroup)
    

    Association_list[[paste0("AssociationMatrix_Group_", g)]] <- param_l$associationMatrix
    FC_used_list[[paste0("FC_Group_", g)]] <- param_l$FClist
    VAR_used_list[[paste0("VAR_Group_", g)]] <- param_l$VARlist
    param_list <- param_l$param_list
    
    for (r in 1:numberReps){
      message(paste0("Simulating parameters for replicate ", r))
      
      sim_list <- list()
      
      
      for(i in 1:N_omics){
        # Simulate the replicate
        sim <- MOSim::sparsim_simulation(dataset_parameter = param_list[[i]])
        sim <- sim[["count_matrix"]]
        # Generate a standard deviation to add to the matrix
        var_rep <- stats::rnorm(nrow(as.data.frame(omics[[i]])), 0, noiseRep)
        # Add the standard deviation of the replicate
        # transform the matrix into TRUE when > 0 false when 0
        sim_trueFalse <- (sim > 0)
        # Multiply the variability vector by a 1/0 to keep the zeros.
        for (e in 1:length(colnames(sim))){
          sim_trueFalse[, e] <- as.integer(as.logical(sim_trueFalse[,e]))
          sim[,e] <- sim[,e] + (sim_trueFalse[,e] * var_rep)
        }
        # Make sure there are no negative numbers
        sim <- abs(sim)
        # Now pass this modified matrix back
        sim_list[[paste0("sim_", names(omics)[i])]] <- sim
        
      }
      
      seu_obj <- list()
      N_sim <- length(sim_list)
      
      for(i in 1:N_sim){
        
        assay_name <- str_split(names(sim_list)[i], "-")[[1]][1]
        assay_name <- sub("sim_sc","",assay_name)
        
        options(Seurat.object.assay.version = "v3")
        seu <- Seurat::CreateAssayObject(counts = sim_list[[i]],
                                          assay = assay_name,
                                          rownames = rownames(sim_list[[i]]), #explicitly specifying rownames
                                          colnames = colnames(sim_list[[i]])) #and colnames for Seurat obj
        seu_obj[[names(sim_list)[i]]] <- seu
        
      }
      seu_replicates[[paste0("Rep_", r)]] <- seu_obj
    }
    
    seu_groups[[paste0("Group_", g)]] <- seu_replicates
    
  } 
  
  # Bring back final celltypes
  seu_groups[["cellTypes"]] <- cellTypes
  seu_groups[["patterns"]] <- patterns
  # Bring back FC vector
  seu_groups[["FC"]] <- FC_used_list
  seu_groups[["AssociationMatrices"]] <- Association_list
  seu_groups[["Variability"]] <- VAR_used_list
  
  
  # If TF, extract their count matrix
  if (isTRUE(TF)){
    # Extract the TFs according to the users list
    for (group_name in names(seu_groups)) {
      if (grepl( "Group", group_name, fixed = TRUE)){
        group <- seu_groups[[group_name]]
        for (replicate_name in names(group)) {
          replicate <- group[[replicate_name]]
          seu_groups[[group_name]][[replicate_name]]$sim_TF <- subset(replicate$`sim_scRNA-seq`, features = TF_human$TF)
        }
      }
    }
    seu_groups[["TFtoGene"]] <- TF_human
  }
  
  return(seu_groups)
  
}



#' sc_omicSettings
#'
#' @param sim a simulated object from sc_mosim function
#' @param TF OPTIONAL default is FALSE, if true, extract TF association matrix
#'
#' @return list of Association matrices explaining the effects of each
#' regulator to each gene
#' @export
#'
#' @examples
#'
#' cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#' 'Memory_B' = c(31:40))
#' omicsList <- sc_omicData(list("scRNA-seq"))
#' sim <- sc_mosim(omicsList, cell_types)
#' res <- sc_omicSettings(sim)
sc_omicSettings <- function(sim, TF = FALSE){
  asma <- sim$AssociationMatrices
  FC <- sim$FC
  
  # Add columns for FC
  for (i in c(1:length(asma))){
    # I have NAs in Gene_ID and Peak_ID, so make the vectors accordingly
    asma[[i]]$Gene_FC <- ifelse(!is.na(asma[[i]]$Gene_ID), FC[[i]][[1]], NA)
    if (length(FC) > 1){
      
      asma[[i]]$Peak_FC <- ifelse(!is.na(asma[[i]]$Peak_ID), FC[[i]][[2]], NA)
    }
  }
  
  TFtoGene_Association <- list()
  
  ## Filter TFtoGene so only genes in our clusters are there
  if (isTRUE(TF)){
    TFtoGene <- sim$TFtoGene
    colnames(TFtoGene) <- c("Gene_ID", "Target_ID")
    # Extract only genes with a cluster from association matrix
    clu <- asma$AssociationMatrix_Group_1[asma$AssociationMatrix_Group_1$Gene_cluster >= 1,]
    TFtoGene <- TFtoGene[TFtoGene$Gene_ID %in% clu$Gene_ID,]
    TFtoGene <- TFtoGene[TFtoGene$Target_ID %in% clu$Gene_ID, ]
    
    # Get opposing patterns
    opposite_indices <- MOSim::check_patterns(sim$patterns)
    
    for (group_name in names(sim)){
      if (grepl( "Group", group_name, fixed = TRUE)){
        TFtoGene_matrix <- data.frame(Gene_ID = character(),
                                      Target_ID = character(),
                                      Cluster_ID = character(),
                                      Cluster_Target = character(),
                                      stringsAsFactors = FALSE)
        
        # Get association name
        association_name <- grep(paste0(group_name, "$"), names(asma), value = TRUE)
        mat <- asma[[association_name]]
        
        # Loop through each row of dataframe B
        for (i in 1:nrow(TFtoGene)) {
          # Extract the Gene_ID and Target_ID from dataframe B
          gene_id <- TFtoGene$Gene_ID[i]
          target_id <- TFtoGene$Target_ID[i]
          
          gene_cluster_id <- stats::na.omit(mat$Gene_cluster[mat$Gene_ID == gene_id])
          target_cluster_id <- stats::na.omit(mat$Gene_cluster[mat$Gene_ID == target_id])
          
          # If a matching Cluster_ID is found, add it to dataframe C
          if (gene_cluster_id[1] > 0 && target_cluster_id[1] > 0) {
            # Determine regulator_effect
            if (gene_cluster_id == target_cluster_id) {
              regulator_effect <- "activator"
            } else if (any(sapply(opposite_indices, function(x) all(x %in% c(gene_cluster_id, target_cluster_id))))) {
              regulator_effect <- "repressor"
            } else {
              regulator_effect <- "NE"
            }
            
            TFtoGene_matrix <- rbind(TFtoGene_matrix, 
                                     data.frame(Gene_ID = gene_id,
                                                Target_ID = target_id,
                                                Cluster_ID = gene_cluster_id,
                                                Cluster_Target = target_cluster_id,
                                                regulator_effect = regulator_effect,
                                                stringsAsFactors = FALSE))
            
          }
        }
        TFtoGene_Association[[group_name]] <- TFtoGene_matrix
      }
    }
    asma[["TFtoGene_Association"]] <- TFtoGene_Association
  }
  
  return(asma)
}

#' sc_omicResults
#'
#' @param sim a simulated object from sc_mosim function
#' @return list of seurat objects with simulated data
#' @export
#' @examples
#'
#' cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#' 'Memory_B' = c(31:40))
#' omicsList <- sc_omicData(list("scRNA-seq"))
#' sim <- sc_mosim(omicsList, cell_types)
#' res <- sc_omicResults(sim)
sc_omicResults <- function(sim){
  df <- sim[grepl("Group_", names(sim))]
  return(df)
}

## Test sc_mosim

suppressPackageStartupMessages(library(testthat))
set.seed(123)

# sc_omicData function
testthat::test_that("Passing a wrong string in 'omics' returns Error", {
  testthat::expect_error(MOSim::sc_omicData(c("scR-seq"), rna_orig_counts))
})

testthat::test_that("Passing an object in data which is neither a matrix or Seurat obj returns error", {
  vector <- c(1,2,3)
  testthat::expect_error(MOSim::sc_omicData(c("scATAC-seq"), vector))
})

testthat::test_that("Passing 'scRNA-seq' as omic and a Seurat obj as data returns a list", {
  scRNA <- MOSim::sc_omicData("scRNA-seq")
  count <- scRNA[["scRNA-seq"]]
  options(Seurat.object.assay.version = "v3")
  Seurat_obj <- Seurat::CreateAssayObject(counts = count, assay = 'RNA')
  testthat::expect_type(sc_omicData(c("scRNA-seq"), c(Seurat_obj)), "list")
})

testthat::test_that("Passing an array ('scRNA-seq','scATAC-seq') as omic returns a list of length 2", {
  res<-MOSim::sc_omicData(list("scRNA-seq","scATAC-seq"))
  testthat::expect_equal(length(res), 2)
})


testthat::test_that("If numberGroups > 1, length(diffGenes) must be == (numberGroups -1)", {
  omicsList <- MOSim::sc_omicData(list("scRNA-seq"))
  cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
                     'Memory_B' = c(31:40))
  # For this not to be an error, it should be diffGenes = list(c(0.2, 0.2))
  testthat::expect_error(MOSim::sc_mosim(omicsList, cell_types, numberReps = 2, numberGroups = 2, 
                       diffGenes = c(0.2, 0.2), minFC = 0.25, maxFC = 4,
                       numberCells = NULL, mean = NULL, sd = NULL))
})

testthat::test_that("Not passing all optional arguments at once returns an error", {
  omic_list <- MOSim::sc_omicData(c("scRNA-seq","scATAC-seq"))
  conditions <- list('Treg' = c(1:10),'cDC' = c(11:20))
  testthat::expect_error(MOSim::sc_mosim(omic_list, conditions, sd = c(10^3, 10^2)))
})

#sc_mosim function
testthat::test_that("param_estimation returns a list", {
  omic_list <- MOSim::sc_omicData(c("scRNA-seq"))
  conditions <- list('Treg' = c(1:10),'cDC' = c(11:20))
  testthat::expect_type(MOSim::sc_mosim(omic_list, conditions, 
                                       mean = c(2*10^6, 2*10^3), sd = c(10^3, 10^2)),"list")
})

testthat::test_that("sc_mosim returns a list with S4 obj as values", {
  omic_list <- MOSim::sc_omicData(c("scRNA-seq"))
  cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20))
  sim <-MOSim::sc_mosim(omic_list, cell_types, mean = c(2*10^6, 2*10^3), sd = c(10^3, 10^2))
  testthat::expect_type(sim[[1]][[1]][[1]], "S4")
})

#make_cluster_patterns function
testthat::test_that("make_cluster_patterns returns a tibble of dimensions 
          numcells^2xnumcells",{
            patterns <- MOSim::make_cluster_patterns(4, 4)
            expected <- c(4, 4)
            testthat::expect_equal(dim(patterns$patterns), expected)
          })

## Test the patterns
testthat::test_that("when there are two opposite patterns, it gives them back", {
  patterns <- tibble::tibble(one = c(TRUE, FALSE, TRUE, FALSE), 
                     two = c(TRUE, FALSE, TRUE, TRUE), 
                     three = c(FALSE, TRUE, FALSE, TRUE), 
                     four = c(FALSE, TRUE, TRUE, TRUE))
  opposite_indices <- check_patterns(patterns)
  testthat::expect_equal(length(opposite_indices[[1]]), 2)
})

## Check we are generating matrices
testthat::test_that("The number of patterns we want are generated", {
  omic_list <- MOSim::sc_omicData(c("scRNA-seq", "scATAC-seq"))
  cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
                     'Memory_B' = c(31:40))
  sim <-MOSim::sc_mosim(omic_list, cell_types, regulatorEffect = list(c(0.1, 0.2)))
  
  sim_matrix <- sim$Group_1$Rep_1$`sim_scRNA-seq`$counts
  testthat::expect_type(sim_matrix, "S4")
})

## test passing association list and working with groups and replicates
testthat::test_that("checking that sc_mosim is able to simulate groups and replicates", {
  omicsList <- MOSim::sc_omicData(list("scRNA-seq", "scATAC-seq"))
  cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
                     'Memory_B' = c(31:40))
  data("associationList")
  testing_groupsreps <- MOSim::sc_mosim(omicsList, cell_types, numberReps = 2, numberGroups = 2, 
                                       diffGenes = list(c(0.1, 0.2)), minFC = 0.25, maxFC = 4,
                                       numberCells = NULL, mean = NULL, sd = NULL, 
                                       regulatorEffect = list(c(0.1, 0.2), c(0.2, 0.3)),
                                       associationList = associationList)
  testthat::expect_type(testing_groupsreps, "list")
})

#' @include Simulator.R functions.R
#' @import lazyeval
#' @importFrom rlang .data
NULL

setMethod("initialize", signature="MOSimulation", function(.Object, ...) {
    # Set slots
    .Object <- callNextMethod()

    # Rename the simulators names to match the classes names
    names(.Object@simulators) <- ifelse(startsWith(names(.Object@simulators), "Sim"),
                                        names(.Object@simulators),
                                        paste0("Sim", gsub("-", "", names(.Object@simulators)))
                                        )

    # RNA-seq simulator must always be present
    if (! exists('SimRNAseq', where = .Object@simulators)) {
        .Object@simulators[['SimRNAseq']] <- list()
    }

    # Load default data if none is provided
    dataProvided <- sapply(.Object@simulators, is.declared, key = 'data')

    if (! any(dataProvided)) {
        data(sampleData, envir = environment())

        .Object@simulators <- mapply(function(sim, data) {
            # Assign data only on list option, not already instantiated objects or those
            # that already have it on the options.
            if (is.declared(data) && ! inherits(sim, "MOSimulator")) {

                if (! is.declared(sim, "data")) {
                    sim$data <- if (exists('data', where = data)) data$data else NULL
                }

                if (! is.declared(sim, "idToGene")) {
                    sim$idToGene <- if (exists('idToGene', where = data)) data$idToGene else NULL
                }
            }

            return(sim)
        }, sim = .Object@simulators, data = sampleData[names(.Object@simulators)], SIMPLIFY = FALSE)

        if (! is.null(.Object@TFtoGene) && .Object@TFtoGene) {
            .Object@TFtoGene <- sampleData$SimRNAseq$TFtoGene
        }
    }

    # Inherited params from simulation
    inheritParams <- list(
        "noiseFunction",
        "noiseParams",
        "depth",
        "minMaxQuantile",
        "minMaxFC"
        )

    # Initialize simulators
    .Object@simulators <- mapply(function(sim, class) {
        # Directly return the simulator if it has already been initialized
        if (! inherits(sim, "MOSimulator")) {
            # Add default params if not provided in the options list
            for (param in inheritParams) {
                if (! exists(param, sim)) {
                    sim[[param]] <- slot(.Object, param)
                }
            }

            # Initialize the simulator
            sim <- do.call(new, c("Class" = class, sim))
        } else {
            # Set the proper slots in the initialized object
            for (param in inheritParams) {
                slot(sim, param) <- slot(.Object, param)
            }
        }

        # If required, adjust the total number of features to simulate on every omic
        if (nrow(sim@data) > sim@totalFeatures) {

            if (sim@regulator) {
                # TODO: limit the sample to those regulators affecting the possibly
                # limited gene list?
            }

            sim@data <- sim@data[sample(rownames(sim@data), sim@totalFeatures), ,drop=FALSE]
        }

        return(sim)

    }, .Object@simulators, names(.Object@simulators), SIMPLIFY = FALSE)

    # Assign gene identifiers and total number from the data
    .Object@geneNames <- rownames(.Object@simulators[['SimRNAseq']]@data)
    .Object@totalGenes <- nrow(.Object@simulators[['SimRNAseq']]@data)

    # Check gene number
    .Object@diffGenes <- round(.Object@totalGenes * min(.Object@diffGenes, 0.99))

    # Print settings
    simSettings(.Object)

    # Create the simulation settings only if they haven't been passed as an option.
    if (! is.declared(.Object@simSettings)) {

        message("Generating simulation settings for RNA-seq.")

        # Available profiles with probabilities
        profileOptions <- names(.Object@profiles)
        profileProbs <- .Object@profileProbs[profileOptions]

        # If there is no time series, allow only the flat profile
        if (length(.Object@times) < 2) {
            profileProbs <- replace(profileProbs, profileOptions != 'flat', 0)
        }

        # If we consider the TF, force that at least 85% of them to be DE
        if (! is.null(.Object@TFtoGene)) {
            # Rename columns
            colnames(.Object@TFtoGene) <- c("Symbol", "TFgene", "LinkedGene")

            # Exclude those not present on gene expression data
            .Object@TFtoGene <- dplyr::filter(.Object@TFtoGene,
                                              TFgene %in% .Object@geneNames)

            # TF to be DE
            allGeneTF <- unique(.Object@TFtoGene$TFgene)

            sampleDE <- sample(as.character(allGeneTF),
                               size = min(round(length(allGeneTF) * 0.85), .Object@diffGenes),
                               replace = FALSE)

            numDiffGenes <- .Object@diffGenes - length(sampleDE)

            if (numDiffGenes) {
                sampleDE <- c(sampleDE, sample(
                    setdiff(.Object@geneNames, sampleDE),
                    size = numDiffGenes,
                    replace = FALSE
                ))
            }
        } else {
            # Assign random gene names to DE
            sampleDE <- sample(
                .Object@geneNames,
                size = .Object@diffGenes,
                replace = FALSE
            )
        }

        # Assign gene names to NonDE
        sampleNonDE <- setdiff(.Object@geneNames, sampleDE)

        # Randomly assign a profile to every DE gene
        # If we have only ONE group, remove flat profile from the
        # DE options because otherwise could not be considered DE genes.
        profileProbsDE <- profileProbs

        if (.Object@numberGroups < 2) {
            profileProbsDE <- replace(profileProbs, profileOptions == 'flat', 0)
        }

        # If number of times is smaller than 3, remove transitory profiles
        if (length(.Object@times) < 3) {
            profileProbsDE <- replace(profileProbsDE, grep("transitory", profileOptions), 0)
        }

        # Construct the data frame with DE genes profiles
        profilesDE <-
            if (.Object@diffGenes)
                data.frame(
                    ID = sampleDE,
                    DE = TRUE,
                    replicate(
                        .Object@numberGroups,
                        sample(
                            profileOptions,
                            .Object@diffGenes,
                            replace = TRUE,
                            prob = profileProbsDE
                        )
                    ), stringsAsFactors = FALSE)
            else
                stop("There are no DEG profiles available, please increase the amount of DE genes.")


        # Assign a random "Tmax" for transitory profiles

        # Declare helper variable
        tmax.T <- length(.Object@times) - 1

        for (g in seq(.Object@numberGroups)) {
            profilesDE[, paste0("Tmax.Group", g)] <- ifelse(grepl("transitory", profilesDE[, 2 + g]), # Third column = Group 1
                                                            stats::runif(nrow(profilesDE), min = 0.25 * tmax.T, max = 0.75 * tmax.T),
                                                            NA)
        }

        # Randomly assign a profile to every NonDE
        profilesNonDE <-
            if (length(sampleNonDE))
                data.frame(
                    ID = sampleNonDE,
                    DE = FALSE,
                    replicate(.Object@numberGroups,
                              rep('flat', times = length(sampleNonDE))),
                    replicate(.Object@numberGroups,
                              rep(NA, times = length(sampleNonDE))),
                    stringsAsFactors = FALSE)
            else
                stop("There are no non-DEG profiles available, please reduce the amount of DE genes.")

        # Set correct colnames
        # Important: pattern "Group[n]" is used to subset with dplyr later
        colNames <- paste0("Group", seq_len(.Object@numberGroups))

        # Symbols needed to split the DF by dplyr
        dplyrGroup <- lapply(colNames, as.symbol)

        colnames(profilesDE) <- colnames(profilesNonDE) <- c("ID", "DE",
                                         colNames, utils::tail(colnames(profilesDE),
                                                     .Object@numberGroups))

        # Merge DE + nonDE for easier access
        # profilesExpr <- rbind(profilesDE, profilesNonDE)
        profilesAll <- rbind(profilesDE, profilesNonDE)

        # Create a profile table for each regulator
        # Note: prevent harmless warning about converting factors to character vector
        suppressWarnings(profilesReg <- sapply(.Object@simulators[names(.Object@simulators) != 'SimRNAseq'], function(sim) {
            message(sprintf("Generating simulation settings for %s.", sim@name))

            # First assign an effect to each regulator, including NE
            allRegulators <- rownames(sim@data)

            # Remove NE
            availableEffects <- sim@regulatorEffect[grep("NE", names(sim@regulatorEffect), invert = TRUE)]

            # Number of regulators with effect
            numberWithEffect <- length(allRegulators) * sum(as.numeric(availableEffects))

            # Select genes ID regulator ID from all genes considered
            regTable <- IDtoGenes(sim, rownames(sim@data), simplify = FALSE)

            # Choose from regulators associated to some gene
            availableRegulators <- unique(regTable$ID)

            # If there are not enough, chose the available ones
            chosenRegulators <- sample(x = availableRegulators,
                                       size = min(length(availableRegulators), numberWithEffect),
                                       replace = FALSE)
            effectByID <- data.frame(
                ID = allRegulators,
                Effect = ifelse(allRegulators %in% chosenRegulators,
                                TRUE, # Do not assign the effect as it will be assigned later
                                "NE"
                                )
                )

            # Skip the process
            if (! nrow(regTable))
                stop(sprintf("No genes were retrieved from the association list for %s, be sure to provide the correct table.", sim@name))

            # Randomly assign an effect to every regulator from the available
            # options defined on every simulator, excluding NE effect.
            regTable$Effect <- sample(
                names(availableEffects),
                size = nrow(regTable),
                replace = TRUE,
                prob = as.numeric(availableEffects)
            )

            # Set non-DEG or non-selected regulators to <NA>
            discardedReg <- dplyr::filter(effectByID, Effect == "NE") %>% dplyr::pull(ID)

            regTable <- dplyr::mutate(regTable, Effect = replace(Effect, (! Gene %in% sampleDE) | (ID %in% discardedReg), NA))

            # Copy the effect to each group
            regTable[, paste0("Effect.Group", seq(.Object@numberGroups))] <- regTable[, rep("Effect", times =.Object@numberGroups)]

            # Initialize tmax.Group columns
            # Copy the effect to each group
            regTable[, paste0("Tmax.Group", seq(.Object@numberGroups))] <- NA

            # Allow simulator class to adjust the generated profiles
            # (i.e. methyation using blocks)
            regTable <- adjustProfiles(sim, .Object, regTable, step = "Effect")

            # Select all (hence the double check) rows duplicated, only for DE genes.
            # Duplicated ID means that the regulator is linked to more than one gene.
            regDupsDE <-  (duplicated(regTable$ID) |
                            duplicated(regTable$ID, fromLast=TRUE)) &
                            (regTable$Gene %in% sampleDE) &
                            (! regTable$ID %in% discardedReg)

            # For every regulator with more than one regulated gene, decide which
            # class (combination of profiles among conditions) to regulate.
            message("- Linking to gene classes...")

            # Legacy code to enable Tmax
            # df: regulator df
            # genesTmax: matrix with gene Tmax values in the proper order
            # assignTmax <- function(df, genesTmax) {
            #     for (group in seq(.Object@numberGroups)) {
            #         colName <- paste0("Tmax.Group", group)
            #         df <- dplyr::mutate(df, !!colName := (if(is.na(genesTmax[[group]]) || is.infinite(genesTmax[[group]])) NA else stats::runif(n = 1, 0.25 * tmax.T, as.numeric(genesTmax[group]))))
            #     }
            #
            #     return(df)
            # }

            # Populate tmax values with the ones found in gene settings table
            regTable <- dplyr::select(regTable, -dplyr::starts_with("Tmax")) %>%
                dplyr::left_join(dplyr::select(profilesDE, ID, dplyr::starts_with("Tmax")), by = c("Gene" = "ID"))

            if (any(regDupsDE)) {
                # Reset effect on the duplicated DE
                # regTable[regDupsDE, c("Effect")] <- NA

                # Choose a new effect
                # Function to use inside classifyDups
                # .selectEffect <- function(groupRow) {
                #     # Relies on the row having these columns (check function classifyDups)
                #     percEnhancer <- max(0, groupRow$Percentage.Enhancer, na.rm = T)
                #     percRepressor <- max(0, groupRow$Percentage.Repressor, na.rm = T)
                #
                #     # In case of tie, select a new effect excluding NE option
                #     if (percEnhancer == percRepressor) {
                #         # If both % are zero, this means the regulator had only ONE class
                #         # that was chosen, and that class was assigned initially as NE,
                #         # thus we keep that.
                #         if (sum(percEnhancer, percRepressor) == 0) {
                #             selEffect <- "NE"
                #         } else {
                #             sampleOptions <- grep("NE", names(sim@regulatorEffect), invert = T)
                #
                #             selEffect <- sample(names(sim@regulatorEffect)[sampleOptions],
                #                                 size = 1,
                #                                 prob = as.numeric(sim@regulatorEffect[sampleOptions]))
                #         }
                #     } else {
                #         selEffect <- if (percEnhancer > percRepressor) 'enhancer' else 'repressor'
                #     }
                #
                #     return(selEffect)
                # }

                classifyDups <- function(profileGroup) {
                    # Select classes of the genes associated with the regulator
                    # Note: dplyr renames the unneeded ID column of "." to ID.y
                    # TODO: room for optimization, remove this join from the loop.
                    regGenes <- dplyr::inner_join(profilesDE, profileGroup, by = c("ID" = "Gene")) %>%
                        dplyr::select(-DE, -ID.y, -dplyr::starts_with("Effect.Group"), -dplyr::ends_with(".y"), dplyr::starts_with("Keep."))

                    # Initialize Tmax.GroupX considering all, for those cases in which
                    # there is only one row.
                    tmaxGroup <- dplyr::select(regGenes, dplyr::starts_with("Tmax.")) %>%
                        dplyr::summarise_all(min, na.rm = TRUE)

                    # Skip the process when there is only one row (regulators affects more than 1 gene
                    # but the others have been classified has non-DE) or if there is no effect at all
                    # in the genes.
                    if (nrow(profileGroup) > 1 && ! all(is.na(regGenes$Effect) | regGenes$Effect == "NE")) {
                        # Split by class and count number of genes on each one.
                        #
                        # I.e. 3 conditions:
                        # induction - induction - repression: X rows
                        # induction - induction - induction: Y rows
                        classSplit <-
                            dplyr::group_by_(regGenes, .dots = dplyrGroup)

                        # Select genes of the majoritary class.
                        #
                        # The majoritary class is selected based on the % of the
                        # most assigned Effect in the group, then, in case of tie, the number
                        # of affected genes is taken into account. If there is another tie,
                        # one is chosen at random or two classes if there are totally
                        # opposite classes.
                        #
                        # Force sampling options to character to prevent a seq when there
                        # is only a result.
                        groupSizes <- dplyr::group_size(classSplit)

                        # If there is only 1 groupSize, skip the process.
                        # If the max % effect is 0, it means that there were multiple groups but all of them
                        # had NE assigned by default.
                        if (length(groupSizes) > 1){# || max(effectSizes$MaxPercentage) == 0) {
                            # Remove groups that have no effect at all
                            # I.e. in methylation we keep <NA> effect up to this point
                            # so there could be two majoritary groups and one of them
                            # without effect.
                            excludedGroups <- dplyr::summarize(classSplit, Exclude = all(is.na(Effect))) %>%
                                dplyr::pull(Exclude)

                            # Remove those groups that have no effect (in methylation)
                            groupSample <- setdiff(which(groupSizes == max(groupSizes[! excludedGroups])), which(excludedGroups))

                            groupSelected <- sample(as.character(groupSample), size = 1)

                            selGroup <- dplyr::slice(regGenes,
                                                     which(dplyr::group_indices(classSplit) == groupSelected))

                            # Retrieve the most used effect
                            propEffect <- prop.table(table(selGroup$Effect))
                            selEffect <- names(propEffect)[propEffect == max(propEffect)]

                            # In case of tie, select at random
                            if (length(selEffect) > 1) {
                                selEffect <- sample(
                                    names(availableEffects),
                                    size = 1,
                                    replace = TRUE,
                                    prob = as.numeric(availableEffects)
                                )
                            }

                            # Select the minimum "Tmax" value for the genes in the group, and generate one
                            # for the regulator.
                            #
                            # Note: there should not be any NA values (in a group) when there is a transitory effect (na.rm not needed)
                            tmaxGroup <- dplyr::select(selGroup, dplyr::starts_with("Tmax.")) %>%
                                dplyr::summarise_all(min, na.rm = TRUE)

                            selGenes <- selGroup$ID

                            # Save profile info (remove ID column)
                            groupCols <- regGenes[, - 1]

                            # Append new columns with associated effect
                            # Add column of effect in Group <i>
                            matchTable <- match(regGenes$ID, profileGroup$Gene)

                            # Selected profile
                            selectedProfile <- dplyr::select(selGroup, dplyr::starts_with("Group")) %>%
                                dplyr::distinct() %>% unlist()

                            # Opposite effect
                            revEffect <- if (selEffect == "NE") NA else setdiff(c('enhancer', 'repressor'), selEffect)

                            for (i in seq(.Object@numberGroups)) {
                                # Opposite class for this group
                                revClass <- stri_replace_all_fixed(
                                    selGroup[1, i + 1], # Skip ID column
                                    c(".induction", ".repression", "*"),
                                    c("*repression", "*induction", "."),
                                    vectorize_all = FALSE
                                )

                                ## When simulating methylation for more than 1 
                                # timepoint, there are repeated matches between 
                                # profile group and groupCols, so there are 
                                # repeated indexes in matchTable. When this 
                                # happens, get the unique overlap, as the 
                                # methylation block identifyer keeps the info
                                # of which CpGs are involved

                                if (sim@name == 'Methyl-seq'){
                                    if (any(duplicated(matchTable))){
                                        matchTable <- unique(matchTable)
                                        profileGroup <- profileGroup[c(matchTable), ]
                                        rownames(profileGroup) <- c(1:length(matchTable))
                                        groupCols <- groupCols[matchTable, ]
                                        rownames(groupCols) <- c(1:length(matchTable))
                                        matchTable <- c(1:length(matchTable))
                                    }
                                }

                                profileGroup[matchTable, paste0("Effect.Group", i)] <- ifelse(
                                    # Check if group is the same as the selected class in this group
                                    groupCols[, i] == as.character(selectedProfile[i]), #selGroup[1, i + 1]),
                                    # If that is the case, choose selected effect
                                    selEffect,
                                    # If not, check if it has the opposite profile
                                    ifelse(
                                        groupCols[, i] == revClass,
                                        # If it has the opposite profile, assign the contrary effect
                                        revEffect,
                                        # If not, assign an NA
                                        NA
                                    )
                                )
                            }

                            profileGroup <- dplyr::mutate(profileGroup, Effect = ifelse(Gene %in% selGenes, selEffect, NA))

                        } else {
                            # Select the group effect (either only one group or multiple but all of them with NE effect)
                              selEffect <- sample(
                                names(availableEffects),
                                size = 1,
                                replace = TRUE,
                                prob = as.numeric(availableEffects)
                            )

                            # Return the original data frame with the same effect for all the genes in the group
                            # Note: use paste as function because newer versions of dplyr cannot work with "~ selEffect"
                            # anymore.
                            profileGroup <- dplyr::mutate(profileGroup, Effect = selEffect) %>%
                                dplyr::mutate_at(dplyr::vars(dplyr::starts_with("Effect.Group")), ~ paste0(selEffect))
                        }
                    }

                    # Assign tmax
                    for (group in seq(.Object@numberGroups)) {
                        colName <- paste0("Tmax.Group", group)

                        profileGroup <- dplyr::mutate(profileGroup,
                                                      !!colName := (if(is.na(tmaxGroup[[group]]) || is.infinite(tmaxGroup[[group]])) NA
                                                                    else as.numeric(tmaxGroup[group])))
                    }

                    # Replace "NE" effect with NA
                    # TODO: check if this is really required, no NE at this point?
                    profileGroup <- dplyr::mutate_at(profileGroup,
                                                     dplyr::vars(dplyr::contains("Effect")),
                                                     list(~ifelse(. == "NE", NA, .)))

                    # Return the processed (or not) profileGroup
                    return(profileGroup)
                }
                # In methylseq, classify the duplicated values outside and then
                # append them to the end of the matrix
                if (sim@name == 'Methyl-seq'){
                    # Get the blocks direction
                    dupProfiles <- dplyr::group_by(regTable[regDupsDE, ], ID) %>% dplyr::do(classifyDups(.))
                    # Remove the duplicates from the regulatory table
                    regTable <- regTable[!regDupsDE,]
                    # Bring back the classified directions of the blocks
                    regTable <- rbind(regTable, dupProfiles)
                } else {
                    regTable[regDupsDE, ] <- dplyr::group_by(regTable[regDupsDE, ], ID) %>% dplyr::do(classifyDups(.))
                }
            }

            message("- Adjusting regulator effect")

            # Expression profiles of all expressed genes
            condTable <- dplyr::left_join(regTable, dplyr::select(profilesAll, -dplyr::starts_with("Tmax.")),
                                          by = c("Gene" = "ID")) %>% dplyr::ungroup()

            subCondTable <- dplyr::select(condTable, ID, Gene, Effect,
                                          dplyr::starts_with("Effect.Group"),
                                          dplyr::starts_with("Tmax.Group"),
                                          dplyr::starts_with("Keep."))

            # Add those regulators not associated with any gene
            allIds <- rownames(sim@data)

            if (! sim@pregenerated) {
                notInTable <- allIds[!allIds %in% condTable$ID]

                subCondTable <- dplyr::bind_rows(subCondTable, data.frame(ID = notInTable))
                condTable <- dplyr::bind_rows(condTable, data.frame(ID = notInTable))
            } else {
                # We assume that Keep.* is the one including the original ID like methyl-seq simulator
                colID <- colnames(regTable)[grep("Keep.", colnames(regTable))]

                notInTable <- dplyr::select(dplyr::ungroup(regTable), "ID", colID)

                notInTable <- notInTable[! as.character(notInTable[, colID]) %in% as.character(condTable[, colID]), ]

                subCondTable <- dplyr::bind_rows(subCondTable, notInTable)
                condTable <- dplyr::bind_rows(condTable, notInTable)
            }

            # Modify the profile of every condition based on the regulator effect
            # on the gene. If the regulator has an "enhancer" effect, the profile
            # will be the same as in RNA-seq, whereas with "repressor" effect, the
            # profile will be the opposite. For no effect, it will be "flat".
            #
            # Examples:
            #   Enhancer:
            #       RNA-seq: continuous.induction
            #       Regulator: continuous.induction
            #   Repressor:
            #       RNA-seq: continous.induction
            #       Regulator: continuous.repressor
            #
            # Note: the fixed pattern/replacement of stri_replace_* overwrites previous
            # results, hence the need to substitute the dot with asterisk first.
            settingsTable <- data.frame(
                    # Variable containing required columns and also those marked as "keep.Name"
                    # in some particular simulators (i.e. methylation)
                    subCondTable,
                    # dplyr::select(condTable, ID, Gene, Effect, dplyr::starts_with("Keep.")),
                    apply(dplyr::select(condTable, dplyr::starts_with("Group")), 2, function(col)
                        ifelse(
                            is.na(condTable$Effect),
                            # Flat profile for no effect regulator
                            'flat',
                            ifelse(
                                condTable$Effect == "enhancer",
                                # Same profile as RNA-seq for enhancer regulators
                                col,
                                # Opposite profile for repressor regulators
                                stri_replace_all_fixed(
                                    col,
                                    c(".induction", ".repression", "*"),
                                    c("*repression", "*induction", "."),
                                    vectorize_all = FALSE
                                )
                            )
                        ))
                , stringsAsFactors = FALSE)

            # Let individual simulator final adjustments after the processing step
            settingsTable <- adjustProfiles(sim, .Object, settingsTable, step = "Groups")

            return(settingsTable)
        }, simplify = FALSE))

        featuresAll <- sapply(profilesReg, function(simulatorProfiles) {

            test <- dplyr::select(simulatorProfiles, ID, dplyr::starts_with(("Effect.Group")))

            # nonDE.pos <- dplyr::select(simulatorProfiles, dplyr::starts_with(("Effect.Group"))) %>%
            #     pmap(~ all(is.na(.))) %>%
            #     unlist()
            #
            # nonDE.ids <- unique(simulatorProfiles$ID[nonDE.pos])

            nonDE.ids <- unique(dplyr::group_by(simulatorProfiles, ID) %>%
                                    dplyr::filter(all(is.na(Effect))) %>%
                                    dplyr::pull(ID))

            DE.ids <- setdiff(simulatorProfiles$ID, nonDE.ids)

            output <- list(
                "DE" = DE.ids,
                "nonDE" = nonDE.ids,
                "noiseNonDE" = sample(nonDE.ids, size = ceiling(length(nonDE.ids) * 0.05))
            )

            return(output)
        }, simplify = FALSE)

        featuresAll$SimRNAseq <- list(
            "DE" = sampleDE,
            "nonDE" = sampleNonDE,
            "noiseNonDE" = sample(sampleNonDE, size = ceiling(length(sampleNonDE) * 0.05))
        )

        # Expressed genes profiles (DE + NonDE)
        profilesReg$SimRNAseq <- profilesAll#profilesExpr

        # In case there are no times in exp design, change the initial count values between
        # samples on DE genes. The associated regulators must change as well,
        # depending on the linked effect.
        if (.Object@numberGroups > 1) {
            # Determine the rows with the same condition on all columns
            # Change only base count values when the profiles are flat on all conditions,
            # otherwise they are already DE genes.
            # sameCond <- apply(apply(dplyr::select(profilesDE, dplyr::starts_with("Group")), 2, '==', 'flat'), 1, all)
            sameCond <- dplyr::select(profilesDE, dplyr::starts_with("Group")) %>%
                purrr::map(`==`, 'flat') %>%
                purrr::pmap_lgl(all)

            # NULL by default
            FlatRNAseq <- NULL

            if ((nSameCount <- sum(sameCond))) {
                message(sprintf("Creating settings to change count values on %d DE genes with the same flat profile on all groups.", nSameCount))

                # Select ID, Group1-GroupN (remove DE -2nd- column)
                sameCondDE <- t(apply(profilesDE[sameCond, -c(2), drop = FALSE], 1, function(geneRow) {
                    # TODO: consider DE as one gene that changes in one condition compared to any of the others,
                    # or just consider the fist group as a reference?
                    #
                    # At this time exclude group 1 from being modified.

                    # Convert to character vector to avoid unexpected sample behaviour
                    # in case of only two groups
                    colChange <- sample(as.character(2:.Object@numberGroups), size = sample.int(.Object@numberGroups - 1, 1))

                    # Associate a trend to every group to change. If enhancer is set,
                    # the new generated count value will be higher than the original,
                    # and the opposite with repressor effect. This has nothing to do with
                    # regulator effects and are used only as indicators.
                    #
                    # Note: add 1 to the indexes because the first column is the gene ID
                    geneRow[as.numeric(colChange) + 1] <- sample(c('enhancer', 'repressor'), size = 1)

                    return(geneRow)
                }))

                FlatRNAseq <- data.frame(sameCondDE, stringsAsFactors = FALSE)
            }

            # Generate "FlatGroup" list for each regulator
            profilesReg$FlatGroups <- lapply(.Object@simulators[names(.Object@simulators) != 'SimRNAseq'], function(regulator) {
                # Skip if there aren't any flat DEG genes in gene expression
                if (is.null(FlatRNAseq))
                    return(NULL)

                profileSubsetID <- dplyr::rename(FlatRNAseq, Gene = ID) %>%
                    dplyr::inner_join(profilesReg[[class(regulator)]][, c('ID', 'Effect', 'Gene')], by = c("Gene" = "Gene")) %>%
                    dplyr::filter(! is.na(Effect)) %>% dplyr::select(ID)

                return(profileSubsetID)
            })

            profilesReg$FlatGroups$SimRNAseq <- FlatRNAseq
        }

        # Resolve references of profiles to proper values
        message("Finishing generation of configuration settings.")

        .Object@simSettings <- list(
            geneProfiles = profilesReg,

            geneSamples = list(
                DE = sampleDE,
                nonDE = sampleNonDE
            ),

            featureSamples = featuresAll,

            expDesign = list(
                times = .Object@times,
                numberReps = .Object@numberReps,
                numberGroups = .Object@numberGroups
            )
        )

        message("Configuration generated.\n")
    }

    return(.Object)
})

setMethod("simulate", signature="MOSimulation", function(object) {
    object@simulators <- sapply(object@simulators, simulate, object)

    # TODO: as a special-case omic, keep it here or move to a proper location?
    # Return TF <-> gene data
    if (! is.null(object@TFtoGene) && nrow(object@TFtoGene)) {

        tableTF <- object@TFtoGene

        # TF data (symbol -> geneTF)
        # Select only genes present in data
        expression.data <- object@simulators$SimRNAseq@simData
        expression.settings <- object@simSettings$geneProfiles$SimRNAseq
        expression.settings.flat <- object@simSettings$geneProfiles$FlatGroups$SimRNAseq

        tableTF.data <- unique(tableTF[, c("Symbol", "TFgene")])

        # Select the proper rows and change the rownames
        simDataTF <- expression.data[tableTF.data$TFgene, ]
        rownames(simDataTF) <- tableTF.data$Symbol

        # Generate the association

        # Symbol | LinkedGene | Effect | Effect.Group1 | ... | Effect.GroupX | Group1 | ... | GroupX
        message("Generating settings for TF based on gene expression settings...")

        settingsTF <- dplyr::inner_join(tableTF, expression.settings, by = c("TFgene" = "ID")) %>%
            dplyr::inner_join(expression.settings, by = c("LinkedGene" = "ID"), suffix = c(".TF", ".Gene")) %>%
            dplyr::left_join(expression.settings.flat, by = c("TFgene" = "ID")) %>%
            dplyr::left_join(expression.settings.flat, by = c("LinkedGene" = "ID"), suffix = c(".FlatTF", ".FlatGene")) %>%
            dplyr::select(ID = Symbol, Gene = LinkedGene, DE.TF, DE.Gene, dplyr::starts_with("Group")) %>%
            dplyr::mutate(Effect = NA)

        # Check effect for every group
        for (i in seq(object@numberGroups)) {

            # TF profile in this group
            TFprofile <- as.character(settingsTF[, sprintf("Group%d.TF", i)])

            # Linked genes profiles in this group
            GeneProfile <- as.character(settingsTF[, sprintf("Group%d.Gene", i)])

            # FLAT TF profile in this group
            flatTFprofile <- as.character(settingsTF[, sprintf("Group%d.FlatTF", i)])

            # FLAT Linked genes profiles in this group
            flatGeneProfile <- as.character(settingsTF[, sprintf("Group%d.FlatGene", i)])

            # Opposite effect of linked genes
            GeneProfile.rev <- stri_replace_all_fixed(
                GeneProfile,
                c(".induction", ".repression", "*"),
                c("*repression", "*induction", "."),
                vectorize_all = FALSE
            )

            # Assign the effect in the group
            settingsTF[, sprintf("Effect.Group%d", i)] <- ifelse(
                # For a proper effect, both genes (regulator and regulated)
                # must be DE
                ! (settingsTF$DE.TF & settingsTF$DE.Gene),
                NA,
                ifelse(
                    # If none of the genes are DE flat, check normally
                    (is.na(flatTFprofile) & is.na(flatGeneProfile)),
                    ifelse(
                        TFprofile == GeneProfile,
                        "enhancer",
                        ifelse(
                            TFprofile == GeneProfile.rev,
                            "repressor",
                            NA
                        )
                    ),
                    # If both genes are flat, check if the effect in the
                    # group is the same or not. Otherwise if one is flat
                    # and the other not, assign NA
                    ifelse(
                        # Both genes DE flat and the effect in the group is different than flat (that is,
                        # it does not change the original counts in that group, that is kept as reference)
                        ((! is.na(flatTFprofile)) & (! is.na(flatGeneProfile))) & flatTFprofile != "flat",
                        ifelse(
                            flatTFprofile == flatGeneProfile,
                            "enhancer",
                            "repressor"
                        ),
                        NA
                    )
                )
            )

            # For flat-flat profiles we also need to check the effect
            # in each group

            # Override the global "Effect" column if it has any effect
            settingsTF[, "Effect"] <- ifelse(
                is.na(settingsTF[, "Effect"]),
                      settingsTF[, sprintf("Effect.Group%d", i)],
                      settingsTF[, "Effect"]
            )
        }

        # Assign an effect
        settingsTF <- dplyr::select(settingsTF,
                                    ID, Gene, Effect,
                                    dplyr::starts_with("Effect"),
                                    dplyr::ends_with(".TF"))

        # Rename columns
        colnames(settingsTF) <- gsub(".TF", "", colnames(settingsTF))

        # Append empty tmax columns just for compatibility with the others
        settingsTF[, paste0("Tmax.Group", seq(object@numberGroups))] <- NA

        # Assign to the simulation object
        object@simSettings$geneProfiles$SimTF <- settingsTF

        # Clone the RNA-seq simulator then override some params
        TFobject <- object@simulators$SimRNAseq

        TFobject@idToGene <- tableTF[, c("Symbol", "LinkedGene")]
        colnames(TFobject@idToGene) <- c("ID", "Gene")

        TFobject@simData <- simDataTF
        TFobject@name <- "TF"
        TFobject@regulator <- TRUE

        class(TFobject) <- "SimTF"

        object@simulators$SimTF <- TFobject
    }

    return(object)
})


setMethod("show", signature="MOSimulation", function(object) {
    # TO DO: temp...
    simSettings(object)
})

setMethod("simSettings", signature="MOSimulation", function(object) {
    cat(sprintf("Simulation settings of class %s:\n", class(object)))
    cat(sprintf("- Default depth: %d\n", object@depth))
    cat(sprintf("- Total genes: %d\n", object@totalGenes))
    cat(sprintf("- Dif. expressed genes: %d\n", object@diffGenes))
    cat(sprintf("- Replicates: %d\n", object@numberReps))
    cat(sprintf("- Factor levels (groups): %d\n", object@numberGroups))
    cat(sprintf("- Time vector length: %d\n", length(object@times)))

    if (is.declared(object@simSettings)) {
        # Print anything else
    }
})

setValidity("MOSimulation", function(object) {
    # Initialize list of errors
    errors <- c()

    # Make sure the design allows DE genes
    if (length(object@times) < 2 && object@numberGroups < 2)
        errors <- c(errors, "The design must have a minimum of 2 times or 2 groups.")

    # Check that noiseParams has names
    if (is.declared(object@noiseParams) & is.null(names(object@noiseParams)))
        errors <- c(errors, "The 'noiseParams' parameter must be a named list.")

    # Convert the names of the simulators to the real classnames
    names(object@simulators) <- ifelse(startsWith(names(object@simulators), "Sim"),
                                       names(object@simulators),
                                       paste0("Sim", gsub("-", "", names(object@simulators)))
                                       )

    # Exclude those simulators already initialized
    simuInitialized <- sapply(object@simulators, inherits, what = "MOSimulator")

    # Simulators excluded from association checking (add RNA-seq)
    assocExcluded <- c(names(simuInitialized), "SimRNAseq")

    # If we provide real data it needs to be done for every loaded
    # simulator and also with the association list.
    dataProvided <- sapply(object@simulators, is.declared, key = "data")

    if (length(object@simulators) > 1) {
        # Check the provided association list. RNAseq is the only one with "NA" by default because
        # it doesn't need one.
        assocProvided <-
            sapply(object@simulators[! names(object@simulators) %in% assocExcluded], is.declared, key = 'idToGene')

        # Currently methylation does not accept custom data
        # TODO: rewrite this check to make it more general instead of relying on the simulator name.
        if ('SimMethylseq' %in% names(dataProvided) && dataProvided['SimMethylseq'] == TRUE)
            message("Currently there is no support for including custom methylation data. You need to provide the 'idToGene' slot, which will be used to retrieve the number and location of the CpGs.")

        # Remove Methylation simulator from the list and avoid checking the already
        # initialized simulators.
        dataProvided <- dataProvided[names(dataProvided) != 'SimMethylseq' &
                                         ! names(dataProvided) %in% names(simuInitialized)]

        # If at least one simulator has provided data, all of them must have
        # both data and association list.
        # Consider also the methylation simulation which can create its own data
        # using the association list.
        if (any(dataProvided, assocProvided) && ! all(assocProvided, dataProvided))
            errors <- c(errors, "If you provide an initial sample for one simulator, you need to do it for all the other ones, and include the association list as well.")
    }

    # Load default data if none is provided
    if (any(dataProvided)) {
        # Check that initial sample has only 1 column.
        # Skip initialized simulator.
        dataCheck <- sapply(object@simulators[! names(object@simulators) %in% names(simuInitialized)], function(sim) {
            # If provided, data should have only 1 column
            return(if (is.declared(sim, 'data')) ncol(sim$data) == 1 else TRUE)
        })

        # Check that every association list contains required columns
        assocCheck <-
            sapply(object@simulators[! names(object@simulators) %in% assocExcluded], function(sim, genes) {
                return(all(colnames(sim$idToGene) %in% c('ID', 'Gene')))
            }, genes = rownames(object@simulators[['SimRNAseq']]$data))

        if (! all(dataCheck, assocCheck))
            errors <- c(errors, "The initial sample data must have only 1 column with counts, and all association lists must contain genes present on RNA-seq data.")
    }

    return(if(length(errors)) errors else TRUE)
})

#' @import zoo
NULL

###############################################################################
#SIMULATED WGBS SEQUENCE DATA USING A HIERACHICAL HMM - Owen Rackham, MRC CSC #
###############################################################################
#This script is designed to be run using RScript from the terminal, it will   #
#produce a simulated dataset for WGBS containing 2 sample types WITH 3 reps.  #
#At present both this and the number of states in the HMM are fixed but v2    #
#will contain a multistate HMM for methylation status allowing smooth         #
#transition from methylated to de-methylated states as is seen in real data.  #
#particularly in the promoter region of genes. V2 will also allow you to set  #
#the number of sample types and the number of replicates in each case.        #
#for more information contact owen.rackham@imperial.ac.uk
###############################################################################

###############################################################################
#main body function which takes lots of params that control the simulated data#
###############################################################################

###############################################################################
# This function is implemented with required modifications on simulators/methyl-seq.R
###############################################################################

# generate_sim_set <- function(n,m,Pi_m,Pi_d,mean_m,mean_d,prob_m,prob_d,error_m,error_d,phase_diff,outfile,type_of_locations,number_of_replicas,number_of_samples,rates_for_HMM_for_CpG_locations,transition_size,balance,output_path,type){
#     #init_simulation <- function (theta,n_mean,n_standard_deviation,number_of_CpGs,probability_of_success_in_differentially_methylated_region,probability_of_success_in_non_differentially_methylated_region,error_rate_in_differentially_methylated_region,mean_number_of_reads_in_differentially_methylated_region,mean_number_of_reads_in_non_differentially_methylated_region,number_of_replicas,number_of_samples,phase_diff,balance,cpg_matrix,){
#
#     #pdf(paste(output_path,"data.pdf",sep=""))
#     #load required libraries
#     sink(file="/dev/null")
#     library(zoo)
#     library(HiddenMarkov)
#     sink()
#     #create a set of CpG locations
#     locs<-create_simulated_locations(n,Pi_m,rates_for_HMM_for_CpG_locations)
#
#     #simulate the state transition based on the location of the CpGs
#     a<-simulate_state_transition((n*m),c(0.01,0.99,0.08,0.99),locs,0.5,transition_size)
#
#     #extract the postions of the blocks
#     state_blocks<-find_the_blocks(a)
#
#     #set the percentage of DM in each block type
#     percs_for_diff<-c(0,0,0,0.5)
#
#     #update the blocks to be differentially methylated
#     diff_methed <- make_differential(state_blocks,percs_for_diff,a)
#
#     #create the simulated reads methylated/unmethylated at each CpG, at the moment this is hard coded to be 3 replicates of each type
#     #The phase diff param control how different the methylation is in the differentially methylated regions.
#     ds <- (number_of_replicas*number_of_samples)*4
#     d <- matrix(data=0,nrow=ds,ncol=n)
#     idx <- -(number_of_replicas*4) + 1
#     #prob_d_mod<-hypo_hyper(prob_d,phase_diff[2],a,balance)
#     prob_d_mod<-hypo_hyper_diffs(prob_d,phase_diff[2],diff_methed,balance)
#     prob_m_mod<-hypo_hyper_diffs(prob_m,phase_diff[2],diff_methed,balance)
#     hist(prob_d_mod,main="prob_d_mod")
#     #prob_d_nonmod<-hypo_hyper(prob_d,phase_diff[1],a,balance)
#     prob_d_nonmod<-hypo_hyper_diffs(prob_d,phase_diff[1],diff_methed,balance)
#     prob_m_nonmod<-hypo_hyper_diffs(prob_m,phase_diff[1],diff_methed,balance)
#     hist(prob_d_nonmod,main="prob_d_nonmod")
#     probs<-list()
#     probs[[1]]<-list(prob_m_mod,((prob_m_nonmod+prob_d_nonmod)/2),prob_d_mod,((prob_m_mod+prob_d_mod)/2))
#     probs[[2]]<-list(prob_m_nonmod,((prob_m_nonmod+prob_d_nonmod)/2),prob_d_nonmod,((prob_m_nonmod+prob_d_nonmod)/2))
#     errors<-list(error_m,((error_d+error_m)/2),error_d,((error_d+error_m)/2))
#     means<-list(mean_m,((mean_d+mean_m)/2),mean_d,((mean_d+mean_m)/2))
#
#
#     write("\nCreating the simulated dateset.\n",stderr())
#     pb <- txtProgressBar(style=3)
#     for(i in 1:number_of_samples){
#         idx <- idx + (4*number_of_replicas)
#         for(j in 1:number_of_replicas){
#             index <- ((i-1)*number_of_replicas)+j
#             setTxtProgressBar(pb, (index/(number_of_replicas*number_of_samples)))
#             idx_rep <- idx + (j*4) - 4
#             #d[idx_rep:(idx_rep+3),] <- generate_replicat_methyl_nbin_data(a,probs,means,0,errors,locs,i)
#             if(type=='binomial'){
#                 d[idx_rep:(idx_rep+3),] <- generate_replicat_methyl_bin_data(a,probs,means,0,errors,locs,i,output_path)
#             }else if(type=='truncated'){
#                 d[idx_rep:(idx_rep+3),] <- generate_replicat_methyl_truncated_nbin_data(a,probs,means,0,errors,locs,i,20,output_path)
#             }else{
#                 d[idx_rep:(idx_rep+3),] <- generate_replicat_methyl_nbin_data_model_3(a,probs,means,0,errors,locs,i,30)
#             }
#             if((i == 1)&&(j==1)){
#                 plot(locs,d[(idx_rep+3),],col=i,type='b',ylim=c(0,1),pch=diff_methed+1)
#             }else{
#                 lines(locs,d[(idx_rep+3),],col=i,type='b',pch=diff_methed+1)
#             }
#         }
#     }
#     d<-rbind(locs,diff_methed,d)
#     #wrap up the simulated data into a single variable
#     #transpose
#     d<-t(d)
#     outname <- paste(c(outfile, n,m,Pi_m,Pi_d,mean_m,mean_d,prob_m,prob_d,error_m,error_d,phase_diff[1],phase_diff[2],balance,".txt"), collapse = "_")
#     #write to file
#     write.table(d,outname, row.names = F,quote=F,sep = "\t")
#     dev.off()
#     return(list(locs,d,outname))
#
# }


###############################################################################
#find the  start and end of the blocks in a vector of states                  #
###############################################################################
find_the_blocks<-function(a){
    l<-length(a)
    coords<-list()
    index<-1
    state<-a[1]
    on<-1
    off<-0
    for(i in 2:l){
        if(a[i-1] != a[i]){
            if(on == 0){
                on<-i
            }else{
                off<-i
                coords[[index]]<-c(on,off,a[i],off-on)
                index<-index+1
                on<-i
                off<-0
            }
        }
    }
    coords_mat <- do.call(rbind,coords)
    return(coords_mat)
}

###############################################################################
#make differentially expressed by picking a preset amount of each state type  #
###############################################################################
make_differential<-function(state_blocks,percentage,a){
    l<-length(a)
    states<-unique(state_blocks[,3])
    n <-length(states)
    diff_meth <- matrix(data=0,nrow=1,ncol=l)
    for(i in seq_len(n)){
        blocks <- state_blocks[state_blocks[,3]==i,]
        # MOD: sum only if it's matrix
        block_length <- if(is.null(dim(blocks))) blocks[4] else sum(blocks[,4])
        cutoff_length <- percentage[i]*block_length
        so_far <- 0
        while((so_far <= cutoff_length)&&!is.null(dim(blocks)[1])){
            picked<- sample(seq_len(dim(blocks)[1]), 1)
            if(so_far+blocks[picked,4] < cutoff_length){
                so_far <- so_far + blocks[picked,4]
                diff_meth[blocks[picked,1]:blocks[picked,2]]<-1
            }
            blocks<- blocks[-(picked),]
        }
    }
    return(diff_meth)
}






###############################################################################
#Alter demethylated probs to be beta distributed                              #
###############################################################################
create_beta_probs<-function(a,prob_m,prob_d){
    l<-length(a)
    probs <- matrix(data=0,nrow=1,ncol=l)
    probs[1]<-trun_beta_probs(prob_m,prob_d)

    for(i in 2:l){
        if(a[i-1]==a[i]){
            probs[i] <- probs[i-1]
        }else{
            probs[i] <- trun_beta_probs(prob_m,prob_d)
        }
    }
    return(probs)
}

###############################################################################
#rbeta but not 0 or 1                              #
###############################################################################
trun_beta_probs<-function(prob_m,prod_d){


    a<-stats::rbeta(1,0.4,0.4)
    if(a<prod_d){
        a<-prod_d
    }
    if(a>prob_m){
        a<-prob_m
    }

    return(a)
}

###############################################################################
#Create the CpG locations                                                     #
###############################################################################
# create_simulated_locations<-function(n,Pi,rates_for_HMM_for_CpG_locations, seed = NULL){
#
#     #set up the variables
#     delta <- c(0, 1)
#
#     #create a HMM model that will simulate the gaps between CpGs. it is a 2 state HMM
#     #in order to simulate CpG islands and CpG deserts. TODO: multistates for CpG shores
#     #,cliffs etc etc etc to be added later.
#     x <- dthmm(NULL, Pi, delta, "exp", list(rate=rates_for_HMM_for_CpG_locations))
#
#     #simulate this HMM for n steps
#     # MODIFIED: call simulate.dthmm function directly
#     x <- HiddenMarkov:::simulate.dthmm(x, nsim=n, seed=seed)
#
#     #extract the length
#     l<-length(x$x)
#
#     #initialise a matrix to store the results
#     locs <- matrix(data=1,nrow=1,ncol=l)
#
#     #loop over the simulated output and create the locations
#     for(i in 2:l){
#         locs[i]<-round(locs[i-1]+x$x[i])+1
#     }
#
#     return(locs)
# }

###############################################################################
#Randomly create hyper/hypo methylation                                       #
###############################################################################
hypo_hyper<-function(prob_m,phase_diff,states,split){
    l<-length(states)
    current_state<-states[1]
    pos<-0
    neg<-0
    prob_m_mod <- matrix(data=prob_m[1],nrow=1,ncol=l)

    if(length(prob_m) > 1){
        multiply<-plus_minus(split,phase_diff,prob_m[1])
    }else{
        multiply <- plus_minus(split,phase_diff,prob_m)
    }

    for(i in 2:l){
        if((states[i]==2)&(current_state==1)){
            if(length(prob_m) > 1){
                multiply<-plus_minus(split,phase_diff,prob_m[i])
            }else{
                multiply <- plus_minus(split,phase_diff,prob_m)
            }
        }
        prob_m_mod[i] <-  multiply
        current_state<-states[i]
    }

    return(prob_m_mod)

}


###############################################################################
#Randomly create hyper/hypo methylation                                       #
###############################################################################
hypo_hyper_diffs<-function(prob_m,phase_diff,states,split){
    l<-length(states)
    current_state<-states[1]
    pos<-0
    neg<-0
    prob_m_mod <- matrix(data=prob_m[1],nrow=1,ncol=l)


    if(length(prob_m) > 1){
        multiply<-plus_minus(split,phase_diff,prob_m[1])
    }else{
        multiply <- plus_minus(split,phase_diff,prob_m)
    }

    for(i in 2:l){
        if((states[i]==1)&(current_state==0)){
            multiply <- plus_minus(split,phase_diff,prob_m)
        }
        if(states[i]==1){
            prob_m_mod[i] <-  multiply
        }
        current_state<-states[i]
    }

    return(prob_m_mod)

}

###############################################################################
#Randomly choose plus or minus                                                #
###############################################################################
plus_minus<-function(split,phase_diff,prob_m){
    if(stats::runif(1, 0, 1) >= split){
        mod_phase_diff <- phase_diff

        multiply <- prob_m+mod_phase_diff

        if(multiply > 1){
            multiply <- prob_m-mod_phase_diff
        }
    }else{


        mod_phase_diff <- phase_diff
        multiply <- prob_m-mod_phase_diff
        if(multiply < 0){
            multiply <- prob_m+mod_phase_diff
        }
    }

    return(multiply)
}

###############################################################################
#Create file from real data set                                               #
###############################################################################
# create_real_data<-function(filename,number_of_samples,number_of_replicas){
#     #set up the variables
#     delta <- c(0, 1)
#     #create a HMM model that will simulate the gaps between CpGs. it is a 2 state HMM
#     #in order to simulate CpG islands and CpG deserts. TODO: multistates for CpG shores
#     #,cliffs etc etc etc to be added later.
#     x <- HiddenMarkov::dthmm(NULL, Pi, delta, "exp", list(rate=rates_for_HMM_for_CpG_locations))
#     #simulate this HMM for n steps
#     # MODIFIED: call simulate.dthmm function directly
#     x <- HiddenMarkov:::simulate.dthmm(x, nsim=n)
#     #extract the length
#     l<-length(x$x)
#     #initialise a matrix to store the results
#     locs <- matrix(data=1,nrow=1,ncol=l)
#     #loop over the simulated output and create the locations
#     for(i in 2:l){
#         locs[i]<-round(locs[i-1]+x$x[i])+1
#     }
#     return(locs)
# }

###############################################################################
#add a random fluctuation to probability of success                           #
###############################################################################
add_random_noise <- function (theta,n_mean,n_standard_deviation){

    #create the delta value with defined mean and standard deviation
    delta <- stats::rnorm(1, mean = n_mean, sd = n_standard_deviation)
    theta_bar <-0


    if(theta<=0){
        theta<-0.0000000000001
    }
    if(theta>=1){
        theta<-0.9999999999999
    }
    #convert theta to theta_bar based on the delta value calculated above.
    theta_bar <-exp(log(theta/(1-theta))+delta)/(1+exp(log(theta/(1-theta))+delta))

    #convert 0 and 1s
    if(theta_bar>=1){theta_bar<-0.9999999999999}
    if(theta_bar<=0){thata_bar<-0.0000000000001}
    return(theta_bar)
}


###############################################################################
#read a text from the command line                                        #
###############################################################################
get_text <- function (message,default){
    #print the prompt to the command line
    cat(message)
    #capture the user input from stdin
    variable <- readLines(con="stdin", 1)
    #if the user doesn't anything then use the default value
    if(variable == ''){
        variable <- default
    }
    return(variable)
}

###############################################################################
#initiate the function based on args                                          #
###############################################################################
# init_simulation <- function (number_of_CpGs,probability_of_success_in_differentially_methylated_region,probability_of_success_in_non_differentially_methylated_region,error_rate_in_differentially_methylated_region,error_rate_in_non_differentially_methylated_region,mean_number_of_reads_in_differentially_methylated_region,mean_number_of_reads_in_non_differentially_methylated_region,number_of_replicas,number_of_samples,phase_diff,balance,cpg_matrix,output_path,type){
#     #get the variables from the command line
#
#     phase_difference_between_two_samples <- c(0,phase_diff)
#
#
#     #error_rate_in_differentially_methylated_region <- 0.1
#
#     file_to_write_results_to <- output_path
#     probs <- c(1,1,0.9,0.8,0.7,0.6)
#
#
#     transition_size <- 0
#     #####probably not set by the user
#     number_of_repeats <- 1
#     transition_matrix_for_CpG_locations <-matrix(c(0.65, 0.35,0.2, 0.8),byrow=TRUE, nrow=2)
#     transition_matrix_for_probability_distributions <- matrix(c(0.9,0.1,0.1,0.9),byrow=TRUE, nrow=2)
#     type_of_locations <- 2
#
#     #run the simulation script
#     simulated_data <-generate_sim_set(number_of_CpGs,
#                                       number_of_repeats,
#                                       transition_matrix_for_CpG_locations,
#                                       transition_matrix_for_probability_distributions,
#                                       mean_number_of_reads_in_differentially_methylated_region,
#                                       mean_number_of_reads_in_non_differentially_methylated_region,
#                                       probability_of_success_in_differentially_methylated_region,
#                                       probability_of_success_in_non_differentially_methylated_region,
#                                       error_rate_in_differentially_methylated_region,
#                                       error_rate_in_non_differentially_methylated_region,
#                                       phase_difference_between_two_samples,
#                                       file_to_write_results_to,
#                                       type_of_locations,
#                                       number_of_replicas,
#                                       number_of_samples,
#                                       cpg_matrix,
#                                       transition_size,
#                                       balance,
#                                       output_path,
#                                       type
#     )
#     #run the summary script
#     summarise_simulated_data(simulated_data,number_of_replicas,number_of_samples)
#
#     filename<-simulated_data[[3]]
#
#     return(filename)
# }


###############################################################################
#Function to summarise the  data from the simulation. This should show: 1)    #
#distribution of methlated/unmethylated sites 2) distribution of distances    #
#between CpGs 2) Distribution of the size of differentially methylated regions#
# 3) Distribution of read counts 4)
###############################################################################
# summarise_simulated_data <- function(generated_set,number_of_replicas,number_of_samples){
#     #define the layout of the figures (actually has no effect when saving to pdf)
#     mat <- matrix(1:6, 2, 3)
#     layout(mat)
#     #take the name from the simulated set and append the pdf extension
#     outname <- generated_set[[3]]
#     pdf(paste(outname,".pdf",sep=""))
#     #create the graphs
#     read_count_distribution(generated_set,number_of_replicas,number_of_samples)
#     methylation_distribution(generated_set,number_of_replicas,number_of_samples)
#     distance_distribution(generated_set)
#     dmr_size(generated_set)
#     methylation_postions(generated_set)
#     dev.off()
# }
###############################################################################
#Distribution of proportion of methylation                                    #
###############################################################################
# methylation_distribution <- function(generated_set,number_of_replicas,number_of_samples){
#     #calcualte the proportion of methylated vs demethylated reads in each replicate
#     #and plot the valus as a histogram
#
#     for(i in 1:number_of_samples){
#         for(j in 1:number_of_replicas){
#             col <- (((i-1)*(number_of_replicas*4))+((j-1)*4)+1)+2
#             hist(generated_set[[2]][,col]/generated_set[[2]][,col+1],col=rgb(0,0,0,0.2),ylab="frequency",xlab="proportion of methylated CpGs",main="histogram of methylation proportion")
#         }
#     }
# }

###############################################################################
#CpG locations on a line                                                      #
###############################################################################
# methylation_postions <- function(generated_set){
#     #plot the location of each CpG as a transparent bar on a line
#     plot(generated_set[[2]][,1],matrix(data=1,ncol=1,nrow=length(generated_set[[2]][,1])),pch='|',col=rgb(0,0,0,0.01),ylab="",xlab="location",yaxt='n', ann=FALSE)
#
# }
###############################################################################
#Distribution of distance between sites                                       #
###############################################################################
# distance_distribution <- function(generated_set){
#     #get the number of CpGs
#     CpG_length <- length(generated_set[[2]][,1])
#     #initialise a matrix to store the lengths in
#     length_set <- matrix(data=0,nrow=6,ncol=CpG_length)
#     #loop through and save the lengths between each site
#     for (i in 2:CpG_length){
#         length_set[1,i]<-generated_set[[2]][i,1]-generated_set[[2]][i-1,1]
#     }
#     #plot the distribution
#     hist(length_set[1,],col=rgb(1,0,0,0.2),breaks=100,ylab="frequency",xlab="coverage",main="histogram of distances between CpGs")
# }
###############################################################################
#Distribution of size of differentially methylated regions                    #
###############################################################################
# dmr_size <- function(generated_set){
#     #get the number of CpGs
#     CpG_states <- length(generated_set[[2]][,2])
#     #initialise a matrix to store the
#     length_set <- matrix(data=NA,nrow=6,ncol=CpG_states)
#     #initialise a variable to store the number of CpGs in each state
#     counter <- 1
#     #initialise a variable with the first state
#     previous <- generated_set[[2]][1,2]
#     #loop through all states and store the counter variable each time the state
#     #changes.
#     for (i in 2:CpG_states){
#         if(previous == generated_set[[2]][i,2]){
#             counter <- counter + 1
#         }else{
#             counter <- counter + 1
#             length_set[i] <- counter
#             counter <- 1
#             previous <- generated_set[[2]][i,2]
#         }
#     }
#     #plot the distribution
#     hist(length_set,breaks=100,ylab="frequency",xlab="size of DMR",main="histogram of DMR sizes")
# }
###############################################################################
#Distribution of read counts                                                  #
###############################################################################
# read_count_distribution <- function(generated_set,number_of_replicas,number_of_samples){
#     #plot a histogram for each read count set.
#     for(i in 1:number_of_samples){
#         for(j in 1:number_of_replicas){
#             col <- ((i-1)*(number_of_replicas*4))+((j-1)*4)+2
#
#             hist(as.numeric(generated_set[[2]][,col+2]),col=rgb(1,0,0,0.2),ylab="frequency",xlab="coverage",main=paste("histogram of simulation read counts ",col))
#
#         }
#     }
# }
###############################################################################
#Simple function which reduces the probability of changing state based on the #
#distance between two CpGs.                                                   #
###############################################################################
reduce_by_distance <- function (x,b){
    #given a value and decay value decrease a value by the the decay function.
    y <- exp(b * log(x))
    return(y)
}

###############################################################################
#Simple function which takes a comma seperated list and converts it into a    #
#square matrix for use as a transition matirx in the HMM package              #
###############################################################################
convert_to_matrix <- function (x){
    #split the string by commas
    list <- unlist(strsplit(x, split=","))
    size <- sqrt(length(list))
    mat <- matrix(list,byrow=TRUE, nrow=size)
    mode(mat) <- "numeric"
    return(mat)
}

###############################################################################
#Simple function which takes a comma seperated list and converts it into a    #
#array for use as a transition matirx in the HMM package              #
###############################################################################
convert_to_array <- function (x){
    #split the string by commas
    list <- unlist(strsplit(x, split=","))
    size <- sqrt(length(list))
    mode(list) <- "numeric"
    return(list)
}

###############################################################################
#This function simulates the transitions from non and differentially methyd   #
#states. It requires n = the number of CpG, Pi = probability of changing state#
#, locs = the postion of the CpGs and start which is the initial starting prob#
# TO DO:                                                                      #
#At the moment the reduction by space is using the hard coded parameter       #
#-3.895e-02 but this should be updated in the future and helper function to   #
#calculate it from the data should be written                                 #
###############################################################################
simulate_state_transition <- function (n,Pi,locs,start,transition_size){
    #initially set the current state to 2
    trans_up <- seq(from = 3, to = transition_size+2)
    trans_down <- seq(from = transition_size+2, to = 3)
    current_state<-2
    #randomly reassign based the on the start probability
    if(stats::runif(1,0,1)<start){
        current_state<-1
    }
    #declare the variables
    state_transition <- matrix(data=1,nrow=1,ncol=n)
    prob_transition <- matrix(data=0,nrow=1,ncol=n)
    dist_transition <- matrix(data=0,nrow=1,ncol=n)

    #set the first state as that calculated above
    state_transition[1]<-current_state

    #loop through all of the CpGs
    i <- 2
    issue <- 0;
    while(i < length(state_transition)){
        #calculate the distance from the previous CpG
        dist<-locs[i]-locs[i-1];
        #store the distance
        dist_transition[i]<-dist
        #calcualte the probability of changing state based on the distance
        prob<-Pi[current_state]*reduce_by_distance(dist,-1.895e-02)
        #store the value
        prob_transition[i]<-prob
        #randomly sample to see if the state should change
        if(stats::runif(1,0,1)<prob){
            #if no: then save the current
            if(current_state < 4){
                current_state<-current_state+1
                state_transition[i]<-current_state
            }else{
                current_state<-1
                state_transition[i]<-current_state
            }
        }
        state_transition[i]<-current_state
        i <- i +1
    }
    #return this value
    return(state_transition)
}


###############################################################################
#This function takes the CpG locations and state transitions and produces the #
#simulated read counts at each location. The function requires: states = the #
#progression of states for each CpG, prob_m the probability of success in the #
#not differentially methylated state, prob_d = probability of success in the #
#differentially methylated state, mean_m = the mean in the non differentially #
#state, mean_d = the mean in the differentially methylated state, s = ?, error#
#_m/d is the error sd, locs is the location of the CpGs. #
###############################################################################
# generate_replicat_methyl_oldbin_data <-function (states,prob_m_a,prob_d,mean_m,mean_d,s,error_m,error_d,locs){
#     #calculate the number of sites
#     l<-length(states);
#     #create a vector of coverage for the non_diffs
#     coverages<-list()
#     for (s in 1:4){
#         coverages[[s]]<-stats::rpois(l, means[[s]])+1
#     }
#     #create a vecotr of coverage for the diffs
#     #set the coverage to the meth vector
#     coverage <- coverages[[1]]
#     #initialse the vectors
#     all_data <- matrix(data=0,nrow=1,ncol=l)
#     #prob_m_s = prob_m_a
#     #prob_d = matrix(data=prob_d,nrow=l,ncol=1)
#     #loop through and add random noise the probs of success
#     for (s in 1:4){
#         for (i in 1:l){
#             probs[[j]][[s]][i]<- add_random_noise(probs[[j]][[s]][i],0,errors[[s]])
#         }
#     }
#     #loop through and add random noise the probs of success
#     for (i in 1:l){
#         prob_m_s[i]<- add_random_noise(prob_m_s[i],0,error_m)
#     }
#     for (i in 1:l){prob_d[i]<- add_random_noise(prob_d[i],0,error_d)}
#     #loop through and simulate the number of methylated reads at each site
#     for(i in 1:l){
#         if(states[i]==1){
#             c<-stats::rbinom(1, coverage_m[i], prob_m_s[i])
#             #c<-rbinom(1, coverage_d[i], probs[states[i]])
#             all_data[i]<-c
#             coverage[i]<-coverage_m[i]
#         }else{
#             c<-rbinom(1, coverage_d[i], prob_d[i])
#             all_data[i]<-c
#             coverage[i]<-coverage_d[i]
#         }
#     }
#     pos <- locs
#     #create one variable to return
#     proportion <- all_data/coverage;
#     final_store<-rbind(all_data,coverage,coverage,proportion)
#     rownames(final_store)<-c("x","n","coverage","proportion")
#     return(final_store)
# }

generate_replicat_methyl_bin_data <-function (states,probs,means,s,errors,locs,j,output_path){
    #calculate the number of sites
    l<-length(states);
    #create a vector of coverage for the non_diffs
    coverages<-list()
    for (s in seq_len(4)){
        coverages[[s]]<-stats::rpois(l, means[[s]])+1
        #coverages[[s]]<-rep(100,l)
    }
    #create a vecotr of coverage for the diffs
    #set the coverage to the meth vector
    coverage <- coverages[[1]]
    #initialse the vectors
    all_data <- matrix(data=0,nrow=1,ncol=l)
    prs <- matrix(data=0,nrow=1,ncol=l)
    #prob_m_s = prob_m_a
    #prob_d = matrix(data=prob_d,nrow=l,ncol=1)
    #loop through and add random noise the probs of success
    for (s in seq_len(4)){
        for (i in seq_len(l)){
            probs[[j]][[s]][i]<- add_random_noise(probs[[j]][[s]][i],0,errors[[s]])
        }
        #hist(probs[[j]][[s]],main=paste("histogram of probs in state",s))
    }
    mt <- list()
    for(s in seq_len(4)){
        sj<-stats::rbinom(l, coverages[[s]], probs[[j]][[s]])
        #hist(sj,main=paste("histogram of sj in state",s))
        mt[[s]]<-sj
    }

    #loop through and simulate the number of methylated reads at each site
    for(i in seq_len(l)){
        c<-mt[[states[i]]][i]
        all_data[i]<-c
        coverage[i]<-coverages[[states[i]]][i]
        prs[i]<-probs[[j]][[states[i]]][i]
    }
    pos <- locs
    #create one variable to return
    proportion <- all_data/coverage;
    #hist(prs,main=paste("histogram of propotion gdgdfgf"))
    final_store<-rbind(all_data,coverage,coverage,proportion)
    #plot(proportion[1:1000],main="methylation profile")
    rownames(final_store)<-c("x","n","coverage","proportion")

    return(final_store)

}



###############################################################################
#This function takes the CpG locations and state transitions and produces the #
#simulated read counts at each location. The function requires: states = the  #
#progression of states for each CpG, prob_m the probability of success in the #
#not differentially methylated state, prob_d = probability of success in the  #
#differentially methylated state, mean_m = the mean in the non differentially #
#state, mean_d = the mean in the differentially methylated state, s = ?, error#
#_m/d is the error sd, locs is the location of the CpGs.                      #
###############################################################################
generate_replicat_methyl_nbin_data_model_3 <-function (states,probs,means,s,errors,locs,j,size){
    #calculate the number of sites
    l<-length(states);
    #create a vector of coverage for the non_diffs
    coverages<-list()
    for (s in seq_len(4)){
        coverages[[s]]<-stats::rpois(l, means[[s]])+1
    }
    #create a vecotr of coverage for the diffs
    #set the coverage to the meth vector
    #initialse the vectors
    all_data <- matrix(data=0,nrow=1,ncol=l)
    coverage <- matrix(data=0,nrow=1,ncol=l)
    #prob_m_s = prob_m_a
    #prob_d = matrix(data=prob_d,nrow=l,ncol=1)
    #loop through and add random noise the probs of success
    for (s in seq_len(4)){
        for (i in seq_len(l)){
            probs[[j]][[s]][i]<- add_random_noise(probs[[j]][[s]][i],0,errors[[s]])
        }
    }
    mt <- list()
    for(s in seq_len(4)){
        sj<-stats::rbinom(l, coverages[[s]], probs[[j]][[s]])
        coverages[[s]]<-ceiling((sj+1) / probs[[j]][[s]])
#         hist(sj,main=paste("histogram of sj in state",s))
#         hist(coverages[[s]],main=paste("histogram of coverage in state",s))
        mt[[s]]<-sj
    }

    #loop through and simulate the number of methylated reads at each site
    for(i in seq_len(l)){
        c<-mt[[states[i]]][i]
        all_data[i]<-c
        coverage[i]<-coverages[[states[i]]][i]
    }
    pos <- locs
    #create one variable to return
    proportion <- all_data/coverage;
    #plot(proportion[1:1000],main="methylation profile")
    final_store<-rbind(all_data,coverage,coverage,proportion)
    rownames(final_store)<-c("x","n","coverage","proportion")

    return(final_store)

}

###############################################################################
#This function takes the CpG locations and state transitions and produces the #
#simulated read counts at each location. The function requires: states = the  #
#progression of states for each CpG, prob_m the probability of success in the #
#not differentially methylated state, prob_d = probability of success in the  #
#differentially methylated state, mean_m = the mean in the non differentially #
#state, mean_d = the mean in the differentially methylated state, s = ?, error#
#_m/d is the error sd, locs is the location of the CpGs.                      #
###############################################################################
generate_replicat_methyl_truncated_nbin_data <-function (states,probs,means,s,errors,locs,j,size,output_path){
    #calculate the number of sites
    l<-length(states);
    #create a vector of coverage for the non_diffs

    #create a vecotr of coverage for the diffs
    #set the coverage to the meth vector
    #initialse the vectors
    all_data <- matrix(data=0,nrow=1,ncol=l)
    coverage <- matrix(data=0,nrow=1,ncol=l)
    coverages<-list()
    prs <- matrix(data=0,nrow=1,ncol=l)
    #prob_m_s = prob_m_a
    #prob_d = matrix(data=prob_d,nrow=l,ncol=1)
    #loop through and add random noise the probs of success
    for (s in seq_len(4)){
        for (i in seq_len(l)){
            probs[[j]][[s]][i]<- add_random_noise(probs[[j]][[s]][i],0,errors[[s]])
        }
    }


    mt <- list()
    for(s in seq_len(4)){
        sj <- matrix(data=0,nrow=1,ncol=l)
        coverages[[s]]<-matrix(data=0,nrow=1,ncol=l)
        for(i in seq_len(l)){
            a<-means[[s]]*probs[[j]][[s]][i]*(probs[[j]][[s]][i]/(1-probs[[j]][[s]][i]))
            b<-(1-probs[[j]][[s]][i])/probs[[j]][[s]][i]
            N <- stats::rpois(1,means[[s]])
            coverages[[s]][i]<-N
            repeat{
                lambda_j <- stats::rgamma(1,shape = a,scale=b)
                x<-stats::rpois(1,lambda_j)

                if(x<=N){
                    sj[i]<-x

                    break
                }

            }
        }
        mt[[s]]<-sj
    }

    #loop through and simulate the number of methylated reads at each site
    for(i in seq_len(l)){
        c<-mt[[states[i]]][i]
        all_data[i]<-c
        coverage[i]<-coverages[[states[i]]][i]
        prs[i]<-probs[[j]][[states[i]]][i]
    }
    pos <- locs
    #create one variable to return
    proportion <- all_data/coverage;
    final_store<-rbind(all_data,coverage,coverage,proportion)
    rownames(final_store)<-c("x","n","coverage","proportion")
    #plot(proportion[1:1000],main="methylation profile")
    #save(prs,file=paste0(output_path,"_probabilities_",j,".RData"))
    return(final_store)

}

#' @include AllGeneric.R
#' @importFrom rlang .data
NULL

#' @rdname Generics
#' @noRd
setMethod("initialize", signature="MOSimulator", function(.Object, ...) {
    .Object <- callNextMethod(.Object, ...)

    # Casting to dataframe
    .Object@idToGene <- as.data.frame(.Object@idToGene, stringsAsFactors = FALSE)
    .Object@data <- as.data.frame(.Object@data, stringsAsFactors = FALSE)

    # Convert data frames to characters or numbers
    .Object@idToGene[] <- lapply(.Object@idToGene, as.character)
    .Object@data[] <- lapply(.Object@data, as.numeric)

    return(.Object)
})

#' initializeData
#'
#' Generates the initial sample of data. It copies the initial data for every
#' group of the experimental design, and ensures to change the count values
#' for those genes (and associated regulators with an active effect on it)
#' that are marked as DE with only flat profiles in all groups.
#'
#' @param object Instance of \linkS4class{MOSimulator} class.
#' @param simulation Initialized instance of \linkS4class{MOSimulation} class
#'
#' @return An object of class \linkS4class{MOSimulator} with the @data slot filled
#' with the correct initial data structure and values.
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("initializeData", signature="MOSimulator", function(object, simulation) {

    # Adjust sequencing depth
    object@depth <- object@depth*10^6

    if (! is.declared(object@data)) {
        stop(sprintf("Data not declared on simulator %s.", object@name))
    }

    # Adjust counts to depth
    object@data$Counts <- object@depth * object@data$Counts / sum(object@data$Counts)

    # Set min/max values based on provided data
    object@min <- min(object@data)
    object@max <- max(object@data)

    nonzero.org.counts <- object@data[object@data > 0]
    no.outliers.counts <- object@data[object@data < stats::quantile(object@data$Counts, c(0.99))]
    min.value.nonzero <- stats::quantile(nonzero.org.counts, simulation@minMaxQuantile[1])

    dataPerc <- stats::quantile(nonzero.org.counts, object@minMaxQuantile)

    range.no.outliers <- range(no.outliers.counts)
    minDE.value <- stats::quantile(nonzero.org.counts, c(simulation@minMaxQuantile[1]))
    maxDE.value <- stats::quantile(nonzero.org.counts, c(simulation@minMaxQuantile[2]))
    maxDE.value <- max(no.outliers.counts)


    # TODO: this might fail when data does have more than one column (pregenerated?)
    object@minMaxDist <- list(
        "min" = dataPerc[1],
        "max" = dataPerc[2],
        "minDE" = minDE.value,
        "maxDE" = maxDE.value,
        "minValue" = min.value.nonzero
    )

    # Generate a random counts series
    omicSettings <- simulation@simSettings$geneProfiles[[class(object)]]

    featureSamples <- simulation@simSettings$featureSamples[[class(object)]]

    featuresDE <- featureSamples$DE

    features.Flat <- simulation@simSettings$geneProfiles$FlatGroups[[class(object)]]$ID

    featuresDE.notFlat <- setdiff(featuresDE, features.Flat)

    featuresNONDE <- featureSamples$nonDE

    featuresNonDE.noised <- featureSamples$noiseNonDE

    featuresNONDE.diff <- setdiff(featuresNONDE, featuresNonDE.noised)

    object@randData <- sample(object@data$Counts)
    names(object@randData) <- rownames(object@data)

    # Adjust randomCounts to depth
    # object@randData <- object@depth * object@randData / sum(object@randData)

    swapCountValues <- function(countVector, idsToChange, idsNonDE, meanValue, operation = NULL) {
        # Select non-DE IDs to swap. Select the maximum amount available
        swapID <- sample(as.character(idsNonDE),
                         size = min(length(idsToChange), length(idsNonDE)),
                         replace = FALSE)

        # Take a sample to replace
        swapID.bad <- sample(as.character(idsToChange),
                             size = length(swapID),
                             replace = FALSE)

        # Good values to use
        swapValues <- countVector[swapID]

        # Set bad values into the Non-DE features
        countVector[swapID] <- countVector[swapID.bad]

        # Assign good values to DE features
        countVector[swapID.bad] <- swapValues

        # In case any value has not been changed due to
        # not having enough replacement values, use random distribution.
        remainingIds <- setdiff(idsToChange, swapID.bad)

        if (length(remainingIds)) {
            countVector[remainingIds] <- stats::rnorm(n = length(remainingIds),
                                                             mean = meanValue,
                                                             sd = 1)
        }

        return(countVector)
    }

    swapCountValuesDiff <- function(countVector, initialVector, idsToChange, nonDEIds, limitMax, limitMin, limit, absMaxLimit, absMinLimit) {

        if (length(idsToChange)) {
            minorCounts <- setNames(pmin(initialVector[idsToChange], countVector[idsToChange]),
                                    idsToChange)

            majorCounts <- setNames(pmax(initialVector[idsToChange], countVector[idsToChange]),
                                    idsToChange)

            diffMask <- (countVector[idsToChange] > initialVector[idsToChange])

            diffCounts <- setNames(majorCounts - minorCounts, idsToChange)

            limitCriteria.min <- setNames(minorCounts * limitMin, idsToChange)
            limitCriteria.max <- setNames(minorCounts * limitMax, idsToChange)

            vectorToChange <- ifelse(diffMask, 'countVector', 'initialVector')

            limitSelValue <-  if (limit == 'max') limitMax else limitMin

            diffToLimit <- setNames(minorCounts * limitSelValue - majorCounts, idsToChange)

            # Order the ids for the more restrictive (lower range) to the most.
            idsToChange <- idsToChange[order(limitCriteria.max - limitCriteria.min)]

            # Repeat the process for each feature, as the pool will change with every situation.
            for (featureID in idsToChange) {
                minValue <- limitCriteria.min[featureID]
                maxValue <- limitCriteria.max[featureID]

                vectorVariable <- get(vectorToChange[featureID])

                matchIds <- names(vectorVariable)[vectorVariable >= minValue & vectorVariable <= maxValue]

                availableIds <- intersect(matchIds, nonDEIds)

                if (length(availableIds)) {

                    swapID <- sample(availableIds, size = 1)

                    swap.Value <- vectorVariable[swapID]
                    feature.Value <- vectorVariable[featureID]

                    vectorVariable[featureID] <- swap.Value
                    vectorVariable[swapID] <- feature.Value
                } else {
                    # If no match has been found, generate a new random value.
                    newValue <- min(max(stats::runif(1,
                                                     min = minValue,
                                                     max = maxValue), absMinLimit), absMaxLimit)

                    vectorVariable[featureID] <- newValue
                }

                # As no pointers exist in R, replace original vector value with the new modified one.
                assign(vectorToChange[featureID], vectorVariable)
            }
        }

        outputList <- list(
            'data' = initialVector,
            'randData' = countVector
        )

        return(outputList)
    }

    # Determine which DE non-flat genes have been assigned a non-expressed status AND have an original
    # value lower than that, then swap their values with non-DE genes
    minDEassignments.rand <- names(object@randData)[object@randData < minDE.value] # Keep IDS from randomCounts separate
    minDEassignments.org <- rownames(object@data)[object@data$Counts < minDE.value]


    badAssignmentDE.min.org <- intersect(featuresDE, minDEassignments.org)


    availableIdsNONDE.rand <- setdiff(featuresNONDE, minDEassignments.rand)
    availableIdsNONDE.min.org <- setdiff(featuresNONDE.diff, minDEassignments.org)


    # First check: make sure they have a minimum value
    object@data[] <- swapCountValues(setNames(object@data$Counts, rownames(object@data)),
                                     badAssignmentDE.min.org,
                                     availableIdsNONDE.min.org,
                                     minDE.value)

    maxDEassignments.org <- rownames(object@data)[object@data$Counts > maxDE.value]
    badAssignmentDE.max.org <- intersect(featuresDE, maxDEassignments.org)

    availableIds <- names(object@data)[object@data < maxDE.value & object@data > minDE.value]
    availableIdsNONDE.max.org <- intersect(featuresNONDE.diff, availableIds)

    object@data[] <- swapCountValues(setNames(object@data$Counts, rownames(object@data)),
                                     badAssignmentDE.max.org,
                                     availableIdsNONDE.max.org,
                                     maxDE.value)


    # TODO: remove this temp mod
    index.DE <- names(object@randData) %in% featuresDE.notFlat
    index.noised <- names(object@randData) %in% featuresNonDE.noised

    minNoiseValue <- 100

    noisedMin.org <- rownames(object@data)[object@data$Counts < minNoiseValue]
    noisedMin.rand <- names(object@randData)[object@randData < minNoiseValue]

    badAssignmentNoiseNonDE.min.org <- intersect(featuresNonDE.noised, noisedMin.org)
    badAssignmentNoiseNonDE.min.rand <- intersect(featuresNonDE.noised, noisedMin.rand)

    availableIdsNONDE.min.org <- setdiff(featuresNONDE.diff, noisedMin.org)
    availableIdsNONDE.min.rand <- setdiff(featuresNONDE.diff, noisedMin.rand)

    object@data[] <- swapCountValues(setNames(object@data$Counts, rownames(object@data)),
                                     badAssignmentNoiseNonDE.min.org,
                                     availableIdsNONDE.min.org,
                                     minNoiseValue)

    object@randData[] <- swapCountValues(object@randData,
                                         badAssignmentNoiseNonDE.min.rand,
                                         availableIdsNONDE.min.rand,
                                         minNoiseValue)

    minDEassignments.rand <- names(object@randData)[object@randData < minDE.value]
    badAssignmentDE.min.rand <- intersect(featuresDE, minDEassignments.rand)
    badAssignmentNoiseNonDE.min.rand <- intersect(featuresNonDE.noised, minDEassignments.rand)
    availableIdsNONDE.min.rand <- setdiff(featuresNONDE.diff, minDEassignments.rand)

    object@randData[] <- swapCountValues(object@randData,
                                         badAssignmentDE.min.rand,
                                         availableIdsNONDE.min.rand,
                                         minDE.value)

    maxDEassignments.rand <- names(object@randData)[object@randData > maxDE.value]
    badAssignmentDE.max.rand <- intersect(featuresDE, maxDEassignments.rand)

    availableIds <- names(object@randData)[object@randData < maxDE.value & object@randData > minDE.value]
    availableIdsNONDE.max.rand <- intersect(featuresNONDE.diff, availableIds)

    object@randData[] <- swapCountValues(object@randData,
                                         badAssignmentDE.max.rand,
                                         availableIdsNONDE.max.rand,
                                         maxDE.value)

    retrieveDiffIndex <- function(instance, multiplier) {
        random.M <- pmax(instance@randData, instance@data$Counts)
        random.m <- pmin(instance@randData, instance@data$Counts)

        diff.out <- (random.M > random.m * multiplier)

        return(diff.out)
    }

    # Maximum difference between M and m
    min.diff <- object@minMaxFC[1]
    max.diff <- object@minMaxFC[2]

    index.match.maxdiff.available <- retrieveDiffIndex(object, max.diff)
    index.match.maxdiff <- (index.match.maxdiff.available & index.DE)

    # Swap values with others to meet the constraints at the time we maintain a similar distribution
    # of the initial sample.

    # Ids to change
    badAssignmentDE.rand.maxdiff <- names(object@randData)[index.match.maxdiff]

    # Pool of available ids to meet the condition.
    availableIdsNONDE.maxdiff.rand <- setdiff(featuresNONDE.diff, names(index.match.maxdiff.available))

    correctedCounts <- swapCountValuesDiff(object@randData,
                                           setNames(object@data$Counts, rownames(object@data)),
                                           badAssignmentDE.rand.maxdiff,
                                           featuresNONDE.diff,
                                           max.diff,
                                           min.diff,
                                           'max',
                                           maxDE.value,
                                           minDE.value
                                           )

    object@data[] <- correctedCounts$data
    object@randData <- correctedCounts$randData

    # Repeat the process with minimum diffs
    index.match.mindiff.available <- ! (retrieveDiffIndex(object, min.diff))
    index.min.match <- (index.match.mindiff.available & index.DE)

    badAssignmentDE.rand.mindiff <- names(object@randData)[index.min.match]

    availableIdsNONDE.mindiff.rand <- setdiff(featuresNONDE.diff, names(index.match.mindiff.available))

    correctedCounts <- swapCountValuesDiff(object@randData,
                                           setNames(object@data$Counts, rownames(object@data)),
                                           badAssignmentDE.rand.mindiff,
                                           featuresNONDE.diff,
                                           max.diff,
                                           min.diff,
                                           'min',
                                           maxDE.value,
                                           minDE.value)

    object@data[] <- correctedCounts$data
    object@randData <- correctedCounts$randData

    # MIN/MAX FOR NOISED NON-DEG
    max.diff.noised <- 1.1
    min.diff.noised <- 1.1

    index.match.maxdiff.available.noised <- retrieveDiffIndex(object, max.diff.noised)
    index.max.match.noised <- (index.match.maxdiff.available.noised & index.noised)

    badAssignmentDE.rand.maxdiff.noised <- names(object@randData)[index.max.match.noised]

    availableIdsNONDE.maxdiff.rand.noised <- setdiff(featuresNONDE.diff, names(badAssignmentDE.rand.maxdiff.noised))

    correctedCounts <- swapCountValuesDiff(object@randData,
                                           setNames(object@data$Counts, rownames(object@data)),
                                           badAssignmentDE.rand.maxdiff.noised,
                                           setdiff(featuresNONDE.diff, featuresNonDE.noised),
                                           max.diff.noised,
                                           min.diff.noised,
                                           'max',
                                           maxDE.value,
                                           minNoiseValue)

    object@data[] <- correctedCounts$data
    object@randData <- correctedCounts$randData

    # Clone the base counts for every group
    if (ncol(object@data) < simulation@numberGroups) {
        object@data <- object@data[, rep.int(1, simulation@numberGroups), drop = FALSE]
    }

    # Important: column names pattern "Counts.Group" is required .
    colnames(object@data) <- paste('Counts.Group', seq(simulation@numberGroups))

    if (! is.null(flatProfiles <- simulation@simSettings$geneProfiles$FlatGroups$SimRNAseq)) {

        # Structure: Gene_ID | Group_1 | ... | Group_N
        # onlyFlat <- (length(simulation@times) > 1)

        # Count range to exclude comparing with the reference (group 1)
        excludeMargin <- 10

        # Match positions
        flatIndexes <- match(flatProfiles$ID, rownames(object@data))

        # Different treatments between RNA-seq and the rest of simulators
        if ( ! object@regulator) {

            # Profiles + Counts
            profileCounts <- cbind(flatProfiles, object@data[flatIndexes, ])

            profileColumns <- dplyr::starts_with("Group", vars = colnames(profileCounts))
            countColumns <- dplyr::starts_with("Counts.Group", vars = colnames(profileCounts))

            # Iterate over the rows on a unique matrix with the structure:
            # Gene_ID | Profile_Group_1 | ... | Counts_Group_1 | ...
            object@data[flatIndexes, ] <- t(apply(profileCounts, 1, function(idRow) {
                # Types of profiles (exclude first column)
                idProfiles <- as.character(idRow[profileColumns])

                # Count values (columns after profiles)
                idCounts <- as.numeric(idRow[countColumns])

                min.flat.value.enhancer <- idCounts[1] * object@minMaxFC[1]
                max.flat.value.enhancer <- idCounts[1] * object@minMaxFC[2]

                min.flat.value.repressor <- idCounts[1] / object@minMaxFC[2]
                max.flat.value.repressor <- idCounts[1] / object@minMaxFC[1]

                # Profiles
                tmpCounts <- ifelse(idProfiles == 'flat',
                                    # If the profile is flat, keep the current value
                                    idCounts,
                                    ifelse(idProfiles == 'enhancer',
                                           # If the profile is enhancer, generate a new count value in the range
                                           # (actual_value + excludeMargin) to maxValue
                                           rep.int(stats::runif(1,
                                                                min = min(min.flat.value.enhancer, object@max),
                                                                max = min(max.flat.value.enhancer, object@max)),
                                                   simulation@numberGroups),
                                           # If the profile is repressor, generate a new count value in the range
                                           # minValue to (actual_value - excludeMargin)
                                           rep.int(stats::runif(1,
                                                                min = max(min.flat.value.repressor, object@min),
                                                                max = max(max.flat.value.repressor, object@min)),
                                                   simulation@numberGroups)
                                    )
                )

                # Check the differences
                # referenceGroup <- head(tmpCounts[idProfiles == 'flat'], 1)
                # diffValues <- abs(tmpCounts - referenceGroup)
                #
                # # For enhancer there shouldn't be any problem
                # invalidDiffs <- (diffValues < min.diff.flat) & (idProfiles == 'repressor')
                #
                # if (any(invalidDiffs)) {
                #     # Calculate the amount to increase the reference group
                #     diffRange <- min.diff.flat - min(diffValues)
                #
                #     tmpCounts[idProfiles == 'flat'] <- tmpCounts[idProfiles == 'flat'] + diffRange
                # }

                return(tmpCounts)
            }))
        } else {
            # In case of regulators, the initial value will depend on the effect
            # on the associated gene.
            profileSubset <- dplyr::rename(flatProfiles, Gene = ID) %>%
                dplyr::inner_join(simulation@simSettings$geneProfiles[[class(object)]][, c('ID', 'Effect', 'Gene')], by = c("Gene" = "Gene")) %>%
                dplyr::select(ID, Effect, dplyr::starts_with("Group")) %>%
                dplyr::filter(! is.na(Effect))

            # TODO: change object@data with object@randData?
            if (nrow(profileSubset)) {
                # CAREFUL: the counts value NEED to have the same amount as columns as number of groups, otherwise a NA
                # will be returned hence assigning the maximum value.
                # Profiles + Counts
                profileCounts <- cbind(profileSubset, object@data[profileSubset$ID, ])

                effectColumn <- dplyr::matches("Effect", vars = colnames(profileCounts))
                profileColumns <- dplyr::starts_with("Group", vars = colnames(profileCounts))
                countColumns <- dplyr::starts_with("Counts.Group", vars = colnames(profileCounts))

                object@data[profileSubset$ID, ] <- t(apply(profileCounts, 1, function(idRow) {
                    # Regulator effect
                    regEffect <- idRow[effectColumn]
                    # Types of profiles (skip first 2 columns: ID and Effect)
                    idProfiles <- as.character(idRow[profileColumns])
                    # Count values (following columns)
                    idCounts <- as.numeric(idRow[countColumns])

                    min.flat.value.enhancer <- idCounts[1] * 3
                    max.flat.value.enhancer <- idCounts[1] * 10

                    min.flat.value.repressor <- idCounts[1] / 10
                    max.flat.value.repressor <- idCounts[1] / 3

                    # Profiles
                    # TODO: change to use randData
                    return(ifelse(idProfiles == 'flat',
                                  # If the profile is flat, keep the current value
                                  idCounts,
                                  # If the regulator effect is enhancer, keep the same behaviour,
                                  # if not, assign the opposite.
                                  ifelse(idProfiles == regEffect,
                                         # If the profile is enhancer, generate a new count value in the range
                                         # (actual_value + excludeMargin) to maxValue
                                         rep.int(stats::runif(1,
                                                              min = min(min.flat.value.enhancer, object@max),
                                                              max = min(max.flat.value.enhancer, object@max)),
                                                 simulation@numberGroups),
                                         # If the profile is repressor, generate a new count value in the range
                                         # minValue to (actual_value - excludeMargin)
                                         rep.int(stats::runif(1,
                                                              min = max(min.flat.value.repressor, object@min),
                                                              max = max(max.flat.value.repressor, object@min)),
                                                 simulation@numberGroups)
                                  )
                    ))
                }))
            }
        }

        # Adjust again to depth for each column
        object@data <- apply(object@data, 2, function(x) x * object@depth / sum(x))
        object@randData <-  object@randData * object@depth / sum(object@randData)

        # Replace with a mean value between the groups
        object@data[featuresNONDE, ] <- apply(object@data[featuresNONDE, , drop = FALSE], 1, mean)
    }

    return(object)
})

#' @rdname Generics
#' @keywords internal
#' @noRd
setMethod("simulate", signature="MOSimulator", function(object, simulation) {
    message(sprintf("Starting simulation of %s.", object@name))

    object <- initializeData(object, simulation)

    makeReplicates <- function(counts, groupInfo, timeInfo, profileInfo, verbose = TRUE) {
        if (verbose) {
            message(sprintf("\t- Making replicates for group %d on time %s.", groupInfo, timeInfo))
        }

        counts[is.na(counts) | counts < 0.1] <- 0.1

        varest <- 10^object@replicateParams$a * (counts + 1)^object@replicateParams$b - 1

        # Force a minimum variance
        varest[varest < 0.03] <- 0.03

        # Apply to every row:
        #   Param x: [mu.noise.cpm, stdev]
        temp <- t(matrix(apply(cbind(counts, varest), 1, function (x) {
            if (x[1] >= x[2]) {
                replis <- stats::rpois(n = simulation@numberReps, lambda = x[1])
            } else {
                replis <- stats::rnbinom(n = simulation@numberReps, size = x[1]^2/(x[2] - x[1]),  mu = x[1])
            }

            return(replis)
        }), nrow = simulation@numberReps))

        flatProfiles <- which(profileInfo == 'flat')

        # Disabled: adjusting to specified depth
        # temp.depth <- apply(temp, 2, function(x) x * object@depth / sum(x))
        temp.depth <- temp

        # Generate random means
        noised.means.rand <- stats::rnorm(n = length(counts),
                             mean = counts,
                             sd = 0.025 * counts)

        # For induction profiles, select the minimum value
        noised.means <- ifelse(grepl("induction", profileInfo),
               pmin(counts, noised.means.rand),
               pmax(counts, noised.means.rand)
               )

        # Override for flat profiles with a less variable noise
        if (length(flatProfiles)) {
            noised.means[flatProfiles] <- stats::rnorm(n = length(flatProfiles),
                                                       mean = counts[flatProfiles],
                                                       sd = 0.01 * counts[flatProfiles])
        }

        # Note: assign as [] to maintain structure, as apply will return a matrix or a vector depending
        # on the number of replicates of the simulation.
        temp.depth[] <- t(apply(cbind(noised.means, temp.depth), 1,
                                              function(geneRow) {
                                                  # Original replicate values
                                                  mean.adjusted <- geneRow[1]
                                                  gene.values <- geneRow[-1]

                                                  # Mean
                                                  diff.mean <- mean(gene.values) - mean.adjusted

                                                  gene.adjusted <- gene.values - diff.mean

                                                  return(gene.adjusted)
                                              }))

        return(temp.depth)
    }

    # Profile table of simulator
    simProfiles <- simulation@simSettings$geneProfiles[[class(object)]]

    # Flat DE genes
    flatProfiles <- simulation@simSettings$geneProfiles$FlatGroups[[class(object)]] #$SimRNAseq

    # Select only the active rows of the regulator profile table, discarding
    # the duplicated rows (all active rows for a given regulator will have the
    # same profile among groups by now).
    if (object@regulator) {
        # If the object is pregenerated (e.g. methylation) then keep the profiles
        # as they are.
        if (object@pregenerated) {
            simProfiles <- dplyr::select(simProfiles, ID, dplyr::starts_with("Group"), dplyr::starts_with("Tmax")) %>%
                dplyr::distinct()
        } else {
            simProfiles <- dplyr::filter(simProfiles, ! is.na(Effect)) %>%
                dplyr::select(ID, dplyr::starts_with("Group"), dplyr::starts_with("Tmax")) %>%
                dplyr::distinct()

            # Add remaining IDs present on data with a flat profile
            simProfiles <- rbind(simProfiles, do.call(cbind, setNames(append(
                # ID
                list(rownames(object@data)[! rownames(object@data) %in% as.character(simProfiles$ID)]),
                # Groups
                append(rep('flat', simulation@numberGroups), rep(NA, simulation@numberGroups)) # Group & Tmax columns
            ), colnames(simProfiles))))
        }
    }

    # Filtering step
    simProfiles <- dplyr::filter(simProfiles, ID %in% rownames(object@data))

    if (object@pregenerated) {
        # When working with blocks, sometimes there are duplicated rows
        # because they do not have the tmax columns properly filled.
      # This is now fixed in Simulation.R inside MOSimulation
        simProfiles <- dplyr::group_by(simProfiles, ID) %>%
            dplyr::summarise_all(list(~dplyr::first(stats::na.omit(.)))) %>%
            dplyr::ungroup()
    }

    # If data is already generated (i.e. methylation simulator) skip some
    # steps like generating random counts or replicates, adjusting also the
    # parameters for mapply.

    # Pass only "group" columns
    columnsParam <- dplyr::select(simProfiles, dplyr::starts_with("Group"))
    # Pass only "tmax" columns
    tmaxParam <- dplyr::select(simProfiles, dplyr::starts_with("Tmax."))
    # Keep track of iteration
    iterationParam <- seq(simulation@numberGroups)
    # Pass IDs
    idsParam <- simProfiles[, rep('ID', simulation@numberGroups), drop = FALSE]

    if (object@pregenerated) {
        # Repeat for every replicate
        columnsParam <- columnsParam[, rep(colnames(columnsParam), each = simulation@numberReps), drop = FALSE]
        iterationParam <- rep(iterationParam, each = simulation@numberReps)
        idsParam <- simProfiles[, rep('ID', simulation@numberGroups * simulation@numberReps), drop = FALSE]

        tmaxParam <- tmaxParam[, rep(colnames(tmaxParam), each = simulation@numberReps), drop = FALSE]
    }

    simulatedParams <- setNames(mapply(function(counts, profiles, group, ids) {
        simulateParams(object, simulation, counts, profiles, group, ids)
    },
    data.frame(object@data[as.character(simProfiles$ID), , drop = FALSE], stringsAsFactors = FALSE),
    columnsParam,
    iterationParam,
    idsParam,
    USE.NAMES = TRUE,
    SIMPLIFY = FALSE
    ), paste0("Group", seq_len(simulation@numberGroups)))

    features2Groups <- c()

    # Genes flat in one group but not the other
    if (simulation@numberGroups > 1) {
        # Check if at least one gene has a flat profile in one group
        features2Groups <- dplyr::select(simProfiles, dplyr::starts_with("Group")) %>%
            purrr::map(`==`, 'flat') %>%
            purrr::pmap_int(any)

        # Exclude those with 'flat' in all profiles
        flatIndexes <- simProfiles$ID %in% flatProfiles$ID

        features2Groups <- simProfiles[features2Groups & ! flatIndexes, 'ID', drop = TRUE]

        # dplyr::select(profilesDE, dplyr::starts_with("Group")) %>% purrr::pmap(., function(...) {
        #     geneProfiles <- list(...)
        #
        #     return(any(geneProfiles == 'flat'))
        # })
    }

    if (simulation@numberReps > 1) {
        nonDE.selected <- simulation@simSettings$featureSamples[[class(object)]]$noiseNonDE


        # Disabled: chose totally opposite profiles for noise genes.
        #
        # sampleProfiles <- function(featureID) {
        #     profileOptions <- names(simulation@profileProbs)
        #     profileTypes <- c("transitory", "continuous")
        #
        #     sampleTypes <- sample(profileTypes, size = floor(simulation@numberReps/2), replace = TRUE)
        #
        #     chosenOptions <- unlist(lapply(sampleTypes, function(typeName) profileOptions[grep(typeName, profileOptions)]))
        #
        #     # For an odd number of replicates, add a final flat profile
        #     if (simulation@numberReps %% 2 != 0) {
        #         chosenOptions <- c(chosenOptions, "flat")
        #     }
        #
        #     return(chosenOptions)
        # }
        profileOptions <- names(simulation@profileProbs)[-grep("flat", names(simulation@profileProbs))]

        replacement <- (simulation@numberReps > length(profileOptions))

        repProfiles <- do.call(rbind,
                               replicate(n = length(nonDE.selected),
                                         sample(profileOptions, size = simulation@numberReps, replace = replacement),
                                         simplify = FALSE))

        # repProfiles <- do.call(rbind, lapply(nonDE.selected, sampleProfiles))

        tmax.T <- length(simulation@times) - 1

        repTmax <- matrix(rep(stats::runif(length(nonDE.selected), min = 0.25 * tmax.T, max = 0.75 * tmax.T),
                            times = simulation@numberReps,
                            simplify = FALSE), ncol = simulation@numberReps)
    }

    # Generate time series (if any) with replicates
    object@simData <- data.frame(
        mapply(
            function(simulateParams, profiles, tmaxValues, group, ids) {
                if (! object@pregenerated) {
                    message(sprintf("- Simulating count values for group %d.", group))
                } else {
                    message(sprintf("[Pregenerated replicate] Simulating count values for group %d.", group))
                }

                # Create the coefficients based on the "tmax" parameter
                nt <- length(simulation@times)

                x <- c(0:(nt - 1))

                varT <- x[nt]

                calculateTimeVectors <- function(localProfiles, localTmaxvalues) {
                    t(apply(cbind(localProfiles, localTmaxvalues), 1, function(rowInfo) {
                    # Set in the current scope the proper values
                    profileValue <- rowInfo[1]
                    tmaxValue <- as.numeric(rowInfo[2])

                    data_values <- list(
                        "0" = 0,
                        a1 = 0,
                        a2 = 0,
                        a2.neg = 0,
                        b1 = 1 / x[nt],
                        b1.neg = -1 / x[nt],
                        b2 = 4 * (x[nt]) / (x[nt] * x[nt]),
                        b2.neg = -4 * (x[nt]) / (x[nt] * x[nt]),
                        c2 = -4 / (x[nt] * x[nt]),
                        c2.neg = 4 / (x[nt] * x[nt])
                    )

                    # If tmaxValue is set, the profile is transitory: override variables
                    if (! is.na(tmaxValue)) {

                        if (tmaxValue >= varT/2) {
                            data_values$b2 <- 2 / tmaxValue
                            data_values$c2 <- - 1 /tmaxValue^2
                        } else {
                            data_values$c2 <- - 1 /(varT - tmaxValue)^2
                            data_values$a2 <- 1 + (data_values$c2) * tmaxValue^2
                            data_values$b2 <- - 2 * (data_values$c2) * tmaxValue
                        }

                        data_values$a2.neg <- - data_values$a2
                        data_values$b2.neg <- - data_values$b2
                        data_values$c2.neg <- - data_values$c2
                    }

                    return(unlist(data_values[as.character(simulation@profiles[[profileValue]])]))

                })) %*% rbind(c(rep(1, nt)), x, x * x)
                }

                generateCountsProfiles <- function(timeVectors, profiles, indexID, applyCorrection=TRUE, verbose=TRUE) {

                    # Generate base counts using the formulas:
                    # X = initial_counts + noise [for flat]
                    # X = m + lambda(M - m) + noise [for lambda in [0,1]]
                    # X = M + lambda(M - m) + noise [for lambda in [-1,0]]

                    # Delegate creation of specific simulation parameters
                    counts <- simulateParams$counts[indexID]
                    randomCounts <- simulateParams$randomCounts[indexID]
                    noiseValues <- simulateParams$noiseValues[indexID]
                    M <- simulateParams$M[indexID]
                    m <- simulateParams$m[indexID]
                    repressionMean <- simulateParams$repression.Mean[indexID]
                    inductionMean <- simulateParams$induction.Mean[indexID]

                    # Rows with flat profile
                    indexFlat <- which(profiles == "flat")

                    diffRepression <- repressionMean - m
                    diffInduction <- M - inductionMean

                    if (! object@pregenerated) {
                        simData <-
                            ifelse(grepl('repression', profiles, fixed = TRUE),
                                   repressionMean,
                                   inductionMean) +
                            # ((M - m) * timeVectors) +
                            ifelse(grepl('repression', profiles, fixed = TRUE),
                                   diffRepression,
                                   diffInduction) * timeVectors +
                            noiseValues
                    } else {
                        # For methylation, avoid using means so that we can replicate the plot showing
                        # a maximum in 0 and 1 values
                        simData <-
                            ifelse(grepl('repression', profiles, fixed = TRUE), M, m) +
                            ((M - m) * timeVectors) +
                            noiseValues
                    }

                    # Overwrite flat rows with the correct value
                    otherGroup.mean <- purrr::pmap_dbl(lapply(grep(paste0("Group", group), names(simulatedParams), invert = TRUE), function(otherGroup) {
                        simulatedParams[[otherGroup]]$mean.counts[indexID]
                    }), mean)

                    if (length(indexFlat)) {
                        simData[indexFlat, ] <- ifelse(ids[indexID][indexFlat] %in% flatProfiles$ID,
                                                       counts[indexFlat],
                                                       # Reduce differentes between groups
                                                       ifelse(ids[indexID][indexFlat] %in% features2Groups,
                                                              otherGroup.mean[indexFlat],
                                                              randomCounts[indexFlat]))
                        + noiseValues[indexFlat]
                    }

                    # Some genes might have negative values due to the way the time profile formula is applied.
                    # For DEG, we correct these as to manually increase the amount in all time profiles to avoid this, increasing it
                    # to a minimum value.
                    if (applyCorrection && ! object@pregenerated) {
                        minimumDEGvalue <- object@minMaxDist$minDE

                        # Apply the correction to transitory profiles only
                        rowsToCheck <- grep("transitory", profiles)

                        if (length(rowsToCheck)) {
                            simData[rowsToCheck, ] <- t(apply(simData[rowsToCheck, , drop = FALSE], 1, function(rowValues) {

                                if (min(rowValues) < 0 ) {
                                    increaseAmount <- minimumDEGvalue - min(rowValues)

                                    correctedValues <- rowValues + increaseAmount

                                    return(correctedValues)
                                }

                                return(rowValues)
                            }))
                        }
                    }

                    # If the object is flagged as pregenerated it should already have the
                    # replicates (i.e. methyl seek), so skip this step.
                    if (! object@pregenerated) {
                        simData <-
                            mapply(
                                makeReplicates,
                                counts = as.data.frame(simData, stringsAsFactors = FALSE),
                                groupInfo = group,
                                timeInfo = simulation@times,
                                profileInfo = as.data.frame(profiles)[, rep(1, length(simulation@times)),drop=FALSE],
                                verbose = verbose,
                                SIMPLIFY = FALSE,
                                USE.NAMES = FALSE
                            )
                    }

                    return(simData)
                }

                globalTimeVectors <- calculateTimeVectors(profiles, tmaxValues)

                simData <- generateCountsProfiles(globalTimeVectors, profiles, seq_along(ids))

                if (simulation@numberReps > 1 && ! object@pregenerated) {
                    ids.positions <- match(nonDE.selected, ids)

                    for (repNum in seq(from = 1, to = simulation@numberReps)) {
                        customTimeVectors <- calculateTimeVectors(repProfiles[, repNum],
                                                                  repTmax[, repNum])

                        customSimdata <- generateCountsProfiles(customTimeVectors,
                                                                repProfiles[, repNum],
                                                                ids.positions,
                                                                applyCorrection = FALSE,
                                                                verbose = FALSE)

                        # Replace replicates in already simulated data
                        for (timePoint in seq_len(ncol(customTimeVectors))) {
                            simData[[timePoint]][ids.positions, repNum] <- customSimdata[[timePoint]][, repNum]
                        }
                    }
                }

                return(simData)
            },
            # Count column for each group in the correct order
            simulatedParams,
            # Pass only "group" columns
            columnsParam,
            # Coefficients parameters
            tmaxParam,
            # Keep track of iteration
            iterationParam,
            # Pass the row IDs
            idsParam,
            SIMPLIFY = FALSE
        ), row.names = simProfiles$ID, stringsAsFactors = FALSE)

    # Ensure that the columns have the proper pattern "Counts.GroupX"
    colsPerGroup <- length(simulation@times) * simulation@numberReps

    colnames(object@simData) <- paste0("Counts.Group.",
                                       rep(seq(simulation@numberGroups), each = colsPerGroup),
                                       ".", seq(colsPerGroup))

    # Final modifications (if required)
    object <- postSimulation(object, simulation)

    return(object)
})

#' postSimulation
#'
#' Method to make final modifications required by the different omics. Like rounding
#' the final count values or renaming columns for making them more human-readable.
#'
#' For internal use only.
#'
#' @param object Instance of class \linkS4class{MOSimulator}.
#' @param simulation Instance of class \linkS4class{MOSimulation}.
#'
#' @return Object of class \linkS4class{MOSimulation} with the simulated data (@simData)
#' correctly formatted.
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("postSimulation", signature="MOSimulator", function(object, simulation) {

    if (ncol(object@simData) < simulation@numberGroups * simulation@numberReps * length(simulation@times))
        stop("Invalid number of columns after simulation. Please, contact package maintainer!")

    # Change number of columns with pattern "Counts.Group"
    # GroupX.TimeY.RepN
    colnames(object@simData)[grep("Counts.Group", colnames(object@simData))] <-
        paste0(
            "Group",
            rep(
                seq_len(simulation@numberGroups),
                each = length(simulation@times) * simulation@numberReps
            ),
            ".Time",
            rep(simulation@times,
                each = simulation@numberReps),
            ".Rep",
            seq_len(simulation@numberReps)
        )

    if (! object@pregenerated) {
        object@simData[object@simData < object@min] <- object@min
        object@simData[object@simData > object@max] <- object@max
    }

    # Before adjusting to depth, we include a "dummy" feature that would adjust
    # the sum of each column to be the same, so as to maintain the profiles on
    # the genes that matter.
    diffToMax <- max(colSums(object@simData)) - colSums(object@simData)

    object@simData <- data.frame(mapply(function(simuCol, diffCol) {

        # First rescale the column
        rescaledColDifferences <- simuCol * diffCol / sum(simuCol)

        rescaledCol <- simuCol + rescaledColDifferences

        return(rescaledCol)
    }, as.data.frame(object@simData), diffToMax, SIMPLIFY = FALSE),
    row.names = rownames(object@simData),
    stringsAsFactors = FALSE)

    # Adjust to simulated depth
    object@simData <- apply(object@simData, 2, function(x) x * object@depth / sum(x))

    # object@simData <- .Simulator.adjustDepth(object, object@simData)

    message("Rounding ", object@name, " count values.")

    # Round only counts columns
    roundCols <- grep(".Time", colnames(object@simData))

    object@simData[, roundCols] <- round(object@simData[, roundCols], digits = object@roundDigits)

    return(object)
})


#' IDfromGenes
#'
#' Returns the regulator IDs associated to a particular set of genes identifiers.
#'
#' @param object Instance of class \linkS4class{MOSimulator}.
#' @param geneNames Character vector of the genes to look for in the association table.
#' @param simplify Return only the genes IDs or a table containing both types of identifiers.
#'
#' @return Depending on \emph{simplify} parameter it would be a character vector or a
#' data frame containing columns \emph{ID} and \emph{Gene}.
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("IDfromGenes", signature="MOSimulator", function(object, geneNames, simplify = TRUE) {
    regTable <- object@idToGene

    selCols <- if (simplify) c('ID') else c('ID', 'Gene')
    selRows <- regTable[, 'Gene'] %in% geneNames

    return(regTable[selRows, selCols])
})

#' IDtoGenes
#'
#' Returns the gene identifiers associated to a particular set of regulator IDs.
#'
#' @param object Instance of class \linkS4class{MOSimulator}.
#' @param idNames Character vector of the regulator IDs to look for in the association table.
#' @param simplify Return only the regulator IDs or a table containing both types of identifiers.
#'
#' @return Depending on \emph{simplify} parameter it would be a character vector or a
#' data frame containing columns \emph{ID} and \emph{Gene}.
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("IDtoGenes", signature="MOSimulator", function(object, idNames, simplify = TRUE) {
    regTable <- object@idToGene

    selCols <- if (simplify) c('ID') else c('ID', 'Gene')
    selRows <- regTable[, 'ID'] %in% idNames

    return(regTable[selRows, selCols])
})

#' simulateParams
#'
#' For internal use. Creates the values to be replaced in the formulas used
#' to simulate the profile values, including noise.
#'
#' @param object Instance of class \linkS4class{MOSimulator}.
#' @param simulation Instance of class \linkS4class{MOSimulation}.
#' @param counts Counts taken from the initial data.
#' @param profiles Types of profiles to simulate.
#' @param ids IDs associated. Needed in some simulators.
#'
#' @return A list containing the following items:
#' \describe{
#'      \item{randomCounts}{numeric vector containing random count values.}
#'      \item{noiseValues}{numeric vector containing noise values generated with the noise function and parameters specified.}
#'      \item{m}{numeric vector of lower values comparing original and random counts.}
#'      \item{M}{numeric vector of maximum values comparing original and random counts.}
#' }
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("simulateParams", signature="MOSimulator", function(object, simulation, counts, profiles, group, ids) {
    # Reorder random counts
    randomCounts <- object@randData[ids]

    # Order [m, M]
    m <- pmin(counts, randomCounts)
    M <- pmax(counts, randomCounts)

    # Generate noise values. Different values for each time.
    noiseValues <-
        replicate(length(simulation@times),
                  do.call(
                      object@noiseFunction,
                      append(list("n" = length(counts)),
                             object@noiseParams[names(object@noiseParams) != 'NB'])
                  ))

    repressionMean <- stats::runif(length(M), min = (M+m)/2, max = M)
    inductionMean <- stats::runif(length(m), min = m, max = (M+m)/2)

    return(list(
        'randomCounts' = randomCounts,
        'noiseValues' = noiseValues,
        'm' = m,
        'M' = M,
        'repression.Mean' = repressionMean,
        'induction.Mean' = inductionMean,
        'mean.counts' = ifelse(grepl('repression', profiles),(repressionMean + m)/2, (inductionMean + M)/2),
        'counts' = counts
    ))
})

#' adjustProfiles
#'
#' For internal use. Allows every omic class to adjust the profiles matrix
#' (simulation settings) to use, according to its needs.
#'
#' @param object Instance of class \linkS4class{MOSimulator}.
#' @param simulation Instance of class \linkS4class{MOSimulation}.
#' @param profiles Data frame containing the profile type associated to each
#' ID.
#' @param step It accepts two options \emph{Effect} and \emph{Groups} depending
#' on the part of the process where this method is called. Check 'Simulation.R'.
#'
#' @return By default it returs the profiles data frame without modifications.
#' @keywords internal
#' @rdname Generics
#' @noRd
#'
setMethod("adjustProfiles", signature="MOSimulator", function(object, simulation, profiles, step) {
    # By default return the same
    return(profiles)
})

#' @rdname Generics
#' @noRd
setMethod("show", signature="MOSimulator", function(object) {
    print(object@simData)
})

#' @rdname Generics
#' @noRd
setMethod("simSettings", signature="MOSimulator", function(object) {
    cat(sprintf("Simulation settings of class %s:\n", class(object)))
    cat(sprintf("- Depth: %d\n", object@depth))
})


setValidity("MOSimulator", function(object) {
    errors <- c()

    if (! is.declared(object@data) && ! object@pregenerated)
        errors <- c(errors, "Every omic needs to have the initial data set.")

    if (object@regulator && ! is.declared(object@idToGene))
        errors <- c(errors, "Regulators must provide the association gene list.")

    return(if(length(errors)) errors else TRUE)
})

# Since SPARSim is neiher on CRAN nor bioconductor and scMOSim strongly relies  
# on SPARSim functionality, we had to include the Main and auxiliary functions  
# we use into the code. The main functions used are:
#    - SPARSIM_estimate_parameter_from_data
#    - SPARSIM_create_simulator_parameter
#    - SPARSIM_simulation
# SPARSim can be downloaded and installed from the sysbiobig GITLAB
# <https://gitlab.com/sysbiobig/sparsim>
# When using SPARSIM, please cite DOI: 10.1093/bioinformatics/btz752
# Baruzzo G, Patuzzi I, Di Camillo B. (2020) SPARSim single cell: a count data  
# simulator for scRNA-seq data


#' random_unif_interval
#' Function to call the C code
#' This function is a copy of the `random_unif_interval` function from the 
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo, 
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed 
#' under the GPL-3 license.
#' @param size from sparsim
#' @param max_val from sparsim
#'
#' @export

random_unif_interval <- function(size, max_val) {
  .Call('_sparsim_random_unif_interval', PACKAGE = 'MOSim', size, max_val)
}


#' Create SPARSim simulation parameter
#'
#' Function to create a SPARSim simulation parameter.
#' This function is a copy of the `SPARSIM_create_simulation_parameter` function from the 
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo, 
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed 
#' under the GPL-3 license.
#' To simulate N feature (e.g. genes), user must specify N values of gene expression level and gene expression variability in the function input parameters \code{intensity} and \code{variability}, respectively.
#' To simulate M samples (i.e. cells), user must specify M values of sample library size in the function input parameter \code{library_size}.
#'
#' User can optionally specify the names to assign at the single feature and sample to simulate (function input parameters \code{feature_names} and \code{sample_names}, respectively,
#' as well as the name of the experimental condition (function input parameter \code{condition_name}). If the user does not specify such information, the function will set some default values.
#'
#' To simulate T different experimental conditions in a single count table, then T different simulation parameters must be created.
#'
#' @param intensity Array of gene expression intensity values
#' @param variability Array of gene expression variability values
#' @param library_size Array of library size values
#' @param feature_names Array of feature names. It must be of the same length of \code{intensity} array. If NA (default), feature will be automatically named "gene_1", "gene_2", ... "gene_<N>", where N = length(intensity)
#' @param sample_names Array of sample names. It must be of the same length of \code{library_size} array. If NA (defatul), sample will be automatically named "<condition_name>_cell1", "<condition_name>_cell2", ..., "<condition_name>_cell<M>", where M = length(library_size)
#' @param condition_name Name associated to the current experimental condition. If NA (default), it will be set to "cond<l1><l2>", where l1 and l2 are two random letters.
#' @param intensity_2 Array of gene expression intensity values for the second expression mode, if simulating genes with bimodal gene expression. Entries containing \code{NAs} will be ignored. If NULL (default), no bimodal gene expression is simulated.
#' @param variability_2 Array of gene expression variability values for the second expression mode, if simulating genes with bimodal gene expression. If NULL (default), no bimodal gene expression is simulated.
#' @param p_bimod Array of bimodal gene expression probabilities; the i-th value indicates the probability \code{p} of the i-th gene to be expressed in the first mode
#' (i.e. the one specified in the i-th entries of parameters \code{intensity} and \code{variability}); with probability \code{1-p} the i-th gene will be expressed in the second mode (i.e. the one specified in the i-th entries of parameters \code{intensity_2} and \code{variability_2})
#' @return SPARSim simulation parameter describing one experimental condition
#' @export
sparsim_create_simulation_parameter <- function(intensity, variability, library_size, feature_names = NA, sample_names = NA, condition_name = NA,
                                                intensity_2 = NULL, variability_2 = NULL, p_bimod = NULL){
  
  # assign feature name to "intensity" and "variability"
  if(length(feature_names)==1){ # potential NA
    if(is.na(feature_names)){
      feature_names <- paste0("gene_", c(1:length(intensity)) )
    }
  }
  names(intensity) <- feature_names
  names(variability) <- feature_names
  
  # assign condition name
  if(is.na(condition_name)){
    condition_name <- paste0("cond_", paste0(sample(LETTERS, size = 2), collapse = "") )
  }
  
  # assign sample names to "library_size"
  if(length(sample_names)==1){
    if(is.na(sample_names)){
      sample_names <- paste0(condition_name,"_cell",c(1:length(library_size)))
    }
  }
  names(library_size) <- sample_names
  
  cond_param <- list()
  cond_param$intensity <- intensity
  cond_param$variability <- variability
  cond_param$lib_size <- library_size
  cond_param$name <- condition_name
  
  # if bimodal gene expression is required, then set the related fields
  if(!is.null(intensity_2) & !is.null(variability_2) & !is.null(p_bimod)){
    names(intensity_2) <- feature_names
    names(variability_2) <- feature_names
    cond_param$intensity_2 <- intensity_2
    cond_param$variability_2 <- variability_2
    cond_param$p_bimod <- p_bimod
  }
  
  return(cond_param)
}


#' Estimate SPARSIm "intensity" parameter
#'
#' Function to estimate the intensity values from the genes in \code{data}. The intensity is computed as mean of normalized counts for each gene.
#'
#' This function is a copy of the `SPARSIM_estimate_intensity` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' This function is used in \code{sparsim_estimate_parameter_from_data} to compute SPARSim "intensity" parameter, given a real count table as input.
#' If the count table contains more than one experimental condition, then the function is applied to each experimental conditions.
#'
#' @param data normalized count data matrix (gene on rows, samples on columns). \code{rownames(data)} must contain gene names.
#' @return An array of intensity values having \code{N_genes} elements (\code{N_genes = nrow(data)}). Array entries are named with gene names.
#' @export
sparsim_estimate_intensity <- function(data){
  
  N_genes <- nrow(data)
  intensity_val <- array(0, dim = N_genes)
  names(intensity_val) <- rownames(data)
  
  # intesity as mean of normalized counts
  intensity_val <- apply(data, 1, mean)
  rm(data); gc()
  return (intensity_val)
  
}


#' Estimate SPARSim "variability" parameter
#'
#' Function to estimate the variability values from the genes in \code{data}.
#'
#' This function is a copy of the `SPARSIM_estimate_variability` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' This function is used in \code{sparsim_estimate_parameter_from_data} to compute SPARSim "variability" parameter, given a real count table as input.
#' If the count table contains more than one experimental condition, then the function is applied to each experimental conditions.
#'
#' @param data raw count data matrix (gene on rows, samples on columns)
#' @return An array of variability values having \code{N_genes} elements (\code{N_genes = nrow(data)})
#' @export
sparsim_estimate_variability <- function (data){
  
  # compute percentage of entry >=0 for each gene
  perc_not_zeros_per_gene <- rowSums(data>0)/ncol(data)
  
  perc_not_zeros = 0
  ind_pass_filter <- (perc_not_zeros_per_gene > perc_not_zeros)
  N_gene_pass_filter <- sum(ind_pass_filter)
  
  variability <- array(NA, dim = nrow(data))
  
  # variability as edgeR dispersion of RAW counts in data
  if(N_gene_pass_filter > 1){
    
    #library(edgeR)
    f <- edgeR::DGEList(as.matrix(data[ind_pass_filter,]))
    gc()
    
    f <- edgeR::estimateGLMCommonDisp(f)
    gc()
    
    f <- edgeR::estimateGLMTrendedDisp(f)
    gc()
    
    if(any(is.na(f$trended.dispersion))){
      f$trended.dispersion <- NULL
      print("Trended dispresion is NA")
    }
    
    f <- edgeR::estimateGLMTagwiseDisp(f)
    gc()
    
    variability[ind_pass_filter] <- f$tagwise.dispersion
  }
  rm(data); gc()
  return(variability)
  
}



#' Estimate SPARSim "library size" parameter
#'
#' Function to estimate the library sizes from the samples in \code{data}.
#'
#' This function is a copy of the `SPARSIM_estimate_library_size` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' This function is used in \code{sparsim_estimate_parameter_from_data} to compute SPARSim "library size" parameter, given a real count table as input.
#' If the count table contains more than one experimental condition, then the function is applied to each experimental conditions.
#'
#' @param data raw count data matrix (gene on rows, samples on columns)
#' @return An array of library size values having \code{N_samples} elements (\code{N_samples = ncol(data)})
#' @export
sparsim_estimate_library_size <- function (data){
  return(colSums(data))
}



#' Estimate SPARSim simulation parameter from a given count table
#'
#' Function to estimate SPARSim simulation parameters (intensity, variability and library sizes) from a real count table.
#' If the real count table contains more than one experimental condition, it is possible to estimate the parameters for each experimental condition.
#'
#' This function is a copy of the `SPARSIM_estimate_parameter_from_data` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' @param raw_data count matrix (gene on rows, samples on columns) containing raw count data
#' @param norm_data count matrix (gene on rows, samples on columns) containing normalized count data
#' @param conditions list where the i-th element of the list contains the column indices for i-th experimental conditions. List must be a named list.
#' @return A SPARSim simulation parameters
#' @export
sparsim_estimate_parameter_from_data <- function (raw_data, norm_data, conditions){
  
  # Number of experimental conditions
  N_cond <- length(conditions)
  
  # Number of genes
  N_feature <- nrow(raw_data)
  
  
  dataset_parameter <- list()
  
  cond_i <- 1
  for (cond in conditions){# for each experimental condition
    
    #print(paste0("Experimental condition ", cond_i))
    
    gene_names <- rownames(raw_data)
    sample_names <- colnames(raw_data)
    
    #print("...estimating gene intensity")
    # estimate intesity

    N_genes <- length(gene_names)
    estim_intensity <- array(0, dim = N_genes)
    names(estim_intensity) <- gene_names
    for(i in 1:N_genes){
      estim_intensity[i] <- mean(norm_data[i,cond])
    }

    gc()
    
    #print("...estimating gene variability")
    # estimate variability
    estim_variability <- sparsim_estimate_variability (data = raw_data[,cond])
    
    #print("...estimating library size")
    # estimate library size
    estim_lib_size <- sparsim_estimate_library_size(data = raw_data[,cond])
    
    # get feature names, if present
    estim_feature_names <- NA
    if(!is.null(gene_names)){
      estim_feature_names <- gene_names
    }
    
    # get sample names, if present
    estim_sample_names <- NA
    if(!is.null(sample_names)){
      estim_sample_names <- sample_names[cond]
    }
    
    # get condition name, if present
    estim_cond_name <- paste0("cond_",cond_i)
    if(!is.null(names(conditions))){
      estim_cond_name <- names(conditions)[cond_i]
    }
    
    #print("...creating SPARSim simulation parameter")
    cond_parameter <- sparsim_create_simulation_parameter (intensity = estim_intensity,
                                                           variability = estim_variability,
                                                           library_size = estim_lib_size,
                                                           feature_names = estim_feature_names,
                                                           sample_names = estim_sample_names,
                                                           condition_name = estim_cond_name)
    
    dataset_parameter[[cond_i]] <- cond_parameter
    cond_i <- cond_i + 1
    
  }
  
  return(dataset_parameter)
}

#' Simulate technical variability
#'
#' Function to simulate the technical variability (i.e. a multivariate hypergeometric on a gamma expression value array)
#'
#' This function is a copy of the `simulate_hyper` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' @param avgAbund array containing the intensity values for each feature. It describes the intensity of a single sample
#' @param seqdepth sequencing depth (i.e. sample size of the MH)
#' @param digits number of digits for random number generation
#' @param max_val max value for random number generation
#' @return An array of \code{length(avgAbund)} elements representing the count values for the current sample
simulate_hyper <- function(avgAbund, seqdepth = NULL, digits, max_val) {
  
  if(seqdepth > 10^digits){
    print("seqdepth must be <= than 10^digits")
    return(NA)
  }
  
  index <- MOSim::random_unif_interval(round(seqdepth*1.1),max_val)
  
  while_i <- 1
  index <- unique(index)
  while (length(index)<seqdepth){
    new_ind <- MOSim::random_unif_interval( (seqdepth-length(index))*(while_i*10),max_val)
    index<-c(index,new_ind)
    while_i <- while_i +1
    index<-unique(index)
  }
  index <- index[1:seqdepth]
  
  cumulative_orig<-cumsum(avgAbund)
  check_orig<-findInterval(index,cumulative_orig,left.open = T)+1
  tmp_tabulate <- tabulate(check_orig, nbins = length(avgAbund))
  names(tmp_tabulate)<-names(avgAbund)
  
  return(tmp_tabulate)
}

#' Function to simulate a raw count table
#'
#' This function is a copy of the `SPARSIM_simulation` function from the
#' `SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
#' Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
#' under the GPL-3 license.
#' @param dataset_parameter list containing, the intensity, variability and lib sizes of each experimental condition. It is the return value of "estimate_parameter_from_data" or could be created by the users
#' @param output_sim_param_matrices boolean flag. If TRUE, the function will output two additional matrices, called abundance_matrix and variability_matrix, containing the gene intensities and gene variabilities used as simulation input. (Default: FALSE)
#' @param output_batch_matrix boolean flag. If TRUE, the function will output an additional matrix, called batch_factors_matrix, containing the multiplicative factors used in batch effect simulation. (Default: FALSE)
#' @param count_data_simulation_seed inherited from sparsim
#' @return A list of 5 elements:
#'
#'   - \code{count_matrix}: the simulated count matrix (genes on rows, samples on columns)
#'
#'   - \code{gene_matrix}: the simulated gene expression levels (genes on rows, samples on columns)
#'
#'   - \code{abundance_matrix}: the input gene intensity values provided as input (genes on rows, samples on columns), if \code{output_sim_param_matrices} = TRUE. NULL otherwise.
#'
#'   - \code{variability_matrix}: the input gene variability values provided as input (genes on rows, samples on columns), if \code{output_sim_param_matrices} = TRUE. NULL otherwise.
#'
#'   - \code{batch_factors_matrix}: the multiplicative factor used in batch generation (genes on rows, samples on columns), if \code{output_batch_matrix} = TRUE. NULL otherwise.
#'
#' @export
sparsim_simulation <- function(dataset_parameter,
                               output_sim_param_matrices = FALSE,
                               output_batch_matrix = FALSE,
                               count_data_simulation_seed = NULL){
  
  
  
  # number of experimental condition
  N_cond <- length(dataset_parameter)
  
  # number of genes
  N_genes <- length(dataset_parameter[[1]]$intensity)
  
  # total number of cells
  N_cell <- sum(unlist(lapply( dataset_parameter, function(x){return(length(x$lib_size))})))
  
  cat("Number of experimental conditions: ", N_cond, "\n")
  cat("Number of genes: ", N_genes, "\n")
  cat("Number of cells: ", N_cell, "\n")
  
  
  cat("Setting gene expression intensity... ", "\n")
  # initialize gene expression level matrix
  gene_expression_matrix <- matrix(0, nrow = N_genes, ncol = N_cell)
  rownames(gene_expression_matrix) <- names(dataset_parameter[[1]]$intensity)
  column_index <- 1
  new_col_names <- ""
  for(cond in 1:N_cond){
    
    cell_cond_name <- names(dataset_parameter[[cond]]$lib_size)
    new_col_names <- c( new_col_names ,  cell_cond_name)
    
  }
  new_col_names <- new_col_names[-1]
  colnames(gene_expression_matrix) <- new_col_names
  
  
  # fill gene expression level matrix with initial (still without biological variability) gene expression values
  for(cond in 1:N_cond){
    tmp_cell_ids <- names(dataset_parameter[[cond]]$lib_size)
    tmp_N_cell <- length(tmp_cell_ids)
    
    N_cell_mem <- 5000
    if(tmp_N_cell < N_cell_mem){
      gene_expression_matrix[, tmp_cell_ids] <- rep(dataset_parameter[[cond]]$intensity, tmp_N_cell)
    }else{
      tmp_data <- rep(dataset_parameter[[cond]]$intensity, N_cell_mem)
      N_mult <- floor(tmp_N_cell/N_cell_mem)
      
      for(ind in c(1:N_mult)){
        ind_range <- c( ((ind-1)*N_cell_mem+1) : (ind*N_cell_mem) )
        gene_expression_matrix[, tmp_cell_ids[ind_range]  ] <- tmp_data
      }
      if(N_mult*N_cell_mem < tmp_N_cell){
        ind_range <- c( (N_mult*N_cell_mem+1) : tmp_N_cell)
        gene_expression_matrix[, tmp_cell_ids[ind_range]  ] <- tmp_data[c(1: (length(ind_range)*N_genes) )]
      }
      
      rm(tmp_data); gc(verbose = FALSE)
    }
    
  }
  
  
  cat("Setting gene expression variability ... ", "\n")
  # initialize gene expression variability matrix
  gene_expression_var_matrix <- matrix(0, nrow = N_genes, ncol = N_cell)
  rownames(gene_expression_var_matrix) <- rownames(gene_expression_matrix)
  colnames(gene_expression_var_matrix) <- colnames(gene_expression_matrix)
  
  # fill gene expression variability matrix
  for(cond in 1:N_cond){
    tmp_cell_ids <- names(dataset_parameter[[cond]]$lib_size)
    tmp_N_cell <- length(tmp_cell_ids)
    
    # get variability values and fix possible NA or negative values
    variability_values <- dataset_parameter[[cond]]$variability
    variability_values[is.na(variability_values)]<-0
    variability_values[variability_values<0]<-min(variability_values[variability_values>0])
    
    N_cell_mem <- 5000
    if(tmp_N_cell < N_cell_mem){
      gene_expression_var_matrix[, tmp_cell_ids] <- rep(variability_values, tmp_N_cell)
    }else{
      tmp_data <- rep(variability_values, N_cell_mem)
      N_mult <- floor(tmp_N_cell/N_cell_mem)
      
      for(ind in c(1:N_mult)){
        ind_range <- c( ((ind-1)*N_cell_mem+1) : (ind*N_cell_mem) )
        gene_expression_var_matrix[, tmp_cell_ids[ind_range]  ] <- tmp_data
      }
      if(N_mult*N_cell_mem < tmp_N_cell){
        ind_range <- c( (N_mult*N_cell_mem+1) : tmp_N_cell)
        gene_expression_var_matrix[, tmp_cell_ids[ind_range]  ] <- tmp_data[c(1: (length(ind_range)*N_genes) )]
      }
      
      rm(tmp_data); gc(verbose = FALSE)
    }
    
  }
  

  for(cond in 1:N_cond){
    
    if(!is.null(dataset_parameter[[cond]]$intensity_2)){ # check if bimodal gene expression is present in this experimental condition
      tmp_cell_ids <- names(dataset_parameter[[cond]]$lib_size)
      tmp_N_cell <- length(tmp_cell_ids)
      
      # get intensity values for mode 2
      intensity_values <- dataset_parameter[[cond]]$intensity_2
      
      # get variability values for mode 2 and fix possible NA or negative values
      variability_values <- dataset_parameter[[cond]]$variability_2
      variability_values[is.na(variability_values)]<-0
      variability_values[variability_values<0]<-min(variability_values[variability_values>0])
      
      # get probability for mode 2 (as 1 - p_mode)
      p_mode_2 <- 1 - dataset_parameter[[cond]]$p_bimod
      
      # identify bimodal genes (i.e. having intensities != NA and probability of mode 2 beign greater than 0)
      bimodal_genes_id <- ( ( !is.na(intensity_values) ) & (p_mode_2>0) )
      bimodal_genes_name <- rownames(gene_expression_matrix)[bimodal_genes_id]
      
      intensity_values_tmp <- intensity_values[bimodal_genes_id]
      variability_values_tmp <- variability_values[bimodal_genes_id]
      p_mode_2_tmp <- p_mode_2[bimodal_genes_id]
      
      N_bimod_gene <- length(intensity_values_tmp)
      
      # simulate bimodal genes in the cells
      for(cell in tmp_cell_ids){
        
        # use the probability to be in mode 2 to select which genes are in the second expression mode in the current cell
        mode2_ind <- as.logical(rbinom(N_bimod_gene, 1, p_mode_2_tmp))
        
        # only for the selected genes, change the gene expression intensity matrix and the gene expression variability matrix
        # with the values describing the second expression mode
        gene_expression_matrix[bimodal_genes_name[mode2_ind],cell] <- intensity_values_tmp[mode2_ind]
        gene_expression_var_matrix[bimodal_genes_name[mode2_ind],cell] <- variability_values_tmp[mode2_ind]
      }
      
    }
    
  }
  
  
  
  # get samples library sizes
  sample_lib_size <- unlist(lapply( dataset_parameter, function(x){return(x$lib_size)} ), use.names = FALSE)
  names(sample_lib_size) <- colnames(gene_expression_matrix)
  
  
  batch_factor_matrix <- NULL
  
  # if user does not require the batch factor matrix as output, free the memory and return a NULL matrix
  if(output_batch_matrix == FALSE){
    rm(batch_factor_matrix); gc(verbose = FALSE);
    batch_factor_matrix <- NULL
  }
  
  
  
  ### Simulate biological variability
  cat("Simulating biological variability ... ", "\n")
  
  gene_expression_matrix_bio_var <- gene_expression_matrix
  
  # simulate biological variability using a gamma
  gene_expression_matrix_bio_var <- matrix(
    stats::rgamma(n = nrow(gene_expression_matrix_bio_var)*ncol(gene_expression_matrix_bio_var),
           shape = 1/gene_expression_var_matrix,
           scale = gene_expression_var_matrix*gene_expression_matrix),
    ncol = ncol(gene_expression_matrix)
  )
  
  # feature having null (i.e. zero) variability have no variability, so "undo" the gamma
  zero_var_index <- (gene_expression_var_matrix == 0)
  gene_expression_matrix_bio_var [zero_var_index] <- gene_expression_matrix [zero_var_index]
  
  rownames(gene_expression_matrix_bio_var) <- rownames(gene_expression_matrix)
  colnames(gene_expression_matrix_bio_var) <- colnames(gene_expression_matrix)
  
  # if user does not require the gene intensity and gene variability matrices as output, free the memory and return NULL matrices
  if(output_sim_param_matrices == FALSE){
    rm(gene_expression_matrix, gene_expression_var_matrix); gc(verbose = FALSE)
    gene_expression_matrix <- NULL
    gene_expression_var_matrix <- NULL
  }
  
  # identify the maximum library size
  max_lib_size <- max(sample_lib_size)
  
  # set the input fragment library size (the population size parameter for MH)
  input_fragment_lib_size <- max_lib_size * 10^2
  digits<-floor(log10(input_fragment_lib_size))+1
  new_libsize<-10^digits
  
  gene_expression_matrix_bio_var_scaled <- round(t(t(gene_expression_matrix_bio_var)*new_libsize/colSums(gene_expression_matrix_bio_var)))
  num_fragment <- colSums(gene_expression_matrix_bio_var_scaled)
  
  
  ### Simulate technical variability
  cat("Simulating technical variability ... ", "\n")
  
  sim_count_matrix <- matrix(0, ncol = ncol(gene_expression_matrix_bio_var_scaled), nrow = nrow(gene_expression_matrix_bio_var_scaled) )
  rownames(sim_count_matrix) <- rownames(gene_expression_matrix_bio_var_scaled)
  colnames(sim_count_matrix) <- colnames(gene_expression_matrix_bio_var_scaled)
  
  # if the user set NO seed for count data simulation
  if(is.null(count_data_simulation_seed)){
    for(sample in colnames(sim_count_matrix)){
      sim_count_matrix[, sample] <- simulate_hyper(avgAbund = gene_expression_matrix_bio_var_scaled[, sample],
                                                   seqdepth = sample_lib_size[sample],
                                                   digits = digits,
                                                   max_val = num_fragment[sample])
    }
  }

  
  ### collect and return the results
  return(list(count_matrix = sim_count_matrix,
              gene_matrix = gene_expression_matrix_bio_var,
              abundance_matrix = gene_expression_matrix,
              variability_matrix = gene_expression_var_matrix,
              batch_factors_matrix = batch_factor_matrix )
  )
}

#' Data to showcase scRNA and scATAC-seq association
#' @format A dataframe with two columns and rows according to gene/feature relationships
#'  \describe{
#'      \item{Peak_ID}{ATAC chromosomic positions associated to genes}
#'      \item{Gene_ID}{RNA genes associated to peaks}
#'      }
#'      
#'  @source {Created in-house to serve as an example}
#' @name associationList
#' @docType data
#' @usage data("associationList")
data(associationList)

#' Data to test scMOSim
#' @format A seurat Object, subset from seuratData with RNA
#'  \describe{
#'      \item{assays}{RNA expression values}
#'      \item{meta.data}{annotations of celltypes}
#'      }
#'      
#'  @source {https://github.com/satijalab/seurat-data, we took 11 cells 
#'  from each of 4 celltypes}
#'  This is how:
#'  dat <- pbmcMultiome.SeuratData::pbmc.rna
#'  dat <- subset(x = dat, subset = seurat_annotations %in% c("CD4 TEM", 
#'                                                            "cDC", "Memory B", "Treg"))
#'  unique_cell_types <- unique(datATmeta.data$seurat_annotations)
#'  extracted_cells <- list()
#'  cellnames <- c()
#'  for (cell_type in unique_cell_types) {
#'    type_cells <- subset(dat, subset = seurat_annotations %in% cell_type)
#'    counts <- as.matrix(type_cellsATassays[["RNA"]]ATcounts)
#'    extracted_cells[[cell_type]] <- counts[, 1:10]
#'    cellnames <- append(cellnames, replicate(11, cell_type))
#'  }
#'  scrna <- Reduce(cbind, extracted_cells)
#' @name scrna
#' @docType data
#' @usage data("scrna")
data(scrna)

#' Data to test scMOSim
#' @format A seurat Object, subset from seuratData with ATAC
#'  \describe{
#'      \item{assays}{ATAC expression values}
#'      \item{meta.data}{annotations of celltypes}
#'      }
#'      
#'  @source {https://github.com/satijalab/seurat-data, we took 11 cells 
#'  from each of 4 celltypes}
#' @name scatac
#' @docType data
#' @usage data("scatac")
data(scatac)

#' Data to extract human TF
#' @format vector of gene names
#'  \describe{
#'      \item{data.frame}{gene names corresponding to TF and to Target genes}
#'      }
#'  @source {https://tflink.net/}
#' @name TF_human
#' @docType data
#' @usage data("TF_human")
data(TF_human)

#' @include Simulator.R SimulatorRegion.R simulate_WGBS_functions.R
#' @import HiddenMarkov
#' @importFrom IRanges IRanges
#' @importFrom S4Vectors queryHits
#' @importFrom rlang .data
NULL

#
# Methyl-seq simulator
#
# Based on simulate_WGBS.R script from WGBSSuite V 0.3 (owen.rackham@imperial.ac.uk)
#
setMethod("initialize", signature="SimMethylseq", function(.Object, idToGene, totalFeatures = nrow(idToGene), ...) {

    # Due to package size restraints, default data has a loc DF used as idToGene for methylation.
    if (ncol(idToGene) > 2) {
        .Object@locs <- idToGene %>% dplyr::mutate(ID = paste(chr, 
                                      format(start, scientific = FALSE),
                                      format(end, scientific = FALSE), sep = "_"))

        # Reconstruct original idToGene
        idToGene <- .Object@locs %>% dplyr::select(ID, Gene)
    }

    # Restrict the number of locations to totalFeatures
    # (Methyl-seq lacks "data")
    if (nrow(idToGene) > totalFeatures) {
        idToGene <- dplyr::sample_n(idToGene, totalFeatures)
    }

    .Object <- callNextMethod(.Object, idToGene = idToGene, totalFeatures = totalFeatures, ...)

    # Filter those CHR having less than 2 observations
    .Object@locs <- dplyr::semi_join(.Object@locs, dplyr::count(.Object@locs, chr)
                                     %>% dplyr::filter(n > 1),
                                     by = "chr") %>%
        dplyr::filter(!is.na(chr))

    # Override WGBS function to consider the CpG coordinates instead of the index
    find_adjusted_blocks <- function(a, positions) {
        l <- length(a)
        coords <- list()
        index <- 1
        state <- a[1]
        on <- positions[1]
        off <- 0
        for (i in 2:l) {
            if (a[i - 1] != a[i]) {
                if (on == 0) {
                    on <- positions[i]
                } else{
                    off <- positions[i]
                    coords[[index]] <- c(on, off, a[i], off - on)
                    index <- index + 1
                    on <- positions[i]
                    off <- 0
                }
            } else if (i == l) {
                # Add last block if last part was not executed
                off <- positions[i] + 1
                coords[[index]] <- c(on, off, a[i], off - on)
            }
        }

        coords_mat <- do.call(rbind, coords)

        return(coords_mat)
    }


    # This simulator needs to previously create the status blocks to modify
    # the simulation settings.
    #
    # Repeat for every chromosome
    .Object@WGBSparams$chrBlocks <- sapply(setNames(nm = as.character(sort(unique(.Object@locs$chr)))), function(chr) {
        message("Creating methylation state blocks for chr ", chr)

        # Order by ascendent position
        regions <- dplyr::arrange(.Object@locs[.Object@locs$chr == chr, ,drop=FALSE], start)

        #simulate the state transition based on the location of the CpGs
        a <- simulate_state_transition((nrow(regions) * .Object@WGBSparams$m),
                                       c(0.01, 0.99, 0.08, 0.99),
                                       as.numeric(regions$start), 0.5,
                                       .Object@WGBSparams$transition_size)

        #extract the positions of the blocks
        state_blocks <- find_adjusted_blocks(a, regions$start)

        return(list(
            'a' = a,
            'state' = state_blocks,
            'chr' = chr
            ))
    }, simplify = 'array')

    # TODO: keep the provided data instead of forcing the default?
    .Object@data <- data.frame(Counts=rep(0, length(unique(.Object@idToGene$ID))),
                               row.names = unique(.Object@idToGene$ID), stringsAsFactors = FALSE)

    return(.Object)
})

setMethod("initializeData", signature="SimMethylseq", function(object, simulation) {
    #############################################################
    # Code from function generate_sim_set [simulate_WGBS.R]
    # Version 0.3 (01 June 2015)
    #############################################################
    object@WGBSparams$number_of_replicas <- simulation@numberReps
    object@WGBSparams$number_of_samples <- simulation@numberGroups

    # TODO: check if M values will be used?
    object@min <- 0
    object@max <- 1

    make_differential_fixed <- function(state_blocks,percentage,a){
        l<-length(a)
        states<-unique(state_blocks[,3])
        n <-length(states)
        diff_meth <- matrix(data=0,nrow=1,ncol=l)
        for(i in seq_len(n)){
            blocks <- state_blocks[state_blocks[,3]==i,]
            # MOD: sum only if it's matrix
            block_length <- if(is.null(dim(blocks))) blocks[4] else sum(blocks[,4])
            cutoff_length <- percentage[i]*block_length
            so_far <- 0
            while((so_far <= cutoff_length)&&!is.null(dim(blocks)[1])){
                picked<- sample(seq_len(dim(blocks)[1]), 1)
                if(so_far+blocks[picked,4] < cutoff_length){
                    so_far <- so_far + blocks[picked,4]
                    diff_meth[blocks[picked,1]:blocks[picked,2]]<-1
                }
                blocks<- blocks[-(picked),]
            }
        }
        return(diff_meth)
    }

    # Fixed function adding the last block
    find_the_blocks <- function(a){
        l<-length(a)
        coords<-list()
        index<-1
        state<-a[1]
        on<-1
        off<-0
        for(i in 2:l){
            if(a[i-1] != a[i]){
                if(on == 0){
                    on<-i
                }else{
                    off<-i
                    coords[[index]]<-c(on,off,a[i],off-on)
                    index<-index+1
                    on<-i
                    off<-0
                }
            } else if (i == l) {
                # Add last block if last part was not executed
                off <- i
                coords[[index]] <- c(on, off, a[i], off - on)
            }
        }

        coords_mat <- do.call(rbind,coords)

        return(coords_mat)
    }

    # Load methylation simulation settings
    methProfiles <- simulation@simSettings$geneProfiles[[class(object)]]

    # DE genes identifiers
    # geneSamples
    genesDE <- simulation@simSettings$featureSamples$SimRNAseq$DE

    # Settings for flat on all groups
    flatProfiles <- simulation@simSettings$geneProfiles$FlatGroups$SimRNAseq

    return(with(object@WGBSparams, {

        methData <- vector("list", simulation@numberGroups)
        regTable <- list()

        # Select a random number of groups to be non-modified
        non_mod_groups <- stats::runif(runif(1, 1, simulation@numberGroups - 1), 1, simulation@numberGroups)

        # Repeat process for every chromosome
        for (chr in as.character(unique(object@locs$chr))) {
            message("Simulating methylation data from CpG locations of chr ", chr, " (", distType, ")")

            regions <- object@locs[object@locs$chr == chr, ]

            a <- chrBlocks[['a', chr]]
            state_blocks <- find_the_blocks(a)
            n <- length(a)
            locs <- regions$start
            # state_blocks <- chrBlocks[['state', chr]]

            # Select blocks of the current chromosome that contain at least
            # 1 DE gene and is affected by methylation
            # diffBlocks <- subset(methProfiles, grepl(paste0("Block", chr), Block) &
            #            ! is.na(Effect) & Gene %in% genesDE, 'Block')
            chrMethProfiles <- methProfiles[methProfiles$ID %in% rownames(regions), ]

            # Select the regions that affect at least one DE gene
            diffRegions <- subset(chrMethProfiles, subset = ! is.na(Effect) & Gene %in% genesDE)

            # Select all the regions contained on the previously selected blocks
            diffBlocks <- subset(chrMethProfiles, subset = Block %in% diffRegions$Block)

            # indexBlock <- dplyr::filter(chrMethProfiles, Block %in% diffBlocks) %>%
            #     select(ID, Block) %>% distinct()
            #
            # chrMethProfiles <- dplyr::filter(methProfiles, ID %in% rownames(regions), ! is.na(Effect), Gene %in% genesDE)

            # Select the regions in the profile matrix in the same order as they
            # are here, and check if the block is inside the previously selected
            # list of blocks, transforming the boolean to 0/1 values.
            diff_methed <- matrix(data = as.numeric(rownames(regions) %in% diffBlocks$ID), nrow = 1, ncol = n)

            # Select all

            # The number of the block "Block<Chr>.number" equals to the row
            # number of the state block matrix
            # diffBlocks <- as.numeric(stri_extract_last_regex(diffBlocks, '\\d+'))

            # Emulate the ouput of the function "make_differential", a matrix with
            # 1 row and N (number of CpG) columns, with 0 for non-modified and 1
            # for modified.
            # diff_methed <- matrix(data=0, nrow=1, ncol=n)

            #set the percentage of DM in each block type
            # percs_for_diff <- c(0,0,0,0.5)

            #update the blocks to be differentially methylated
            # diff_methed <- make_differential(state_blocks, percs_for_diff, a)

            #create the simulated reads methylated/unmethylated at each CpG, at the moment this is hard coded to be 3 replicates of each type
            #The phase diff param control how different the methylation is in the differentially methylated regions.
            errors <-
                list(error_m, ((error_d + error_m) / 2), error_d, ((error_d + error_m) / 2))
            means <-
                list(mean_m, ((mean_d + mean_m) / 2), mean_d, ((mean_d + mean_m) / 2))


            # Generate data for every sample and every rep
            repData <- list()
            # Use format to prevent scientific notation on rownames
            # repDataNames <- regionspaste(chr, format(regions$start, scientific = FALSE),
                                  # format(regions$end, scientific = FALSE), sep="_") #regionNames(object, chrNumber=i, start=locs)

            # Make all groups identical and later choose random values like in the
            # other simulators.
            diffPhase <- rep(0, simulation@numberGroups)

            prob_d_factor <- lapply(seq_len(simulation@numberGroups), function(f) {
                return(list(
                    d=hypo_hyper_diffs(prob_d, diffPhase[f], diff_methed, balance),
                    m=hypo_hyper_diffs(prob_m, diffPhase[f], diff_methed, balance)
                ))
            })

            if (! is.null(flatProfiles)) {
                flatMethProfiles <- dplyr::select(chrMethProfiles, ID, Gene, Block, Effect) %>%
                    dplyr::inner_join(flatProfiles, by = c("Gene" = "ID")) %>%
                    dplyr::select(Block, Effect, dplyr::starts_with("Group")) %>%
                    dplyr::filter(!is.na(Effect)) %>%
                    dplyr::distinct()

                if (nrow(flatMethProfiles)) {
                    # By default the methylation prob is high, so for reflecting
                    # a change we lower it on the flat groups instead of increasing
                    # it on the proper group (read below).
                    prob_m_mod <- prob_m - max(phase_diff)
                    prob_d_mod <- prob_d + max(phase_diff)

                    # Repeat for every block
                    for (i in seq_len(nrow(flatMethProfiles))) {
                        blockProfiles <- unlist(flatMethProfiles[i, ])

                        # ID of the block
                        blockId <- blockProfiles[1]

                        # Effect of the block
                        blockEffect <- blockProfiles[2]

                        # Expression profiles
                        blockExpr <- blockProfiles[seq(3, length.out = simulation@numberGroups)]

                        # Retrieve the groups used as reference
                        blockFlat <- which(blockExpr == 'flat')

                        # Modified groups
                        blockNonFlat <- which(blockExpr != 'flat')

                        # Associated effect: enhancer or repressor
                        exprEffect <- blockExpr[blockNonFlat][1]

                        # Positions of the probs vector to update
                        # blockIndexes <- match(blockId, chrMethProfiles$Block)
                        blockIndexes <- match(unique(subset(chrMethProfiles, Block == blockId)$ID), rownames(regions))

                        # Check every RNA-seq group for increased (enhancer) or
                        # decreased (repressor) expression, altering the probs of
                        # methylated/non-methylated reads depending on the effect
                        # associated to the block:
                        #   - enhancer: will increase methylation probs with enhancer,
                        # and decrease them with repressor.
                        #   - repressor: decrease methylation probs with enhancer, and
                        # increase them with repressor.
                        #
                        # If the effect of the regulator is complementary to the
                        # change on the expression data, increase methylation probs
                        # and reduce non-methylated.
                        if (blockEffect == exprEffect) {
                            # Modify flat (reference) groups
                            changeBlocks <- blockFlat
                        } else {
                            # Modify non-flat groups
                            changeBlocks <- blockNonFlat
                        }

                        # Repeat for each affected group
                        for (f in changeBlocks) {
                            prob_d_factor[[f]]$d[blockIndexes] <- prob_d_mod
                            prob_d_factor[[f]]$m[blockIndexes] <- prob_m_mod
                        }
                    }
                }
            }

            # Get one "non-mod" data
            # prob_nonmod <- prob_d_factor[[which(diffPhase == 0)[1]]]
            # prob_nonmod <- prob_d_factor[[which.max(diffPhase == 0)]]
            prob_nonmod <- prob_d_factor[[1]]

            probs <- vector("list", simulation@numberGroups)

            for (f in seq_len(simulation@numberGroups)) {
                # Diff. sites for every factor
                prob_f <- prob_d_factor[[f]]

                # Non-mod
                # if (diffPhase[f] == 0) {
                #     prob_f <- list(prob_f$m, ((prob_nonmod$m + prob_nonmod$d) / 2), prob_f$d, ((prob_f$m + prob_f$d) / 2))
                # } else {
                #     prob_f <- list(prob_f$m, ((prob_f$m + prob_f$d) / 2), prob_f$d, ((prob_f$m + prob_f$d) / 2))
                # }

                prob_f <- list(prob_f$m, ((prob_f$m + prob_f$d) / 2), prob_f$d, ((prob_f$m + prob_f$d) / 2))

                probs[[f]] <- prob_f

                # New matrix for every sample
                repData <- matrix(data=0, nrow=simulation@numberReps, ncol=n)

                for (r in seq_len(simulation@numberReps)) {
                    if (distType == 'binomial') {
                        sRepData <-
                            generate_replicat_methyl_bin_data(a, probs, means, 0, errors, locs, f, output_path)
                    } else if (distType == 'truncated') {
                        sRepData <-
                            generate_replicat_methyl_truncated_nbin_data(a, probs, means, 0, errors, locs, f, 20, output_path)
                    } else{
                        sRepData <-
                            generate_replicat_methyl_nbin_data_model_3(a, probs, means, 0, errors, locs, f, 30)
                    }
                    # Columns:
                    #         V1: location in base pairs
                    #         V2: differentially methylated flag
                    #
                    # Blocks of 4 columns for each replica as follows:
                    #
                    #         Vn: Number of methylated reads
                    #         Vn+1: Number of de-methylated reads
                    #         Vn+2: Total number of reads
                    #         Vn+3: Proportion of methylated vs de-methylated reads
                    sRepData <- sRepData[returnColumn,]

                    repData[r,] <- sRepData
                }

                repData <- t(repData)

                # Add rows to the factor data
                rownames(repData) <- regions$ID #repDataNames

                # Repeating for every group
                methData[[f]] <- rbind(methData[[f]], repData)
            }
        }

        # Save random values for every group to be used later on simulate function.
        # This needs to be done on a "block basis".
        uniqueBlocks <- unique(methProfiles$Block)

        object@WGBSparams$randomCounts <- lapply(seq_len(simulation@numberGroups), function(group) {
            # Min/max values
            simRange <- range(methData[[group]])

            # Create random values for every block
            randomValues <- stats::runif(length(uniqueBlocks), min = simRange[1], max = simRange[2])

            return(dplyr::inner_join(methProfiles, data.frame(Block=uniqueBlocks,
                                                              M=randomValues,
                                                              stringsAsFactors = FALSE),
                                     by = c("Block" = "Block")) %>%
                       dplyr::distinct(ID, M)) %>%
                       dplyr::mutate(M = jitter(M))
        })

        # Merge simulated data from every group
        methData <- do.call(cbind, methData)

        object@WGBSparams$blocks <- chrBlocks
        object@data <- methData

        # Pattern "Counts.Group" required for post-simulation. Later it will
        # be correctly renamed.
        colnames(object@data) <- paste('Counts.Group', seq_len(ncol(object@data)))

        return(object)
    }))
})


setMethod("simulateParams", signature="SimMethylseq", function(object, simulation, counts, profiles, group, ids) {
    # Blocks
    randomValues <- object@WGBSparams$randomCounts[[group]]
    randomValues <- randomValues[match(ids, randomValues$ID), ]

    # Order [m, M]
    m <- pmin(counts, randomValues$M)
    M <- pmax(counts, randomValues$M)

    # Do not add extra noise
    # noiseValues <- matrix(0, ncol = length(simulation@times), nrow = length(counts))
    # Noise with fixed parameters and function (the value can only go from 0 to 1)
    # TODO: remove this extra noise?
    noiseValues <-
        replicate(length(simulation@times),
                  do.call(
                      object@noiseFunction,
                      list(n = length(counts), sd = 0.03)
                  ))

    repressionMean <- stats::runif(length(M), min = (M+m)/2, max = M)
    inductionMean <- stats::runif(length(m), min = m, max = (M+m)/2)

    return(list(
        'randomCounts' = randomValues$M,
        'noiseValues' = noiseValues,
        'm' = m,
        'M' = M,
        'repression.Mean' = repressionMean,
        'induction.Mean' = inductionMean,
        'mean.counts' = ifelse(grepl('repression', profiles),(repressionMean + m)/2, (inductionMean + M)/2),
        'counts' = counts
    ))
})

setMethod("postSimulation", signature="SimMethylseq", function(object, simulation) {
    # Limit the range of proportions to 0-1
    object@simData[object@simData < 0] <- 0
    object@simData[object@simData > 1] <- 1

    # Add M-values
    if (object@Mvalues) {
        # methLevel & rowData comes from BiSeq package?
        betaThreshold <- object@betaThreshold

        # Convert to numeric with data.matrix
        beta <- pmin(pmax(data.matrix(object@simData), betaThreshold), 1 - betaThreshold)

        colnames(beta) <- colnames(object@simData)

        rownames(beta) <- rownames(object@simData)

        # beta <- beta[rowVars(beta, na.rm=T)!=0,]
        M <- log2(beta/(1-beta))

        # Return M values
        # TODO: decide which data to return
        # object@simData <- list(
        #     raw=object@simData,
        #     beta=beta,
        #     M=M
        # )

        object@simData <- as.data.frame(M)
    }

    # Reorder the columns to respect the order timeX.<reps>
    numberTimes <- length(simulation@times)

    columnReorder <- unlist(
        lapply(seq_len(numberTimes),
           seq,
           by = numberTimes,
           length.out = simulation@numberReps)
    )

    # Add extra groups
    if (simulation@numberGroups > 1) {
        for (groupNumber in seq(from = 2, to = simulation@numberGroups)) {
            columnReorder <- c(columnReorder, columnReorder +
                                   (numberTimes * simulation@numberReps)*(groupNumber - 1))
        }
    }

    object@simData <- object@simData[, columnReorder]

    object <- callNextMethod(object, simulation)

    return(object)
})

setMethod("adjustProfiles", signature="SimMethylseq", function(object, simulation, profiles, step) {

    message("Adjusting methylation profiles")

    availableEffects <- object@regulatorEffect[grep("NE", names(object@regulatorEffect), invert = TRUE)]

    switch(step,
           Effect = return(dplyr::left_join(profiles, unique(dplyr::select(object@locs, chr, start, end, ID)), by = c("ID" = "ID")) %>%
                          dplyr::group_by(chr) %>% dplyr::do({
                              # Chromosome name
                              chrName <- .$chr[[1]]

                              message(sprintf("Generating block methylation data for chromosome %s.", chrName))

                              # State blocks for the current chromosome
                              # Note: almost half of the blocks generated by WGBS consist of a single CpG island repeated on another block
                              # so we filter them.
                              state_blocks <- data.frame(object@WGBSparams$chrBlocks[['state', as.character(chrName)]],
                                                         stringsAsFactors = FALSE)

                              stateIRanges <- IRanges::IRanges(start = state_blocks[,1], end = state_blocks[,2] - 1)
                              chrIRanges <- IRanges::IRanges(start = .$start, end = .$end)

                              # The query column in overlaps will correspond to the block number.
                              blockOverlaps <- IRanges::findOverlaps(stateIRanges, chrIRanges)

                              blockNames <- S4Vectors::queryHits(blockOverlaps)

                              if (length(blockNames) < nrow(.)) {
                                  blockNames <- c(blockNames, seq(from = max(blockNames) + 1,
                                                                  length.out = nrow(.) - length(blockNames)))
                              }

                              within(., {
                                  # Rename ID column to CpG
                                  Keep.CpG <- .$ID
                                  # Different name for every block
                                  # Overwrite ID to allow grouping
                                  ID <- paste('Block', chrName, blockNames, sep = ".")
                                  # Assign a random effect per block
                                  # Keep the already set NA (non DE genes)
                                  Effect <- ifelse(is.na(.$Effect), NA, sample(names(availableEffects), size = 1,
                                                                                   prob = as.numeric(availableEffects)))
                              })
                          }) %>% dplyr::ungroup()),
            Groups = return({
                    # Retrieve true group effect for each block
                    dplyr::select(profiles, ID, Effect, dplyr::starts_with("Group")) %>%
                        dplyr::filter(!is.na(Effect)) %>%
                        dplyr::select(-Effect) %>%
                        dplyr::distinct() %>%
                        dplyr::bind_rows(dplyr::select(profiles, ID, Effect, dplyr::starts_with("Group")) %>%
                                             dplyr::filter(is.na(Effect)) %>%
                                             dplyr::select(-Effect) %>%
                                             dplyr::distinct()
                        )%>%
                    # Join with the full profile table
                    dplyr::left_join(dplyr::select(profiles, - dplyr::starts_with("Group")), by = c("ID" = "ID")) %>%
                    dplyr::mutate(Block = ID, ID = Keep.CpG) %>%
                    dplyr::select(ID, Gene, Block, Effect,
                                  dplyr::starts_with("Effect.Group"), dplyr::starts_with("Group"), dplyr::starts_with("Tmax.")) %>%
                    dplyr::distinct()
            })
    )

    # By default return the same
    return(profiles)
})

#' @import methods stringi matrixStats
#' @importFrom stats rnorm runif rbeta rbinom rpois quantile
#' @importFrom utils data
NULL

#'
#' This class manages the global simulation process, like associating genes with
#' gene classes, regulatory programs and other settings. Finally it will
#' initialize the simulators with their options that will use the previously
#' generated settings to simulate the data.
#'
#' @slot simulators Vector containing either S4 initialized classes of
#'   simulators or a list with the class name as keys, and its options as value,
#'   see example.
#' @slot totalGenes A number with the total number of genes including not
#'   expressed. Overwritten if a genome reference is provided. Currently not used
#'   as we force to provide real data.
#' @slot diffGenes A number with the total number of differential genes (if
#'   value > 1) or \% or total genes (if value < 1).
#' @slot numberReps Number of replicates of the experiment.
#' @slot numberGroups Number of samples considered on the experiment.
#' @slot times Numeric vector containing the measured times. If numberGroups <
#'   2, the number of times must be at least 2.
#' @slot geneNames Read only. List containing the IDs of the genes. Overwrited
#'   by the genome reference if provided. Currently not used as we force to
#'   provide real data.
#' @slot simSettings List of settings that overrides initializing the
#'   configuration of the simulation by passing a previously generated list.
#'   This could be used to tweak by hand the assigned profiles, genes,
#'   regulatory programs, etc.
#' @slot noiseFunction Noise function to apply when simulating counts. Must
#'   accept the parameter 'n' and return a vector of the same length. Defaults
#'   to `rnorm`
#' @slot profiles Named list containing the patterns with their coefficients.
#' @slot profileProbs Numeric vector with the probabilities to assign each of
#'   the patterns. Defaults to 0.2 for each.
#' @slot noiseParams Default noise parameters to be used with noise function.
#' @slot depth Default depth to simulate.
#' @slot TFtoGene Boolean (for default data) or 3 column data frame containing
#'   Symbol-TFGene-LinkedGene
#' @slot minMaxQuantile Numeric vector of length 2 indicating the quantiles to
#'   use in order to retrieve the absolute minimum and maximum value that a
#'   differentially expressed feature can have.
#' @slot minMaxFC Numeric vector of length 2 indicating the minimum and maximum
#'   fold-change that a differentially expressed feature can have.
#'
#' @export
#' @keywords internal
#'
#'
setClass(
    "MOSimulation",
    slots = c(
        simulators = "list",
        totalGenes = "numeric",
        diffGenes = "numeric",
        numberReps = "numeric",
        numberGroups = "numeric",
        times = "vector",
        geneNames = "character",
        simSettings = "list",
        profiles = "list",
        profileProbs = "list",
        noiseFunction = "function",
        noiseParams = "list",
        depth = "numeric",
        minMaxQuantile = "numeric",
        minMaxFC = "numeric",
        TFtoGene = "ANY"
    ),
    prototype = list(
        diffGenes = .15,
        numberReps = 3,
        numberGroups = 2,
        times = c(0, 2, 4, 12, 24),
        depth = 74,
        noiseFunction = stats::rnorm,
        noiseParams = list("sd" = 0.3),
        profiles = list(
            continuous.induction = c("a1", "b1", 0),
            continuous.repression = c("a1", "b1.neg", 0),
            transitory.induction = c("a2", "b2", "c2"),
            transitory.repression = c("a2.neg", "b2.neg", "c2.neg"),
            flat = c(0, 0, 0)
        ),
        profileProbs = list(
            continuous.induction = .235,
            continuous.repression = .235,
            transitory.induction = .235,
            transitory.repression = .235,
            flat = .06
        ),
        minMaxQuantile = c(0.3, 0.95),
        minMaxFC = c(3, 8),
        TFtoGene = NULL
    )
)

#'
#' Virtual class containing common methods and slots for child classes.
#'
#' @slot name Name of the simulator to be used in messages.
#' @slot data Data frame containing the initial sample to be used, with the
#'   features IDs as rownames and only one column named "Counts".
#' @slot regulator Boolean flag to indicate if the omic is a regulator or not.
#' @slot regulatorEffect Possible regulation effects of the omic (enhancer,
#'   repressor or both).
#' @slot idToGene Data frame with the association table between genes and other
#'   features. The structure must be 2 columns, one named "ID" and the other
#'   "Gene".
#' @slot min Minimum value allowed in the omic.
#' @slot max Maximum value allowed in the omic.
#' @slot depth Sequencing depth to simulate.
#' @slot depthRound Number of decimal places to round when adjusting depth.
#' @slot depthAdjust Boolean indicating whether to adjust by sequencing depth or
#'   not.
#' @slot totalFeatures Number of features to simulate. This will replace the
#'   data with a subset.
#' @slot noiseFunction Noise function to apply when simulating counts. Must
#'   accept the parameter 'n' and return a vector of the same length. Defaults
#'   to `rnorm`
#' @slot increment Read-only. Minimum value to increase when simulating counts.
#' @slot simData Contains the final simulated data.
#' @slot pregenerated Indicates if the child class will generate the simulated
#'   data instead of the general process.
#' @slot randData Auxiliary vector containing the original count data in random
#'   order with other adjustments.
#' @slot noiseParams Noise parameters to be used with noise function.
#' @slot roundDigits Number of digits to round the simulated count values.
#' @slot minMaxQuantile Numeric vector of length 2 indicating the quantiles to
#'   use in order to retrieve the absolute minimum and maximum value that a
#'   differentially expressed feature can have.
#' @slot minMaxFC Numeric vector of length 2 indicating the minimum and maximum
#'   fold-change that a differentially expressed feature can have.
#' @slot minMaxDist Named list containing different minimum and maximum
#'   constraints values calculated at the beginning of the simulation process.
#' @slot replicateParams Named list containing the parameters a and b to be used
#'   in the replicates generation process, see the vignette for more info.
#'
#' @export
#' @keywords internal
#'
setClass(
    "MOSimulator",
    slots = c(
        name = "character",
        data = "ANY",
        simData = "ANY",
        randData = "ANY",
        regulator = "logical",
        regulatorEffect = "vector",
        idToGene = "ANY",
        min = "numeric",
        max = "numeric",
        increment = "numeric",
        depth = "numeric",
        depthRound = "numeric",
        depthAdjust = "logical",
        noiseFunction = "function",
        noiseParams = "list",
        roundDigits = "numeric",
        pregenerated = "logical",
        totalFeatures = "numeric",
        minMaxQuantile = "numeric",
        minMaxFC = "numeric",
        minMaxDist = "list",
        replicateParams = "list"
    ),
    prototype = list(
        regulator = TRUE,
        min = 0,
        increment = 0,
        depthRound = 0,
        depthAdjust = TRUE,
        regulatorEffect = NA,
        roundDigits = 0,
        pregenerated = FALSE,
        totalFeatures = Inf,
        replicateParams = list(
            "a" = 0.01,
            "b" = 1.5
        )
    ),
    contains = c("VIRTUAL")
)

#'
#' Virtual class containing general methods for simulators based on regions of
#' the chromosomes, like DNase-seq, ChIP-seq or Methyl-seq
#'
#' @slot locs Vector containing the list of locations of the sites.
#' @slot locsName Type of the site to simulate, only for debug.
#' @slot splitChar Character symbol used to split identifiers in chr/start/end
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "MOSimulatorRegion",
    slots = c(
        locs = "ANY",
        splitChar = "character"
    ),
    prototype = list(
        splitChar = "_"
    ),
    contains = c("MOSimulator", "VIRTUAL")
)



#'
#' Class to simulate RNA-seq data
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimRNAseq",
    prototype = list(
        name = "RNA-seq",
        # idToGene = matrix(NA),
        regulator = FALSE,
        replicateParams = list(
            "a" = 0.5, #0.01,
            "b" = 1.5 #1.5
        )
    ),
    contains = "MOSimulator"
)

#'
#' Class to simulate transcription factor data
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimTF",
    prototype = list(
        name = "TF",
        # idToGene = matrix(NA),
        regulator = TRUE
    ),
    contains = "SimRNAseq"
)

#'
#' Class to simulate miRNA-seq
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimmiRNAseq",
    prototype = list(
        name = "miRNA-seq",
        regulator = TRUE,
        idToGene = matrix(),
        regulatorEffect = list(
            'activator' = 0.01,
            'repressor' = 0.05,
            'NE' = 0.94
        ),
        replicateParams = list(
            "a" = -0.065,
            "b" = 1.566
        )
    ),
    contains = "MOSimulator"
)

#'
#' Class to simulate ChIP-seq data
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimChIPseq",
    prototype = list(
        name = "ChIP-seq",
        regulator = TRUE,
        idToGene = matrix(),
        regulatorEffect = list(
            'enhancer' = 0.48,
            'repressor' = 0.48,
            'NE' = 0.02
        ),
        replicateParams = list(
            # "a" = -0.042,
            # "b" = 1.265,
            "a" = 0.5,
            "b" = 1.5
        )
    ),
    contains = "MOSimulatorRegion"
)

#'
#' Class to simulate DNase-seq data
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimDNaseseq",
    prototype = list(
        name = "DNase-seq",
        regulator = TRUE,
        idToGene = matrix(),
        regulatorEffect = list(
            'enhancer' = 0.48,
            'repressor' = 0.48,
            'NE' = 0.02
        ),
        replicateParams = list(
            # "a" = -0.042,
            # "b" = 1.265
            "a" = 0.5,
            "b" = 1.5
        )
    ),
    contains = "MOSimulatorRegion"
)

#'
#' Class to simulate Methyl-seq data.
#'
#' @slot nCpG numeric. Number of CpG sites to simulate.
#' @slot pSuccessMethReg numeric. Probability of success in methylated region.
#' @slot pSuccessDemethReg numeric. Probability of success in non methylated
#'   region
#' @slot errorMethReg numeric. Error rate in methylated region
#' @slot errorDemethReg numeric. Error rate in methylated region
#' @slot nReadsMethReg numeric. Mean number of reads in methylated region.
#' @slot nReadsDemethReg numeric. Mean number of reads in non methylated
#'   regions.
#' @slot phaseDiff numeric. Phase difference in the differentially methylated
#'   regions between two samples
#' @slot balanceHypoHyper numeric. Balance of hypo/hyper methylation
#' @slot ratesHMMMatrix numeric. Matrix of values that describes the exponential
#'   decay functions that define the distances between CpG values.
#' @slot distType character. Distribution used to generate replicates:
#' @slot transitionSize numeric.
#' @slot PhiMeth matrix. Transition matrix for CpG locations.
#' @slot PhiDemeth matrix. <Not used>
#' @slot typesLocation numeric. <Not used>
#' @slot returnValue character. Selected column:
#' @slot betaThreshold numeric. Beta threshold value used to calculate M values.
#'
#' @export
#' @keywords internal
#' @rdname Simulator-class
#'
setClass(
    "SimMethylseq",
    slots = c(
        nCpG = "numeric",
        betaThreshold = "numeric",
        WGBSparams = "list",
        Mvalues = "logical"
    ),
    prototype = list(
        name = "Methyl-seq",
        regulator = TRUE,
        Mvalues = TRUE,
        nCpG = 5000,
        betaThreshold = 0.01,
        # maxValue = 1,
        # nRepeats = 1,
        idToGene = matrix(),
        pregenerated = TRUE,
        roundDigits = 5,
        WGBSparams = list(
            # Phase difference in the differentially methylated regions between two samples
            phase_diff = c(0, 0.1),
            #error_rate_in_differentially_methylated_region = 0.1
            # File to write results
            outfile = '/tmp/',
            #output_path
            probs = c(1, 1, 0.9, 0.8, 0.7, 0.6),
            # Transition size
            transition_size = 0,
            # Number of repeats (NOT REPLICATES!)
            m = 1,
            # Transition matrix for CpG locations
            Pi_m = matrix(c(0.65, 0.35, 0.2, 0.8), byrow = 
                            TRUE, nrow = 2),
            # Transition matrix for probability distributions
            Pi_d = matrix(c(0.9, 0.1, 0.1, 0.9), byrow = 
                            TRUE, nrow = 2),
            # Type of locations
            type_of_locations = 2,
            # Mean number of reads in methylated region
            mean_m = 29,
            # Mean number of reads in non methylated regions
            mean_d = 29,
            # Probability of success in  methylated region
            prob_m = 0.9203,
            # Probability of success in non methylated region
            prob_d = 0.076,
            # Error rate in dif. methylated region
            error_m = 0.1,
            # Error rate in non methylated region
            error_d = 0.1,
            # Balance: this is the balance of hypo/hyper methylation
            balance = 0.5,
            # Rates for HMM for CpG locations: this is the matrix of values that
            # describes the exponential decay functions that define the distances
            # between CpG values.
            rates_for_HMM_for_CpG_locations = c(0.019, 0.002),
            # Type: this can be either binomial or truncated and defines the
            # distribution of methylated reads at each CpG.
            type = "binomial",
            # methReads = 1, demethReads = 2, totalReads = 3, proportionReads = 4
            returnColumn = 4,
            distType = "nbin"#binomial"
            ),
        regulatorEffect = list(
            'enhancer' = 0.48,
            'repressor' = 0.48,
            'NE' = 0.01
        ),
        depthAdjust = FALSE
        ),
    contains = "MOSimulatorRegion"
)

## ----installing, eval = FALSE-------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("MOSim")
# 
# # For the latest development version
# install.packages("devtools")
# devtools::install_github("ConesaLab/MOSim")
# 

## ----test_run, eval = FALSE---------------------------------------------------
# library(MOSim)
# 
# # Create a list of omics data types (e.g., scRNA-seq and scATAC-seq)
# omicsList <- sc_omicData(list("scRNA-seq", "scATAC-seq"),
#                          data = NULL)
# 
# # Define cell types for your experiment
# cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#       'Memory_B' = c(31:40))
# 
# # Load an association list containing peak IDs related to gene names
# associationList <- data(associationList)
# 
# # Simulate multi-omics data with specific parameters
# testing_groups <- sc_mosim(
#   omicsList,
#   cell_types,
#   numberReps = 2,
#   numberGroups = 3,
#   diffGenes = list(c(0.2, 0.3), c(0.2, 0.3)),
#   minFC = 0.25,
#   maxFC = 4,
#   numberCells = NULL,
#   mean = NULL,
#   sd = NULL,
#   regulatorEffect = list(c(0.1, 0.2), c(0.1, 0.2), c(0.1, 0.2)),
#   associationList = associationList,
#   TF = FALSE
# )

## ----custom data, eval = FALSE------------------------------------------------
# # This is done to get a dataset to extract a matrix (for example purposes)
# scRNA <- MOSim::sc_omicData("scRNA-seq", data = NULL)
# count <- scRNA[["scRNA-seq"]]
# options(Seurat.object.assay.version = "v3")
# Seurat_obj <- Seurat::CreateAssayObject(counts = count, assay = 'RNA')
# # To format the data into sc_mosim-ready format, we pass the seurat
# # object containing the count data we extracted into sc_omicData
# omic_list_user <- sc_omicData(c("scRNA-seq"), data = c(Seurat_obj))

## ----default, eval = FALSE----------------------------------------------------
# omic_list <- sc_omicData(list("scRNA-seq"))
# cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#       'Memory_B' = c(31:40))
# 
# sim <- sc_mosim(omic_list, cell_types, TF = TRUE)

## ----testing, eval = FALSE----------------------------------------------------
# omic_list <- sc_omicData(c("scRNA-seq", "scATAC-seq"))
# cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#       'Memory_B' = c(31:40))
# sim <- sc_mosim(omic_list, cell_types, numberReps = 2,
#                numberGroups = 2, diffGenes = list(c(0.2, 0.3)), feature_no = 8000,
#                clusters = 3, mean = c(2*10^6, 1*10^6,2*10^6, 1*10^6),
#                sd = c(5*10^5, 2*10^5, 5*10^5, 2*10^5),
#                regulatorEffect = list(c(0.1, 0.2), c(0.1, 0.2)), TF = FALSE)

## ----settings, eval = FALSE---------------------------------------------------
# settings <- sc_omicSettings(sim)

## ----settingsTF, eval = FALSE-------------------------------------------------
# settings <- sc_omicSettings(sim, TF = TRUE)

## ----results, eval = FALSE----------------------------------------------------
# res <- sc_omicResults(sim)

#' check_patterns
#' 
#' Function to check if the TRUE FALSE patterns have at least two rows that are
#' opposite, we need this to be able to generate repressor regulators
#'
#' @param patterns tibble of TRUE FALSE values
#' @export
#' @return list of indices where the rows are opposite
#'
#' @examples
#' patterns <- tibble::tibble(one = c(TRUE, FALSE, TRUE, FALSE), 
#'               two = c(TRUE, TRUE, TRUE, TRUE), 
#'               three = c(FALSE, TRUE, FALSE, TRUE), 
#'               four = c(FALSE, TRUE, TRUE, TRUE))
#' opposite_indices <- check_patterns(patterns)
#' 
check_patterns <- function(patterns) {
  opposite_indices <- list()
  for (i in 1:(nrow(patterns) - 1)) {
    for (j in (i + 1):nrow(patterns)) {
      if (all(patterns[i, ] == !patterns[j, ])) {
        opposite_indices <- append(opposite_indices, list(c(i, j)))
      }
    }
  }
  return(opposite_indices)
}

#' make_cluster_patterns
#' 
#' Function to make the tibble with cluster combinations for the gene expression
#' patterns along the cells
#' This function is a slightly modified copy of the `make_cluster_patterns` function
#' from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
#' Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
#' interpretable networks of isoform co-usage from single cell data. Nature communications
#' 1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
#' GPL-3 license.
#'
#' @param numcells Number of different celltypes we are simulating
#' @param clusters OPTIONAL. Number of co-expression patterns the user wants
#'      to simulate
#'
#' @return A tibble with number of columns equal to number of celltypes, rows
#'  according to the number of TRUE/FALSE combinations corresponding to the
#'  gene expression patterns along the cells
#' @export
#' @examples
#' patterns <- make_cluster_patterns(numcells = 4, clusters = 8)
#' cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
#' 'Memory_B' = c(31:40))
#' patterns <- make_cluster_patterns(numcells = length(cell_types), 
#'     clusters = 8)
#' 
make_cluster_patterns <- function(numcells = 4, clusters = 8) {
  patterns <- tibble::tibble()
  col_names <- paste0("Var", 1:numcells)
  
  # Loop until we find a suitable pattern matrix
  repeat {
    # Generate all possible patterns
    patterns <- tibble::tibble()
    for (i in 1:(2^numcells)) {
      # Make it a bigger probability to have FALSE than true
      # To be conservative with the expression values.
      boolArr <- runif(numcells) > 0.85
      patterns <- rbind(patterns, boolArr)
    }
    colnames(patterns) <- col_names
    
    # Sample the required number of clusters
    patterns_ret <- slice_sample(patterns, n = clusters)
    
    # Check for duplicate rows
    if (any(duplicated(patterns_ret))) {
      next
    }
    
    # Check for opposite patterns
    opposite_indices <- check_patterns(patterns_ret)
    if (length(opposite_indices) >= 1) {
      break
    }
  }
  
  return(list("patterns" = patterns_ret, "opposite_indices" = opposite_indices))
}

#' simulate coexpression
#' 
#' Adapted from ACORDE (https://github.com/ConesaLab/acorde) to adapt to our
#' data input type. Simulates coexpression of genes along celltypes
#'
#' This function is a slightly modified copy of the `simulate_coexpression` function
#' from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
#' Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
#' interpretable networks of isoform co-usage from single cell data. Nature communications
#' 1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
#' GPL-3 license.
#' @param sim_matrix Matrix with rows as features and columns as cells
#' @param feature_no Total number of features to be distributed between the 
#'    coexpression clusters
#' @param cellTypes list where the i-th element of the list contains the column 
#'    indices for i-th experimental conditions. List must be a named list.
#' @param patterns Tibble with TRUE FALSE depicting the cluster patterns to
#'    simulate. Generated by the user or by \code{make_cluster_patterns}.
#' @param cluster_size OPTIONAL. It may be inputted by the user. By default, 
#'    its the number of features divided by the number of patterns to generate.
#'
#' @return the simulated coexpression
#' @export

simulate_coexpression <- function(sim_matrix,
                                  feature_no, cellTypes,
                                  patterns,
                                  cluster_size = NULL){
  
  ## If no cluster size specified, make it by default
  if (is.null(cluster_size)){
    cluster_size <- feature_no/dim(patterns)[1]
  }
  
  # Define notin to filter later on
  `%notin%` <- Negate(`%in%`)
  
  # extract counts 
  normcounts <- as.data.frame(sim_matrix)
  # get cell ids in each cell type
  colData <- tibble::tibble(Cell = colnames(normcounts),
                            Group = rep(names(cellTypes), times = lengths(cellTypes)))
  
  group.list <- colData$Cell %>% split(colData$Group)
  # extract cell type (group) expr matrices
  normcounts.list <- purrr::map(group.list,
                                ~(normcounts[, as.character(.)] %>%
                                    tibble::rownames_to_column("feature")))
  
  # rank features by mean expression in each cell type
  normcounts.list <- purrr::map(normcounts.list,
                                ~dplyr::mutate(., mean = rowMeans(.[,-1])) %>%
                                  dplyr::arrange(dplyr::desc(mean))
                                %>% dplyr::select(-mean))
  
  # select top and bottom feature IDs for each cell type
  
  # top
  top_features.list <- purrr::map(normcounts.list,
                                  ~dplyr::select(., feature) %>%
                                    dplyr::rename(top = "feature") %>%
                                    dplyr::slice(., 1:feature_no) %>%
                                    tibble::as_tibble())
  
  # modify bottom feature no. to create range correctly
  feature_no.c <- nrow(normcounts) - (feature_no - 1)
  # bottom
  bottom_features.list <- purrr::map(normcounts.list,
                                     ~dplyr::select(., feature) %>%
                                       dplyr::rename(bottom = "feature") %>%
                                       dplyr::slice(., feature_no.c:nrow(normcounts)) %>%
                                       tibble::as_tibble())
  
  # create a two-col tibble with top/bottom features per group
  features.list <- purrr::map2(top_features.list, bottom_features.list,
                               dplyr::bind_cols)
  
  
  ## USE SUPPLIED PATTENRS TO SHUFFLE THE CELL TYPE MATRICES ##
  
  # match column names for patterns
  colnames(patterns) <- names(normcounts.list)
  
  # shuffle matrix for each cell type following cluster patterns
  # note that internal function shuffle_group_matrix() is used to perform
  # each individual shuffling operation
  
  # calculate no. of clusters based on size and number of features
  partitions <- feature_no / cluster_size
  partitions <- trunc(partitions)
  
  expr.list <- purrr::pmap(list(normcounts.list, features.list, patterns),
                           ~MOSim::shuffle_group_matrix(sim_data = ..1,
                                                        feature_ids = ..2,
                                                        group_pattern = ..3,
                                                        ngroups = partitions))
  
  feature_names <- expr.list[[1]]$feature
  
  # join cell type matrices into a single expression matrix
  expr.list <- purrr::map(expr.list, dplyr::select, -feature)
  coexpr.df <- dplyr::bind_cols(expr.list) %>% tibble::as_tibble()
  
  # merge all dataframes in the list by feature column, fillna the genes not 
  coexpr.df <- coexpr.df %>%
    #dplyr::mutate(feature = paste0("Feature", seq(1, nrow(coexpr.df)))) %>%
    dplyr::mutate(feature = feature_names) %>%
    dplyr::relocate(feature)
  
  # generate feature ID vectors for co-expression clusters
  clusters <- split(coexpr.df$feature,
                    cut(seq(1, nrow(coexpr.df)),
                        breaks = nrow(patterns), labels = FALSE))
  
  # New, not in acorde's simulate coexpression
  # Get the genes that we havent used into the table
  # Format the simulated dataframe as tibble with feature column and get the 
  # missing rows into the coexpression DF
  normcounts <- dplyr::mutate_all(normcounts, function(x) as.double(x))
  normcounts$feature <- rownames(normcounts)
  normcounts <- tibble::as_tibble(normcounts)
  # Sort the columnames according to the simulated dataframe
  normcounts <- normcounts[, colnames(coexpr.df)]
  
  # remove from the original simulated matrix the features co-regulated
  normcounts <- normcounts %>%
    dplyr::filter(feature %notin% coexpr.df$feature)
  
  ## Bring back other features not corregulated
  coexpr.df <- dplyr::bind_rows(coexpr.df, normcounts) %>% replace(is.na(.), 0)
  
  # build a list with results
  coexpr_sim <- list(sim_matrix = coexpr.df,
                     sim_clusters = clusters)
  return(coexpr_sim)
  
}


#' shuffle_group_matrix, Reorder cell type-specific expression matrix during 
#' co-expression simulation. Copied from ACORDE (https://github.com/ConesaLab/acorde)
#' to facilitate stability and running within our scripts
#' This function is a slightly modified copy of the `shuffle_group_matrix` function
#' from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
#' Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
#' interpretable networks of isoform co-usage from single cell data. Nature communications
#' 1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
#' GPL-3 license.
#' 
#' @description This function is used internally by \code{acorde} to perform
#' the shuffling of simulated features for an individual cell type, as part of
#' the co-expression simulation process. The function is called recursively by
#' \code{\link[MOSim:simulate_coexpression]{simulate_coexpression()}} to
#' perform the simulation on a full scRNA-seq matrix.
#'
#' @param sim_data A count matrix with features as rows and cells as columns.
#' Feature IDs must be included in an additional column named \code{feature}.
#' @param feature_ids A two-column \code{tibble} containing \code{top} and \code{bottom}
#' columns, each including the feature IDs of features to be used as highly or
#' lowly expressed when shuffling by the indicated expression pattern.
#' @param group_pattern A logical vector, containing \code{TRUE} to indicate that
#' high expression in that cell type is desired and \code{FALSE} if the opposite.
#' The vector must be ordered as the cell types in \code{sim_data}.
#' @param ngroups An integer indicating the number of groups that top and bottom
#' features should be divided into. It is computed by dividing the number
#' of features selected as highly/lowly expressed by the size of the clusters
#' that are to be generated.
#' @export
#' @return An expression matrix, with the same characteristics as \code{sim_data},
#' and a number of features defined as the total amount of top/bottom features
#' selected divided by the number of clusters for which co-expression patterns
#' where supplied.

shuffle_group_matrix <- function(sim_data, feature_ids, group_pattern, ngroups) {
  
  top <- feature_ids$top
  bottom <- feature_ids$bottom
  
  top <- sample(top)
  top.list <- split(top, cut(seq_along(top), breaks = ngroups, labels = FALSE, include.lowest = TRUE))
  
  bottom <- sample(bottom)
  bottom.list <- split(bottom, cut(seq_along(bottom), breaks = ngroups, labels = FALSE, include.lowest = TRUE))
  
  features_bound <- vector("list", length(group_pattern))
  features_bound[group_pattern] <- top.list[1:sum(group_pattern)]
  features_bound[!group_pattern] <- bottom.list[1:sum(!group_pattern)]
  features_bound <- unlist(features_bound)
  
  sim_data.mod <- sim_data[sim_data$feature %in% features_bound, ]
  sim_data.mod <- sim_data.mod[match(features_bound, sim_data.mod$feature), , drop = FALSE]
  
  return(sim_data.mod)
}


#' make_association_dataframe
#' 
#' This function generates a dataframe containing the information of the 
#' relationship between ATAC and RNA, based on the cluster groups, and then
#' tells the order the genes and peaks should be in the simulated dataframe
#' of the group
#'
#' @param group Group from which we are generating the association dataframe
#' @param genereggroup list of elements to generate the association dataframe
#'      such as clusters of each omic, indices of opposite clusters, which
#'      genes are activated, repressed, behavior of the features etc.
#' @param numtotalgenes total number of genes
#' @param numtotalpeaks total number of peaks
#' @param minFC FC below which is downregulated
#' @param maxFC FC above which is upregulated
#' @return a dataframe with all the information the user needs about each gene
#'      and the order of gene and peak names to rename them in the simulated
#'      datasets of the group
#' @export
#'
make_association_dataframe <- function(group, genereggroup, numtotalgenes, 
                                       numtotalpeaks, minFC, maxFC){
  # Start from the association list, now we have two columns Peak_ID and Gene_ID
  
  columns <- c("Gene_ID", "Peak_ID", "RegulatorEffect", "Gene_cluster", "Peak_cluster", 
               "Gene_DE", "Peak_DE", "Gene_FC", "Peak_FC")
  keep_remaining <- function(ori_clus, clus){
    clusters_a <- as.data.frame(lengths(ori_clus))
    clusters_a$cluster <- rownames(clusters_a)
    colnames(clusters_a) <- c("Freq", "cluster")
    clusters_ao <- as.data.frame(table(clus))
    colnames(clusters_ao) <- c("cluster", "Freq")
    clusters_a <- clusters_a[colnames(clusters_ao)]
    result <- clusters_a %>%
      dplyr::left_join(clusters_ao, by = "cluster", suffix = c(".a", ".ao")) %>%
      dplyr::mutate(Freq = Freq.a - ifelse(is.na(Freq.ao), 0, Freq.ao)) %>%
      dplyr::select(cluster, Freq)
    return(result)
  }
  
  keep_remaining2 <- function(ori_clus, clus){
    clusters_a <- as.data.frame(ori_clus)
    clusters_ao <- as.data.frame(table(clus))
    colnames(clusters_ao) <- c("cluster", "Freq")
    clusters_a <- clusters_a[colnames(clusters_ao)]
    result <- clusters_a %>%
      dplyr::left_join(clusters_ao, by = "cluster", suffix = c(".a", ".ao")) %>%
      dplyr::mutate(Freq = Freq.a - ifelse(is.na(Freq.ao), 0, Freq.ao)) %>%
      dplyr::select(cluster, Freq)
    
    return(result)
  }
  
  ## Make the repressed
  df2 <- data.frame(matrix(nrow = length(genereggroup[[paste0("GeneRepressed_G", 
                                                              group)]]$Gene_ID), ncol = length(columns)))
  colnames(df2) <- columns
  df2$Gene_ID <- genereggroup[[paste0("GeneRepressed_G", group)]]$Gene_ID
  df2$Peak_ID <- genereggroup[[paste0("GeneRepressed_G", group)]]$Peak_ID
  df2$RegulatorEffect <- rep("Repressor", length(df2[[1]]))
  Gene_cluster <- sample(unique(unlist(genereggroup$opposite_indices)), 
                          length(df2[[1]]), replace = TRUE)
  df2$Gene_cluster = Gene_cluster
  lookup <- unlist(lapply(genereggroup$opposite_indices, function(x) setNames(rev(x), x)))
  Peak_cluster <- as.numeric(sapply(Gene_cluster, function(x) lookup[as.character(x)]))
  df2$Peak_cluster <- Peak_cluster
  df2$Gene_DE <- rep("Down", length(df2[[1]]))
  df2$Peak_DE <- rep("Up", length(df2[[1]]))
  
  if (group > 1){
    df2$Gene_FC <- runif(n = length(df2[[1]]), min = 0.0001, max = minFC)
    df2$Peak_FC <- runif(n = length(df2[[1]]), min = maxFC, max = 100)
  }
  
  remaining_rna <- keep_remaining(genereggroup$`Clusters_scRNA-seq`, Gene_cluster)
  remaining_atac <- keep_remaining(genereggroup$`Clusters_scATAC-seq`, Peak_cluster)
  
  remaining_r <- as.numeric(rep(remaining_rna$cluster, remaining_rna$Freq))

  # Make the activated
  
  df1 <- data.frame(matrix(nrow = length(genereggroup[[paste0("GeneActivated_G", 
                                    group)]]$Gene_ID), ncol = length(columns)))
  colnames(df1) <- columns
  
  df1$Gene_ID <- genereggroup[[paste0("GeneActivated_G", group)]]$Gene_ID
  df1$Peak_ID <- genereggroup[[paste0("GeneActivated_G", group)]]$Peak_ID
  df1$RegulatorEffect <- rep("Activator", length(df1[[1]]))
  Gene_cluster <- sample(remaining_r, 
                         length(df1[[1]]), replace = FALSE)
  Peak_cluster <- Gene_cluster
  df1$Gene_cluster <- Gene_cluster
  df1$Peak_cluster <- Peak_cluster
  df1$Gene_DE <- rep("Up", length(df1[[1]]))
  df1$Peak_DE <- rep("Up", length(df1[[1]]))
  
  if (group > 1){
    df1$Gene_FC <- runif(n = length(df1[[1]]), min = maxFC, max = 100)
    df1$Peak_FC <- df1$Gene_FC
  }
  
  remaining_rna <- keep_remaining2(remaining_rna, Gene_cluster)
  remaining_atac <- keep_remaining2(remaining_atac, Peak_cluster)
  
  remaining_r <- as.numeric(rep(remaining_rna$cluster, remaining_rna$Freq))
  remaining_a <- as.numeric(rep(remaining_atac$cluster, remaining_atac$Freq))
  

  ## Add extras
  
  df3 <- data.frame(matrix(nrow = length(c(genereggroup[[paste0("GeneExtraUp_G", 
                    group)]], rep(NA, length(genereggroup[[paste0("FeatExtraUp_G", 
                    group)]])))), ncol = length(columns)))
  colnames(df3) <- columns
  df3$Gene_ID <- c(genereggroup[[paste0("GeneExtraUp_G", group)]], 
                      rep(NA, length(genereggroup[[paste0("FeatExtraUp_G", group)]])))
  df3$Peak_ID <- c(rep(NA, length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                      genereggroup[[paste0("FeatExtraUp_G", group)]])
  df3$RegulatorEffect <- rep("NE", length(df3[[1]]))
  df3$Gene_cluster <- c(rep(0, length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                      rep(NA, length(genereggroup[[paste0("FeatExtraUp_G", group)]])))
  df3$Peak_cluster <- c(rep(NA, length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                      rep(0, length(genereggroup[[paste0("FeatExtraUp_G", group)]])))
  df3$Gene_DE <- c(rep("Up", length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                      rep(NA, length(genereggroup[[paste0("FeatExtraUp_G", group)]])))
  df3$Peak_DE <- c(rep(NA, length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                      rep("Up", length(genereggroup[[paste0("FeatExtraUp_G", group)]])))

  if (group > 1){
    df3$Gene_FC <- c(runif(n = length(genereggroup[[paste0("GeneExtraUp_G", group)]]), min = maxFC, max = 100),
                        rep(NA, length(genereggroup[[paste0("FeatExtraUp_G", group)]])))
    df3$Peak_FC <- c(rep(NA, length(genereggroup[[paste0("GeneExtraUp_G", group)]])), 
                        runif(n = length(genereggroup[[paste0("FeatExtraUp_G", group)]]), min = maxFC, max = 100))
  }
  
  ## Extra down
  
  df4 <- data.frame(matrix(nrow = length(c(genereggroup[[paste0("GeneExtraDown_G", group)]], 
                                           rep(NA, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))), ncol = length(columns)))
  colnames(df4) <- columns
  df4$Gene_ID <- c(genereggroup[[paste0("GeneExtraDown_G", group)]], 
                      rep(NA, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
  df4$Peak_ID <- c(rep(NA, length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                      genereggroup[[paste0("FeatExtraDown_G", group)]])
  df4$RegulatorEffect <- rep("NE", length(df4[[1]]))
  df4$Gene_cluster <- c(rep(0, length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                      rep(NA, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
  df4$Peak_cluster <- c(rep(NA, length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                      rep(0, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
  df4$Gene_DE <- c(rep("Down", length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                      rep(NA, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
  df4$Peak_DE <- c(rep(NA, length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                      rep("Down", length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
  
  if (group > 1){
    df4$Gene_FC <- c(runif(n = length(genereggroup[[paste0("GeneExtraDown_G", group)]]), min = 0.0001, max = minFC),
                        rep(NA, length(genereggroup[[paste0("FeatExtraDown_G", group)]])))
    df4$Peak_FC <- c(rep(NA, length(genereggroup[[paste0("GeneExtraDown_G", group)]])), 
                        runif(n = length(genereggroup[[paste0("FeatExtraDown_G", group)]]), min = 0.0001, max = minFC))
  }
  
  ## All remaining
  
  df5 <- data.frame(matrix(nrow = length(c(genereggroup[[paste0("GeneRemaining_G", group)]], 
                                    rep(NA, length(genereggroup[[paste0("FeatRemaining_G", group)]])))), 
                           ncol = length(columns)))
  colnames(df5) <- columns
  df5$Gene_ID <- c(genereggroup[[paste0("GeneRemaining_G", group)]], 
                      rep(NA, length(genereggroup[[paste0("FeatRemaining_G", group)]])))
  df5$Peak_ID <- c(rep(NA, length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                      genereggroup[[paste0("FeatRemaining_G", group)]])
  df5$RegulatorEffect <- rep("NE", length(df5[[1]]))
  
  df5$Gene_cluster <- c(remaining_r, 
                      rep(0, length(genereggroup[[paste0("GeneRemaining_G", group)]]) - length(remaining_r)),
                      rep(NA, length(genereggroup[[paste0("FeatRemaining_G", group)]])))
  df5$Peak_cluster <- c(rep(NA, length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                      remaining_a, 
                      rep(0, length(genereggroup[[paste0("FeatRemaining_G", group)]]) - length(remaining_a)))
  
  df5$Gene_DE <- c(rep("NE", length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                      rep(NA, length(genereggroup[[paste0("FeatRemaining_G", group)]])))
  df5$Peak_DE <- c(rep(NA, length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                      rep("NE", length(genereggroup[[paste0("FeatRemaining_G", group)]])))
  
  if (group > 1){
    df5$Gene_FC <- c(rep(1, length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                        rep(NA, length(genereggroup[[paste0("FeatRemaining_G", group)]])))
    df5$Peak_FC <- c(rep(NA, length(genereggroup[[paste0("GeneRemaining_G", group)]])), 
                        rep(1, length(genereggroup[[paste0("FeatRemaining_G", group)]])))
  }
  
  # Concat dataframes of DE genes and features
  df <- rbind(df1, df2, df3, df4, df5)
  
  if (group == 1){
    df$Gene_FC <- ifelse(is.na(df$Gene_ID), NA, 1)
    df$Peak_FC <- ifelse(is.na(df$Peak_ID), NA, 1)
  }
  
  # Now we need to sort the association dataframe according to the clusters
  # But cluster 0 should be last
  custom_sort <- function(x) {
    ifelse(x == 0, Inf, x)
  }
  df <- df[order(custom_sort(df$Gene_cluster)),]
  
  # Remove duplicated atac peaks
  df <- df %>%
        group_by(Peak_ID) %>%
        filter(!(is.na(Gene_ID) & duplicated(Peak_ID)))
  
  dfGeneNames <- as.character(stats::na.omit(df$Gene_ID))
  
  df2 <- df[order(custom_sort(df$Peak_cluster)),]
  
  
  
  dfPeakNames <- unique(as.character(stats::na.omit(df2$Peak_ID)))
  
  return(list("associationMatrix" = df, "dfPeakNames" = dfPeakNames, "dfGeneNames" = dfGeneNames))
  
}


#' calculate_mean_per_list_df
#' 
#' Helper function to calculate mean expression per celltype
#'
#' @param df dataframe of expression where columns are cells
#' @param named_lists list of which cells belong to each celltype
#'
#' @export
#'
#' @examples
#' rna <- data.frame(c1 = c(1.5, 15.5, 3.5, 20.5), c2 = c(2, 15, 4, 20), 
#'           c3 = c(10, 1, 12, 13), c4 = c(11, 1, 13, 14))
#' cell_types <- list("ct1" = c(1,2), "ct2" = c(3, 4))
#' calculate_mean_per_list_df(rna, cell_types)
calculate_mean_per_list_df <- function(df, named_lists) {
  means <- list()
  for (name in names(named_lists)) {
    columns <- named_lists[[name]]
    means[[name]] <- rowMeans(df[, columns, drop = FALSE])
  }
  # Combine the list of means into a dataframe
  means_df <- do.call(cbind, means)
  # Add column names
  colnames(means_df) <- names(named_lists)
  return(as.data.frame(means_df))
}


#' match_gene_regulator
#' 
#' Helper function to make the most similar profiles possible between
#' gene and regulator
#'
#' @param rna dataframe of RNA expression
#' @param atac dataframe of ATAC expression
#' @param cell_types list of which cells belong to each celltype
#' @param associationList dataframe of two columns, Gene_ID and Peak_ID
#'
#' @export
#'
#' @examples
#' rna <- data.frame(c1 = c(1.5, 15.5, 3.5, 20.5), c2 = c(2, 15, 4, 20), 
#'         c3 = c(10, 1, 12, 13), c4 = c(11, 1, 13, 14), c5 = c(7, 0, 0, 0), 
#'         c6 = c(8, 1, 1, 1), c7 = c(8, 1, 1, 1))
#' rownames(rna) <- c('GenB', 'GenA', 'GenC', 'GenD')
#' associationList <- data.frame(Gene_ID = c('GenA', 'GenB', 'GenC', 'GenA'),
#'         Peak_ID = c('PeakA', 'PeakB', 'PeakC', 'PeakD'))
#' cell_types <- list("ct1" = c(1,2), "ct2" = c(3, 4), "ct3" = c(5, 6), "ct4" = c(7))
#' atac <- data.frame(c1 = c(3,20, 1,15, 1, 7, 1), c2 = c(4,20, 2,15, 0, 5, 1.5), 
#'         c3 = c(10, 13, 1, 12, 1, 14, 9), c4 = c(11, 14, 1, 13, 1, 4, 12), 
#'         c5 = c(0, 0, 0, 7, 1, 6, 6), c6 = c(1, 1, 1, 8, 0, 5, 8), 
#'         c7 = c(1, 1, 1, 8, 1, 5, 7))
#' rownames(atac) <- c('PeakB', "PeakC", "PeakF", "PeakD", "PeakE", "PeakA", "PeakG")
#' match_gene_regulator(rna, atac, cell_types, associationList)
match_gene_regulator <- function(rna, atac, cell_types, associationList){
  ## Prepare the dataframes:
  Gene_ID <- NULL
  dup_index <- NULL
  
  # Add a suffix to each duplicate occurrence in associationList
  associationList <- associationList %>%
    dplyr::group_by(Gene_ID) %>%
    dplyr::mutate(dup_index = row_number() - 1,
           Gene_ID = ifelse(dup_index > 0, paste0(Gene_ID, "_dup", dup_index), Gene_ID)) %>%
    dplyr::select(-dup_index) %>%
    dplyr::ungroup()
  
  # Check for duplicates in Gene_ID column
  duplicate_genes <- associationList$Gene_ID[grepl("_dup", associationList$Gene_ID)]
  
  # Duplicate rows in rna dataframe based on duplicates in associationList
  for (gene in duplicate_genes) {
    # Extract the base gene name
    base_gene <- sub("_dup[0-9]+$", "", gene)
    
    # Find the row in rna dataframe corresponding to the base gene
    rna_row <- rna[rownames(rna) == base_gene, ]
    
    # Append the row to the rna dataframe
    rna <- rbind(rna, rna_row)
    
    # Update the row names
    rownames(rna)[nrow(rna)] <- gene
  }
  
  
  ## Sort dataframes according to the association list order
  rna <- rna[order(match(rownames(rna), as.vector(associationList$Gene_ID))), , drop = FALSE]
  atac <- atac[order(match(rownames(atac), as.vector(associationList$Peak_ID))), , drop = FALSE]
  
  mean_rna <- MOSim::calculate_mean_per_list_df(rna, cell_types)
  mean_atac <- MOSim::calculate_mean_per_list_df(atac, cell_types)
  
  # Target values
  target_values <- as.numeric(as.data.frame(mean_rna)[[1]])
  
  # Function to find the most similar element and its index, avoiding used indexes
  find_most_similar <- function(values, target, used_indexes) {
    # Calculate the absolute differences, ignoring used indexes
    differences <- abs(values - target)
    differences[used_indexes] <- Inf  # Set used indexes to Inf to avoid selecting them
    min_index <- which.min(differences)
    return(list(element = values[min_index], index = min_index))
  }
  
  # Initialize list to store results
  results <- list(elements = numeric(length(target_values)), indexes = integer(length(target_values)))
  
  # Vector to keep track of used indexes
  used_indexes <- integer(0)
  
  # Find most similar elements and their indexes
  for (i in seq_along(target_values)) {
    res <- find_most_similar(mean_atac[[1]], target_values[i], used_indexes)
    results$elements[i] <- res$element
    results$indexes[i] <- res$index
    used_indexes <- c(used_indexes, res$index)
  }
  
  new_mean_atac <- data.frame(results$elements)
  colnames(new_mean_atac) <- names(mean_rna)[[1]]
  new_indexes_atac <- data.frame(results$indexes)
  colnames(new_indexes_atac) <- names(mean_rna)[[1]]
  
  for (j in 2:length(colnames(mean_atac))) {
    prev_ct <- names(mean_rna)[j - 1]
    curr_ct <- names(mean_rna)[j]
    
    differences_rna <- mean_rna[[prev_ct]] - mean_rna[[curr_ct]]
    results_curr <- data.frame(elements = numeric(length(differences_rna)), indexes = integer(length(differences_rna)))
    used_indexes_curr <- integer(0)
    
    for (i in seq_along(differences_rna)) {
      target_diff <- differences_rna[i]
      res <- find_most_similar(mean_atac[[curr_ct]], new_mean_atac[[prev_ct]][i] - target_diff, used_indexes_curr)
      results_curr$elements[i] <- res$element
      results_curr$indexes[i] <- res$index
      used_indexes_curr <- c(used_indexes_curr, res$index)
    }
    
    new_mean_atac[[curr_ct]] <- results_curr$elements
    new_indexes_atac[[curr_ct]] <- results_curr$indexes
  }
  
  # Get unique values in each column
  unique_values <- lapply(new_indexes_atac, unique)
  
  # Find missing numbers from 1 to 10 for each column
  missing_numbers <- lapply(unique_values, function(x) setdiff(1:nrow(mean_atac), x))
  
  # Add missing indexes
  new_indexes_atac <- rbind(new_indexes_atac, missing_numbers)
  
  ## Get the values from those indices from atac
  new_atac <- data.frame(matrix(ncol = ncol(atac), nrow = nrow(atac)))
  colnames(new_atac) <- colnames(atac)
  rownames(new_atac) <- rownames(atac)
  
  # Populate the new_atac data frame with the values from atac according to new_indexes_atac and cell_types
  for (cell_type in colnames(new_indexes_atac)) {
    # Get the indices for the current cell type
    indices <- new_indexes_atac[[cell_type]]
    
    # Get the columns in atac that correspond to the current cell type
    columns <- cell_types[[cell_type]]
    
    # Extract and reorder values for each column according to the indices
    for (col in columns) {
      new_atac[, col] <- atac[indices, col]
    }
  }
  
  # Function to remove the added rows
  remove_added_rows <- function(dataframe) {
    return(dataframe[!grepl("_dup[0-9]+$", rownames(dataframe)), ])
  }
  
  # Remove the added rows
  rna <- remove_added_rows(rna)
  atac <- new_atac
  return(list("atac" = atac, "rna" = as.data.frame(as.matrix(rna))))
}



#' match_gene_regulator_cluster
#'
#' @param rna rna expression dataframe
#' @param atac atac expression dataframe
#' @param cell_types list of which cells belong to each celltype
#' @param associationMatrix matrix of related genes and peaks
#'
#' @export
#'
#' @examples
#' rna <- data.frame(c1 = c(1.5, 15.5, 3.5, 20.5), c2 = c(2, 15, 4, 20), 
#'         c3 = c(10, 1, 12, 13), c4 = c(11, 1, 13, 14), c5 = c(7, 0, 0, 0), 
#'         c6 = c(8, 1, 1, 1), c7 = c(8, 1, 1, 1))
#' rownames(rna) <- c('GenB', 'GenA', 'GenC', 'GenD')
#' associationList <- data.frame(Gene_ID = c('GenA', 'GenB', 'GenC', 'GenA'),
#'         Peak_ID = c('PeakA', 'PeakB', 'PeakC', 'PeakD'),
#'         Gene_cluster = c(1, 2, 1, 2), Peak_cluster = c(1, 2, 1, 2))
#' cell_types <- list("ct1" = c(1,2), "ct2" = c(3, 4), "ct3" = c(5, 6), "ct4" = c(7))
#' atac <- data.frame(c1 = c(3,20, 1,15, 1, 7, 1), c2 = c(4,20, 2,15, 0, 5, 1.5), 
#'         c3 = c(10, 13, 1, 12, 1, 14, 9), c4 = c(11, 14, 1, 13, 1, 4, 12), 
#'         c5 = c(0, 0, 0, 7, 1, 6, 6), c6 = c(1, 1, 1, 8, 0, 5, 8), 
#'         c7 = c(1, 1, 1, 8, 1, 5, 7))
#' rownames(atac) <- c('PeakB', "PeakC", "PeakF", "PeakD", "PeakE", "PeakA", "PeakG")
#' match_gene_regulator_cluster(rna, atac, cell_types, associationList)
match_gene_regulator_cluster <- function(rna, atac, cell_types, associationMatrix){
  Gene_cluster <- NULL
  Peak_cluster <- NULL
  
  clusters <- unique(associationMatrix$Gene_cluster)
  
  # remove cluster 0 since these are the unorganized.
  clusters <- clusters[clusters != 0 & !is.na(clusters)]
  
  for (e in clusters){
    # Make mini association lists of each cluster and reorganize them
    miniAsoc <- associationMatrix %>%
      dplyr::filter((Gene_cluster == e & (Peak_cluster == e | is.na(Peak_cluster))) |
                      (Peak_cluster == e & (Gene_cluster == e | is.na(Gene_cluster))))
    
    miniATAC <- atac[row.names(atac) %in% as.character(stats::na.omit(miniAsoc$Peak_ID)), ]
    
    associationList <- stats::na.omit(miniAsoc[, c("Gene_ID", "Peak_ID")])
    
    miniRNA <- rna[row.names(rna) %in% as.character(associationList$Gene_ID), ]
    
    res <- MOSim::match_gene_regulator(miniRNA, miniATAC, cell_types, associationList)
    
    ## Update RNA and ATAC dataframes with the changes we have made
    atac <- as.data.frame(as.matrix(atac)) %>%
      tibble::rownames_to_column() %>%
      dplyr::rows_update(res$atac %>% tibble::rownames_to_column(), by = "rowname") %>%
      tibble::column_to_rownames()
    
    rna <- as.data.frame(as.matrix(rna)) %>%
      tibble::rownames_to_column() %>%
      dplyr::rows_update(res$rna %>% tibble::rownames_to_column(), by = "rowname") %>%
      tibble::column_to_rownames()
    
  }
  return(list("atac" = atac, "rna" = rna))
}

---
title: "Simulating Single-Cell Multi-Omics Data with MOSim"
author: 
  - name: Carolina Monzó, Ángeles Arzalluz-Luque, Sonia Tarazona
date: "`r Sys.Date()`"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Wiki of how to use sc_mosim}
  %\usepackage[utf8]{inputenc}
  %\VignetteEncoding{UTF-8}
---

# Introduction

Welcome to the `MOSim` package, a versatile tool for simulating bulk and
single-cell multi-omics data. In this vignette, we will explore how to
create synthetic single-cell data, focusing on single-cell RNA-seq
(scRNA-seq) and single-cell ATAC-seq (scATAC-seq) data. Using the
`MOSim` package, you can generate custom multi-omics datasets for
various experimental conditions, making it an essential resource for
testing and validating analysis methods, or creating benchmark datasets.

# Installation

Before we dive into the exciting world of data simulation, you'll need
to install the `MOSim` package. You can easily obtain it from bioconductor using
the following commands:

```{r installing, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) 
    install.packages("BiocManager")

BiocManager::install("MOSim")

# For the latest development version
install.packages("devtools")
devtools::install_github("ConesaLab/MOSim")

```

# Simulating Single-Cell Multi-Omics Data

The core of data simulation lies in the sc_mosim function, which allows
you to create synthetic single-cell multi-omics data. Let's explore a
typical example of its usage, using the default dataset loaded in the package:

```{r test_run, eval = FALSE}
library(MOSim)

# Create a list of omics data types (e.g., scRNA-seq and scATAC-seq)
omicsList <- sc_omicData(list("scRNA-seq", "scATAC-seq"), 
                         data = NULL)

# Define cell types for your experiment
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
      'Memory_B' = c(31:40))

# Load an association list containing peak IDs related to gene names
associationList <- data(associationList)

# Simulate multi-omics data with specific parameters
testing_groups <- sc_mosim(
  omicsList,
  cell_types,
  numberReps = 2,
  numberGroups = 3,
  diffGenes = list(c(0.2, 0.3), c(0.2, 0.3)),
  minFC = 0.25,
  maxFC = 4,
  numberCells = NULL,
  mean = NULL,
  sd = NULL,
  regulatorEffect = list(c(0.1, 0.2), c(0.1, 0.2), c(0.1, 0.2)),
  associationList = associationList,
  TF = FALSE
)
```

In the example above, we load omics data types, specify experimental
conditions and cell types, and load an association list. The sc_mosim
function lets us simulate multi-omics data with various parameters, such
as the number of replicates, differentially expressed genes, and
regulatory effects.

# Data Preparation

Before diving into simulation, it's essential to have your data ready.
The `sc_omicData` function aids in preparing your data for simulation.
It accepts the following inputs:

-   omics_types: A list of omics data types, which can be "scRNA-seq" or
    "scATAC-seq."

-   data (optional): A user-inputted list of matrices with features as
    rows and cells as columns. If data is NULL, the default data from
    10 cells for 4 celltypes is loaded. 

## Providing Custom Data

`sc_mosim` also allows you to simulate data resembling characteristics of
a dataset of your choice. To do so, you need to format your data using
the `sc_omicData` function. Supported input formats include:

-   Count matrix
-   Seurat array  
For example, to format your data extracted from the original Seurat object,  
you can follow these steps:

```{r custom data, eval = FALSE}
# This is done to get a dataset to extract a matrix (for example purposes)
scRNA <- MOSim::sc_omicData("scRNA-seq", data = NULL)
count <- scRNA[["scRNA-seq"]]
options(Seurat.object.assay.version = "v3")
Seurat_obj <- Seurat::CreateAssayObject(counts = count, assay = 'RNA')
# To format the data into sc_mosim-ready format, we pass the seurat
# object containing the count data we extracted into sc_omicData
omic_list_user <- sc_omicData(c("scRNA-seq"), data = c(Seurat_obj))
```

The resulting omic_list_user is a named list with "scRNA-seq" as the
name and your count matrix as the value.

# Running the Simulation: sc_mosim

## Default sc_mosim Simulation

`sc_mosim` can simulate scRNA, scATAC and TF count matrices without providing
any additional arguments. For a basic simulation, you only need to input
the omics list and cell types. Here's how it's done:

```{r default, eval = FALSE}
omic_list <- sc_omicData(list("scRNA-seq"))
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
      'Memory_B' = c(31:40))

sim <- sc_mosim(omic_list, cell_types, TF = TRUE)
```

This will result in simulated raw count matrices for scRNA and TF.

## Customizing the sc_mosim Simulation

The `sc_mosim` function offers a range of parameters to fine-tune your
simulation:

-   omics: A named list specifying the omics data types.
-   cellTypes: A list specifying the cell types.
-   numberReps (optional): The number of biological replicates.
-   numberGroups (optional): The number of different biological groups
    (experimental conditions).
-   diffGenes (optional): To simulate differentially expressed genes
    between groups.
-   minFC (optional): Threshold for downregulated genes.
-   maxFC (optional): Threshold for upregulated genes.
-   numberCells (optional): A vector specifying the number of cells per
    cell type.
-   mean and sd (optional): Vectors for mean and standard deviation of
    expression per cell type.
-   noiseRep (optional): Standard deviation between biological
    replicates.
-   noiseGroup (optional): Standard deviation between groups.
-   feature_no (optional): Total number of features to distribute
    between co-expression clusters.
-   clusters (optional): Number of co-expression patterns to simulate.
-   cluster_size (optional): Number of features in each co-simulation
    cluster.  
-   TF (optional): wether to extract TF dataframe as sim_TF in simulation object.
-   TFdf (optional): If an association matrix of TF and Target_gene is given the 
    TF expression values are extracted. If no data.frame is given, using the 
    association of human TF from {https://tflink.net/}
For example, to simulate data with specific settings, you can use the following  
code:

```{r testing, eval = FALSE}
omic_list <- sc_omicData(c("scRNA-seq", "scATAC-seq"))
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
      'Memory_B' = c(31:40))
sim <- sc_mosim(omic_list, cell_types, numberReps = 2, 
               numberGroups = 2, diffGenes = list(c(0.2, 0.3)), feature_no = 8000, 
               clusters = 3, mean = c(2*10^6, 1*10^6,2*10^6, 1*10^6), 
               sd = c(5*10^5, 2*10^5, 5*10^5, 2*10^5), 
               regulatorEffect = list(c(0.1, 0.2), c(0.1, 0.2)), TF = FALSE)
```

# Working with Simulation Results

## The sc_mosim Simulation Object

The result of your simulation is stored in a named list with 'sim_sc +
omic name' as names and Seurat objects as values. Each Seurat object
contains the synthetic count matrices for your experiment. Other
relevant information included in the object are:

-   cellTypes: A list specifying the columns in each simulated matrix
    that correspond to each cell type.

-   patterns: Matrix of co-expression patterns affecting the genes
    throughout cell-types.

-   FC: list of Fold Changes applied to each gene to simulate
    differential expression between experimental groups.

-   AssociationMatrices: gene/peak association matrices including
    differential expression and regulatory relationships.

-   Variability: added variability matrices to add dispersion to
    experimental groups and biological replicates.

## Retrieving Simulation Settings

To access simulation settings and other constraints for simulation, you can use the
`sc_omicSettings` function. This provides information about the
relationship between genes and peaks, differentially expressed genes,
regulator types, expression patterns, and fold changes for each gene and
peak compared to group 1.

```{r settings, eval = FALSE}
settings <- sc_omicSettings(sim)
```

If you run the sc_mosim simulation including TF, you can also extract the  
association matrix of TF - target genes regulatory relationships.

```{r settingsTF, eval = FALSE}
settings <- sc_omicSettings(sim, TF = TRUE)
```

## Accessing the Count Data Matrices

You can extract the simulated matrices for all experimental conditions
and biological replicates using the `sc_omicResults` function. This
provides you with the synthetic data for further analysis and
visualization.

```{r results, eval = FALSE}
res <- sc_omicResults(sim)
```

## How to cite `MOSim`

The `MOSim` package is published in Briefings in Bioinformatics:

Monzó C., Aguerralde-Martin M., Martínez-Mira C., Arzalluz-Luque A., Conesa A., Tarazona S. (2025) MOSim: bulk and single-cell multi-layer regulatory network simulator. Briefings in Bioinformatics, Volume 26, Issue 2. DOI: 10.1093/bib/bbaf110

(https://academic.oup.com/bib/article/26/2/bbaf110/8089935?utm_source=advanceaccess&utm_campaign=bib&utm_medium=email)

---
title: "Simulating bulk Multi-Omics Data with MOSim"
author: 
  - name: Carolina Monzó, Carlos Martínez, Sonia Tarazona
date: "`r Sys.Date()`"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Wiki of how to use mosim}
  %\usepackage[utf8]{inputenc}
  %\VignetteEncoding{UTF-8}
---

# mosim

## Abstract
This vignette describes the basic usage of MOSim package, showing how to perform a simulation, extract and interpret the information from the generated object, touching also some more advanced use cases.

## Introduction

`MOSim` package simulates multi-omic experiments that mimic regulatory mechanisms within the cell. Gene expression (RNA-seq count data) is the central data type and the rest of available omic data types act as regulators of genes, including DNase-seq (ATAC-seq), ChIP-seq, miRNA-seq and Methyl-seq. In addition, transcription factor (TF) regulation can also be modeled.

`MOSim` algorithm returns the simulated count data matrices, regulatory connections between genes and omic features and a detailed description of the simulation settings. Thus, these results can be used to test new integration methods, to tune or prepare analysis pipelines, as example data in users' manuals or for teaching purposes.

`MOSim` requires a seed count dataset for each omic to be simulated. For regulatory omics and TFs, an association table linking genes to regulators must also be given. For convenience, `MOSim` includes the default datasets from STATegra project (mouse data) for all omics `(sampleData)`. Therefore, the package can still be used in the absence of custom data.

Due to the potentially great amount of information generated, multiple helper functions are available for both passing the necessary input data and retrieving the generated data.

The outcome of the simulation process depends on two types of input information: the specific parameters of each omic to be simulated and the experimental design.

The experimental design options are flexible. The user can choose the number of experimental groups and the number of replicates. Time series data can also be simulated and, again, the user may decide the number of time points.  

MOSim has great flexibility in defining experimental designs, DEGs, and active regulators making it a versatile tool for a variety of different applications: i) validating methods aimed at modelling complex, multi-layered regulatory networks, ii) benchmarking multi-omics data integration pipelines, iii) benchmarking GRN inference tools, iv) evaluating differential expression and accessibility analysis tools, v) testing single-cell data clustering methods, vi) evaluating multi-omics visualization tools etc.

The process starts by simulating RNA-seq (gene expression) data. To do that, the program takes a sample from the supplied identifiers (row names of the initial count dataset) and labels them as differentially expressed genes (DEG). The percentage of DEG can be configured by the user, as many other settings that will be described in this vignette. A gene is considered to be differentially expressed if the expression of the gene changes (i) between the reference experimental group (group 1) and at least one of the remaining groups in the experimental design or (ii) across time.

When time course data is to be simulated, `MOSim` assigns one of the following profiles to each of the DEGs in each of the experimental groups:

* [Continuous induction] lineal increase of the activity of the gene with time.
* [Continuous repression] lineal decrease of the activity of the gene with time.
* [Transitory induction] inactive gene at the initial time, with progressive increasing of the activity followed by a decrease.
* [Transitory repression] active gene at the initial time, with progressive decreasing of the activity followed by an increase.
* [Flat] the activity of the gene remains constant along time.

```{r figure1, echo=FALSE, eval=TRUE, warning=FALSE}
library(ggplot2)
library(gridExtra)

# Define the data for lines
line_data <- data.frame(
  x = c(5, 5, 5, 5, 5),
  xend = c(6, 6, 6, 5.5, 5.5),
  y = c(0, -1.8, -2.7, -4.8, -5.7),
  yend = c(0, -1.2, -3.3, -4.2, -6.3),
  curve = c(FALSE, FALSE, FALSE, TRUE, TRUE)
)

# Create plot
p <- ggplot() +
  geom_segment(data = subset(line_data, !curve),
               aes(x = x, y = y, xend = xend, yend = yend),
               color = "red", size = 1) +
  geom_curve(data = subset(line_data, curve),
             aes(x = x, y = y, xend = xend, yend = yend),
             curvature = 0.5, color = "red", size = 1) +
  annotate("text", x = 0, y = 0, label = "Flat", hjust = 0) +
  annotate("text", x = 0, y = -1.5, label = "Continuous induction (CI)", hjust = 0) +
  annotate("text", x = 0, y = -2.7, label = "Continuous repression (CR)", hjust = 0) +
  annotate("text", x = 0, y = -4.8, label = "Transitory induction (TI)", hjust = 0) +
  annotate("text", x = 0, y = -5.7, label = "Transitory repression (TR)", hjust = 0) +
  theme_void()

# Display the figure
grid.arrange(p)
```


If a DEG is assigned to a flat profile in all groups, the algorithm will model a change in expression for at least one of the experimental groups (up or down regulation).

For other experimental designs not including time series, all DEGs are labeled as flat and the change in expression is modeled as indicated above, that is, for at least one of the experimental groups with regard to the first group.

Once gene expression settings have been set, regulatory omics are configured. This is done first by assigning a potential effect (activation, repression or no-effect) to each regulator.
Similarly to how the percentage of DEG could be specified for RNA-seq, the user can indicate the percentage of regulators that should be activators, repressors or with no-effect in each regulatory omic. However, these initial percentages can be affected, as regulatory relationships must be coherent with assigned profiles or selection of DEG. For instance, when a regulator has an effect on more than one DEG and these DEGs have opposite profiles, the type of effect must be forced to match the profiles. In fact, and related to this, if a regulator is potentially associated to more than one DEG with different profiles, the system has to decide which profile should be assigned to the regulator. For that, `MOSim` takes the profile class (combination of profiles for all groups, for example CI-FL-CR in groups 1, 2 and 3 respectively) with more DEGs associated to the regulator (majority class) and assigns the corresponding profile to the regulator: depending on the regulator effect, the profile will be the same for activation effect (following the example, CI-FL-CR for groups 1, 2 and 3) or the opposite for repression (CR-FL-CI). The interactions with genes not included in the majoritary class are automatically classified as "activator" if the profiles are the same, "repressor" if the are the totally opposite (CI vs CR, TI vs TR) or "no-effect" in any other case. Importantly, when generating user-defined percentages of regulators assigned as activators, repressors or no-effect, these percentages are subject to the number of DEG. If the percentage of regulators is higher than what is possible to generate within the constraint of the simulated DEG, `MOSim` generates as many regulator-DEG relationships as possible, but may generate a lower percentage than requested. In those cases, inducing a higher percentage of DEG (diffGenes parameter) will allow for a higher percentage of regulating regulators.

In brief, `MOSim` usage can be summed up in 3 main steps that will be described in the next sections:
* Decide the experimental design, omics list and input data to use.
* Generate a simulation object using the wrapper function \Rfunction{mosim}, in combination with the methods \Rfunction{omicData} and \Rfunction{omicSim}.
* Extract the results from the simulation object with the helper functions \Rfunction{omicResults} and \Rfunction{omicSettings}.

## Getting started

The `MOSim` package may be installed as:

```{r code, echo=TRUE, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("MOSim")
```

The current development version may be installed as follows:

```{r code1, echo=TRUE, eval=FALSE}
library(devtools)

devtools::install_github("ConesaLab/MOSim")
```

## MOSim input parameters

For the experimental design of the simulation, there are 3 parameters to be set: the number of experimental groups or conditions, the number of time points (1, if time series are not to be considered) and the number of replicates per condition. The only requirements, so that the algorithm can simulate differential expression, are at least 2 groups with no time points, or 1 group with at least 2 time points.

The list of omics to be simulated must be also provided. At this moment `MOSim` supports the following data types:
* RNA-seq (compulsory)
* DNase-seq
* ChIP-seq
* Methyl-seq
* miRNA-seq

The simulation needs gene expression to be present, so RNA-seq will be included always even if it is not specified by the user. The simulation of transcription factors (TF) is also supported as a subset of RNA-seq simulated data.

Optionally, user-defined seed samples to start the simulation can also be given. They are used for extracting the feature identifiers from the row names, and as the initial count distribution to generate the rest of simulated samples. The algorithm includes mouse default samples from STATegra project `(sampleData)` but users may provide seed samples from any other organism or experiment. For each regulatory omic, the association list linking regulator IDs to genes that they potentially regulate is also required. If provided, extra care must be taken to ensure that the identifiers between RNA-seq and the association lists are correctly matched. Again, for STATegra data `(sampleData)`, these association files are included in the package. If TF-target gene associations are provided, TF regulation will be also simulated.

The structure of the custom data and how to correctly pass it to `MOSim` will be described in the following sections.

## Running the simulation: {mosim}

`MOSim` simulations are stored in a custom class S4 object, which means that the information is contained in slots and can be accessed using the standard way (with the operator @). However, this is not recommended and the preferred way to access the information are the accessors or utility function provided by the package.

The first of these functions is `mosim`. This helper method takes all the options, performs the simulation, and returns the simulation object.

Internally, this helper function creates a series of S4 objects according to the options passed by the user and calls the required methods to simulate the data, gather the results and return them. The user only needs to set the simulation options, as indicated in the following example:

\Robject{mosim(omics, omicsOptions = NULL, diffGenes = .15, numberReps = 3, numberGroups = 2, times = c(0, 2, 4, 12, 24), depth = 74, noiseParams = list("sd" = 0.05), profileProbs = list(
            continuous.induction = .235,
            continuous.repression = .235,
            transitory.induction = .235,
            transitory.repression = .235,
            flat = .06
        ), minMaxFC = c(3, 8), TFtoGene = NULL)}

The main arguments accepted by `mosim` function are:

* [omics] Character vector containing the names of the omics to simulate, which can be "RNA-seq", "miRNA-seq", "DNase-seq", "ChIP-seq" or "Methyl-seq"  (e.g. c("RNA-seq", "miRNA-seq")). It can also be a list with the omic names as names and their options as values, but we recommend to use the argument omicsOptions to provide the options to simulate each omic.
* [omicsOptions] List containing the options to simulate for each omic. We recommend to apply the helper method \Rfunction{omicSim} to create this list in a friendly way, and the function \Rfunction{omicData} to provide custom data (see the related sections for more information). Each omic may have different configuration parameters, but the common ones are:

  + [simuData/idToGene] Seed sample and association tables for regulatory omics. The helper function \Rfunction{omicData} should be used to provide this information (see the following section).
  + [regulatorEffect] For regulatory omics. List containing the percentage of effect types (repressor, activator or no effect) over the total number of regulators. For example \Robject{list('repressor' = 0.05, 'NE' = 0.95)}. Remember that these numbers might be modified by the algorithm as explained in section ~\@ref(algorithm).
  + [totalFeatures] Number of features to simulate. By default, the total number of features in the seed dataset.
  + [depth] Sequencing depth in millions of reads. If not provided, it takes the global parameter passed to \Rfunction{mosim} function.
  + [replicateParams] List with parameters $a$ and $b$ for adjusting the variability in the generation of replicates using the negative binomial. See section \@ref(advanced) for more information.

  + [diffGenes] Number of differentially expressed genes to simulate, given in percentage (0 - 1) or in absolute number (> 1).
  + [numberGroups] Number of experimental groups or conditions to simulate.
  + [numberReps] Number of replicates per experimetal condition.
  + [times] Vector of time points to consider in the experimental design.
  + [depth] Sequencing depth in millions of reads.
  + [minMaxFC] Vector of minimum and maximum fold-change allowed for differentially expressed features.
  + [TFtoGene] A logical value indicating if default transcription factors data should be used (TRUE) or not (NULL), or a 3 column data frame containing custom associations as explained in \@ref(sec:TF). For transcription factors, the count matrix is not simulated like in the other omics but extracted from RNA-seq simulated data. Default value = NULL.


The most basic example of `mosim` function usage is calling it with only the list of omics to simulate. In this case, the default values will be used, including the default data samples.
```{r load, echo=FALSE, eval=TRUE, include=TRUE}
library(MOSim)
```

```{r code2, echo=TRUE, eval=TRUE}
library(MOSim)

omic_list <- c("RNA-seq")

rnaseq_simulation <- mosim(omics = omic_list)
```

The `rnaseq_simulation` object is a `Simulation` class object containing the simulated data, that can be easily accessed with the helper functions `omicResults` and `omicSettings`, as we will see in the corresponding section.

Following with that basic example above, we can modify the experimental design to simulate 2 groups, 1 time point and 4 replicates per group:

```{r code3, echo=TRUE, eval=TRUE, include=TRUE}
rnaseq_simulation <- mosim(omics = c("RNA-seq"),
                           times = 0,
                           numberGroups = 2,
                           numberReps = 4)
```

Invalid combinations of experimental design arguments will make the algorithm stop with an error message, like this:

```{r code4, echo=TRUE, eval=FALSE, include=TRUE, error=TRUE}
rnaseq_simulation <- mosim(omics = c("RNA-seq"),
                           times = 0,
                           numberGroups = 1,
                           numberReps = 4)
```

To obtain more than one omic data type, the omics list must be modified. RNA-seq is mandatory, and will be automatically included in the simulation, no matter if it is listed or not. Therefore these two simulations would be equivalent:

```{r code5, echo=TRUE, eval=FALSE, include=TRUE}
multi_simulation <- mosim(omics = c("RNA-seq", "DNase-seq"),
                          times = c(0, 5, 10),
                          numberGroups = 2,
                          numberReps = 4,
                          diffGenes = .3)

dnase_simulation <- mosim(omics = c("DNase-seq"),
                          times = c(0, 5, 10),
                          numberGroups = 2,
                          numberReps = 4,
                          diffGenes = .3)
```

As it can be seen, `mosim` function accepts global simulation parameters, but specific settings for a particular omic should be provided through two specially designed functions: `omicData` and `omicSim`.

### Provided STATegra dataset

The STATegra dataset [Gomez-Cabrero *et al.* 2019](https://www.nature.com/articles/s41597-019-0202-7) is provided in the `MOSim` package under `sampleData`. The dataset contains sample count matrices for RNA-seq, DNase-seq, miRNA-seq, ChIP-seq and Methyl-seq, as well as regulator association lists. 

This provided dataset may be called by the user:

`data("sampleData")`

### Providing custom data: `omicData`

The function `omicData` was designed to help users to provide their own seed data sets, as follows:

`omicData(omic, data, associationList = NULL)`

This helper function accepts 3 parameters:

* [omic] The name of the omic data type whose seed sample is to be provided. The omic names must be included in the list of accepted omics.
* [data] Count data. A data frame or ExpressionSet object with the omic identifiers as row names and just one column named \texttt{Counts}, containing the counts to be used as seed sample in the simulation for that omic.
* [associationList] Only for regulatory omics. Data frame with 2 columns containing the potential associations between genes and regulators. The first column, called \texttt{ID}, must contain the regulator IDs, and the second column, called \texttt{Gene}, must contain the gene identifiers.


For illustration purposes, consider as our custom data a subset of the default gene expression dataset. To use it as our seed RNA-seq dataset, we can use this code:

```{r code6, echo=TRUE, eval=TRUE,cache=TRUE, tidy=FALSE, results='hide', message=FALSE}
# Take a subset of the included dataset for illustration
# purposes. We could also load it from a csv file or RData,
# as long as we transform it to have 1 column named "Counts"
# and the identifiers as row names.
data("sampleData")

custom_rnaseq <- head(sampleData$SimRNAseq$data, 100)

# In this case, 'custom_rnaseq' is a data frame with
# the structure:
head(custom_rnaseq)
##                    Counts
## ENSMUSG00000000001   6572
## ENSMUSG00000000003      0
## ENSMUSG00000000028   4644
## ENSMUSG00000000031      8
## ENSMUSG00000000037      0
## ENSMUSG00000000049      0


# The helper 'omicData' returns an object with our custom data.
rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)

# We use the associative list of 'omics' parameter to pass
# the RNA-seq object.
rnaseq_simulation <- mosim(omics = list("RNA-seq" = rnaseq_customdata))
```

RNA-seq is a special case of omic data type because it does not require an association list to work. For any other omic, such as DNase-seq, we need two different data frames: the seed sample with the structure already mentioned, and the associations between regulator IDs and genes.

```{r code7, echo=TRUE, eval=TRUE, tidy=FALSE, include=TRUE, results='hide', message=FALSE}
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_dnaseseq <- head(sampleData$SimDNaseseq$data, 100)

# Retrieve a subset of the default association list.
dnase_genes <- sampleData$SimDNaseseq$idToGene
dnase_genes <- dnase_genes[dnase_genes$ID %in%
                               rownames(custom_dnaseseq), ]

# In this case, 'custom_dnaseseq' is a data frame with
# the structure:
head(custom_dnaseseq)
##                       Counts
## 1_63176480_63177113      513
## 1_125435495_125436168   1058
## 1_128319376_128319506     37
## 1_139067124_139067654    235
## 1_152305595_152305752    105
## 1_172490322_172490824    290

# The association list 'dnase_genes' is another data frame
# with the structure:
head(dnase_genes)
##                      ID               Gene
## 29195 1_3670777_3670902 ENSMUSG00000051951
## 29196 1_3873195_3873351 ENSMUSG00000089420
## 29197 1_4332428_4332928 ENSMUSG00000025900
## 29198 1_4346315_4346445 ENSMUSG00000025900
## 29199 1_4416827_4416973 ENSMUSG00000025900
## 29200 1_4516660_4516798 ENSMUSG00000096126

dnaseseq_customdata <- omicData("DNase-seq",
                                data = custom_dnaseseq,
                                associationList = dnase_genes)

multi_simulation <- mosim(omics = list(
    "RNA-seq" = rnaseq_customdata,
    "DNase-seq" = dnaseseq_customdata)
    )
```

The two exceptions in this section are transcription factors and methylation.

The simulated transcription factor data is extracted from the generated RNA-seq data but a data frame with 3 columns needs to be provided:  `TF` column, with the transcription factor identifiers (any type of identifier can be used);
`TFgene` column, with transcription factor identifiers that must coincide with the type of identifier used in RNA-seq;
and `LinkedGene` column, with the identifier of the target gene (again, the same used in RNA-seq data).
Instead of applying `omicData` function for this purpose, the `TFtoGene` argument in `mosim` function must be used:

```{r code8, echo=TRUE, eval=TRUE, tidy=FALSE, include = TRUE, results='hide', message=FALSE}
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_tf <- head(sampleData$SimRNAseq$TFtoGene, 100)
#      TF             TFgene         LinkedGene
# 1  Aebp2 ENSMUSG00000030232 ENSMUSG00000000711
# 2  Aebp2 ENSMUSG00000030232 ENSMUSG00000001157
# 3  Aebp2 ENSMUSG00000030232 ENSMUSG00000001211
# 4  Aebp2 ENSMUSG00000030232 ENSMUSG00000001227
# 5  Aebp2 ENSMUSG00000030232 ENSMUSG00000001305
# 6  Aebp2 ENSMUSG00000030232 ENSMUSG00000001794

multi_simulation <- mosim(omics = list(
    "RNA-seq" = rnaseq_customdata,
    "DNase-seq" = dnaseseq_customdata),
    # The option is passed directly to mosim function instead of
    # being an element inside "omics" parameter.
    TFtoGene = custom_tf
    )
```

For methylation, a seed count sample does not need to be provided because it will be generated automatically. Methylation simulation only needs the association list containing the CpG sites to be simulated and the associated genes. The chromosomal positions for the CpG sites must be given in the format `<chr>_<start>_<end>`, that is, the chromosome number, start and end positions separated by the char `_`.

```{r code9, echo=TRUE, eval=TRUE, tidy=FALSE, results='hide', message=FALSE}
# Select a subset of the available data as a custom dataset
data("sampleData")

custom_cpgs <- head(sampleData$SimMethylseq$idToGene, 100)

# The ID column will be splitted using the "_" char
# assuming <chr>_<start>_<end>.
#
# These positions will be considered as CpG sites
# and used to generate CpG islands and other elements.
#
# Please refer to MOSim paper for more information.
#
#                    ID               Gene
# 1  11_3101154_3101154 ENSMUSG00000082286
# 2  11_3101170_3101170 ENSMUSG00000082286
# 3  11_3101229_3101229 ENSMUSG00000082286
# 4  11_3101287_3101287 ENSMUSG00000082286
# 5  11_3101329_3101329 ENSMUSG00000082286
# 6  11_3101404_3101404 ENSMUSG00000082286
```

### Changing omic settings: `omicSim`

As explained before when describing `mosim` function, there are two ways of passing omic configuration options: by giving a list in the `omics` parameter or by giving `omics` as a character vector including the omics to simulate and also specifying the simulation options in the parameter `omicsOptions`.

The `omicsOptions` parameter accepts a list, but the `MOSim` helper function, `omicSim`, allows to do it in a more straightforward way.

\Robject{omicSim(omics, depth = NULL, totalFeatures = NULL, regulatorEffect = NULL)}

* [omics] String containing the name of the omic to simulate, which can be "RNA-seq", "miRNA-seq", "DNase-seq", "ChIP-seq" or "Methyl-seq".
* [depth] Sequencing depth in millions of reads. If not provided, it takes the global parameter passed to \Rfunction{mosim} function.
* [totalFeatures] Number of features to simulate. By default, the total number of features in the seed dataset.
* [regulatorEffect] List containing the percentage of effect types (repressor, activator or no effect) over the total number of regulators. For example \Robject{list('repressor' = 0.05, 'NE' = 0.95)}.

Back to the first basic example of RNA-seq simulation using the default dataset, the code to use if we wish to restrict the number of features is:

```{r code10, echo=TRUE, eval=FALSE, tidy = FALSE, results='hide', message=FALSE}
omic_list <- c("RNA-seq")

rnaseq_options <- omicSim("RNA-seq", totalFeatures = 2500)

# The return value is an associative list compatible with
# 'omicsOptions'
rnaseq_simulation <- mosim(omics = omic_list,
                           omicsOptions = rnaseq_options)
```

When having multiple omics, we concatenate the information like follows:

```{r code11, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE}
omics_list <- c("RNA-seq", "DNase-seq")

# In R concatenaning two lists creates another one merging
# its elements, we use that for 'omicsOptions' parameter.
omics_options <- c(omicSim("RNA-seq", totalFeatures = 2500, depth = 74),
                   omicSim("DNase-seq",
                           # Limit the number of features to simulate
                           totalFeatures = 1500,
                           # Modify the percentage of regulators with effects.
                           regulatorEffect = list(
                                'activator' = 0.68,
                                'repressor' = 0.3,
                                'NE' = 0.02
                            )))

set.seed(12345)

multi_simulation <- mosim(omics = omics_list,
                          omicsOptions = omics_options)
```

The objects generated by `omicData` and `omicSim` are different and special attention must be paid to combine them. The following code shows an example on how to do it:

```{r code12, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE}
rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)
rnaseq_options <- omicSim("RNA-seq", totalFeatures = 100)

rnaseq_simulation <- mosim(omics = list("RNA-seq" = rnaseq_customdata),
                           omicsOptions = rnaseq_options)
```



## Working with simulation results


The information contained in a simulation object can be classified in two categories: the simulation settings used to perform the simulation, and the count data matrices generated by the process.

To access this information, `MOSim` provides two helper functions: `omicSettings` to retrieve the simulation settings and `omicResults` for accessing the count matrices.

#### The `simulation` object

After running `mosim`, an S4 object is generated containing all the information from the simulation. This object may be parsed using `omicResults` and `omicSettings` functions. The `simulation` object contains the information about the global `simulation` process, including association of genes with gene classes, regulatory programs and other settings.

For user understanding, the `simulation` object has the following structure:

* [simulators] Vector containing either S4 initialized classes of simulators or a list with the class name as keys, and its options as value.
* [totalGenes] A number with the total number of genes including not expressed. Overwritten if a genome reference is provided.
* [diffGenes] A scalar with the total number of differential genes if value > 1 or if value < 1, the \% of total genes.
* [numberReps] Number of replicates of the experiment.
* [numberGroups] Number of groups considered on the experiment.
* [times] Numeric vector containing the measured times. If numberGroups < 2, the number of times must be at least 2.
* [geneNames] Read only. List containing the IDs of the genes. Overwritten by the genome reference if provided.
* [simSettings] List of settings that overrides initializing the configuration of the simulation by passing a previously generated list.
* [noiseFunction] Noise function to apply when simulating counts. Must accept the parameter 'n' and return a vector of the same length. Defaults to `rnorm` function.
* [profiles] Named list containing the patterns with their coefficients.
* [profileProbs] Numeric vector with the probabilities to assign each of the patterns. Defaults to 0.2 for each.
* [noiseParams] Default noise parameters to be used with noise function.
* [depth] Default depth to simulate (million of reads).
* [TFtoGene] Boolean (for default data) or 3 column data frame containing Symbol-TFGene-LinkedGene
* [minMaxQuantile] Numeric vector of length 2 indicating the quantiles to use in order to retrieve the absolute minimum and maximum value that a differentially expressed feature can have.
* [minMaxFC] Numeric vector of length 2 indicating the minimum and maximum fold-change that a differentially expressed feature can have.


#### Retrieving the simulation settings: `omicSettings`

The helper function `omicSettings` is used to extract the settings used in the simulation:

`omicSettings(simulation, omics = NULL, association = FALSE, reverse = FALSE, only.linked = FALSE, include.lagged = TRUE)`

The following parameters are accepted by the function:

* [simulation] Simulation object returned by \Rfunction{mosim} function.
* [omics] List with the names of the omic data types whose settings are to be retrieved.
* [association] A logical value. If TRUE, the original association lists used in the simulation are included.
* [reverse] A logical value. If TRUE, it swaps the column order in the association list in case we want to use the output directly and the program requires a different ordering.
* [only.linked] A logical value. If TRUE, it returns only the regulator-gene interactions with effect.
* [include.lagged] A logical value. If TRUE it will return the full settings table including regulator-gene interactions in which the minimum/maximum value for transitory profiles does not perfectly match, otherwise they will be filtered.
* [prefix] prepend the omic name to the

Users can choose to recover the setting for all the simulated omics or just for some of them:

```{r code13, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE}
# This will be a data frame with RNA-seq settings (DE flag, profiles)
rnaseq_settings <- omicSettings(multi_simulation, "RNA-seq")

# This will be a list containing all the simulated omics (RNA-seq
# and DNase-seq in this case)
all_settings <- omicSettings(multi_simulation)
```

For RNA-seq, the settings table has an structure similar to this:
```{r table1, echo = FALSE, eval = TRUE, warning = FALSE}
# Create the data frame
df <- data.frame(
  ID = c("ENSMUSG00000017204", "ENSMUSG00000097082", "ENSMUSG00000055493", 
         "ENSMUSG00000017221", "ENSMUSG00000020205", "ENSMUSG00000087802"),
  DE = c(TRUE, TRUE, TRUE, TRUE, TRUE, FALSE),
  Group1 = c("transitory.induction", "transitory.induction", "transitory.induction", 
             "transitory.induction", "transitory.induction", "flat"),
  Group2 = c("continuous.repression", "transitory.induction", "continuous.repression", 
             "continuous.induction", "continuous.induction", "flat"),
  Tmax_Group1 = c(2.57, 1.46, 2.37, 2.63, 2.83, NA),
  Tmax_Group2 = c(NA, 2.23, NA, NA, NA, NA)
)

# Generate the table
print(df, row.names = FALSE)
```


Each column provides different information about the settings used to carry on the simulation:

* [ID] Gene identifier.
* [DE] A logical value indicating if the gene was selected as differentially expressed (TRUE) or not (FALSE).
* [GroupX] There will be as many group columns as groups defined in the experimental design, each one containing the type of expression profile assigned to the gene in the simulation.
* [Tmax.GroupX] For transitory profiles, the time point with the absolute maximum (or minimum) value.

For regulatory omics, the structure will slightly differ from RNA-seq, adding additional columns. Note that in this example, for reading purposes, the last 4 columns containing the `Tmax.GroupX` and `Lagged.GroupX` have been omitted:
```{r table2, echo = FALSE, eval = TRUE, warning = FALSE}
df <- data.frame(
  ID = c("10_111588324_111588448", "10_111588324_111588448", 
         "10_11358301_11358431", "10_11358301_11358431", 
         "11_98682094_98682786", "11_98682094_98682786"),
  Gene = c("ENSMUSG00000097082", "ENSMUSG00000020205", 
           "ENSMUSG00000055493", "ENSMUSG00000087802", 
           "ENSMUSG00000017204", "ENSMUSG00000017221"),
  Effect_Group1 = c("activator", "activator", "activator", "NA", "repressor", "repressor"),
  Effect_Group2 = c("activator", "NA", "activator", "NA", "activator", "repressor"),
  Group1 = c("transitory.induction", "transitory.induction", 
             "transitory.induction", "transitory.induction", 
             "transitory.repression", "transitory.repression"),
  Group2 = c("transitory.induction", "transitory.induction", 
             "continuous.repression", "continuous.repression", 
             "continuous.repression", "continuous.repression"),
  Extra = rep("...", 6) # Placeholder for extra columns
)

# Print the table in a readable format
print(df, row.names = FALSE)
```


Each row describes a regulator-gene interaction, with the following columns:  
* [ID]: Regulator identifier.  
* [Gene]: Gene identifier.  
* [Effect.GroupX]: There will be as many effect group columns as groups in the experimental design. Each one will contain the effect of the regulator on the gene. As explained in previous sections, if both gene (being a DEG) and regulator share the same profile, the regulator is considered to act as activator; if they have completely opposite profiles, the regulator will be a repressor; for any other case,  \texttt{NA} value will be set.  
* [GroupX]: There will be as many group columns as groups defined in the experimental design, each one containing the type of expression profile assigned to the regulator in the simulation, as described in section \@ref(algorithm).  
* [Tmax.GroupX]: For transitory profiles, the time point with the absolute maximum (or minimum) value.  
* [Lagged.GroupX]: For transitory profiles, a logical value indicating if regulator and gene share the same maximum (or minimum) time point or not. The difference between points could explain potentially low correlation values between the two.  

To retrieve the original association lists, the parameter `association` must be set to `TRUE`:

```{r code14, echo=TRUE, eval=TRUE, tidy=FALSE, results='hide', message=FALSE}
# This will be a list with 3 keys: settings, association and regulators
dnase_settings <- omicSettings(multi_simulation, "DNase-seq",
                               association = TRUE)
```

When setting the `association` parameter to `TRUE`, the output object will be a list of lists with the following key names:  

* [association] List containing the association table for each omic.  
* [settings] List containing the setting data frames for each omic.  
* [regulators] Data frame combining the settings from all regulatory omics, adding an additional column `Omic`.  

### Accessing the count data matrices: `omicResults`

The last helper function is `omicResults`:

`omicResults(simulation, omics = NULL)`

This function can accept 2 parameters: the simulation output object and, optionally, the omics we want to retrieve. As in the previous helper function, retrieving one omic will result in a data frame object, and for more than one a list of data frames will be provided.

```{r code15, echo=TRUE, eval=TRUE, tidy = FALSE, results='hide', message=FALSE}
# multi_simulation is an object returned by mosim function.

# This will be a data frame with RNA-seq counts
rnaseq_simulated <- omicResults(multi_simulation, "RNA-seq")

#                    Group1.Time0.Rep1 Group1.Time0.Rep2 Group1.Time0.Rep3 ...
# ENSMUSG00000073155              4539              5374              5808 ...
# ENSMUSG00000026251                 0                 0                 0 ...
# ENSMUSG00000040472              2742              2714              2912 ...
# ENSMUSG00000021598              5256              4640              5130 ...
# ENSMUSG00000032348               421               348               492 ...
# ENSMUSG00000097226                16                14                 9 ...
# ENSMUSG00000027857                 0                 0                 0 ...
# ENSMUSG00000032081                 1                 0                 0 ...
# ENSMUSG00000097164               794               822               965 ...
# ENSMUSG00000097871                 0                 0                 0 ...

# This will be a list containing RNA-seq and DNase-seq counts
all_simulated <- omicResults(multi_simulation)
```

The structure of the final count matrix will have the features as row names, and the conditions as column names following the scheme `<Group>.<Timepoint>.<Replicate>`.

Alternatively a `ExpressionSet` object can be returned by setting the `format` argument to `ExpressionSet`.

### Obtaining the experimental design matrix: `experimentalDesign`

Downstream analysis of the simulated datasets will require an experimental design matrix depicting the simulated comparisons between groups and throughout time. To generate an experiental design matrix, function `experimentalDesign` needs a simulaton object.

```{r code16, echo=TRUE, eval=TRUE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE}
# Generate a simulation object
omic_list <- c("RNA-seq")
rnaseq_simulation <- mosim(omics = omic_list)

# This will be a data frame with RNA-seq counts
design_matrix <- experimentalDesign(rnaseq_simulation)
design_matrix
```

### Plotting results: `plotProfile`

Graphical plots are useful to check a feature profile or to compare gene & regulator interactions. To generate them, the function `plotProfile` needs the simulation object, the omic or two omics to plot, and one feature for each omic.

```{r code17, echo=TRUE, eval=FALSE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE}

# The methods returns a ggplot plot, if called directly
# it will be automatically plotted.
plotProfile(multi_simulation,
            omics = c("RNA-seq", "DNase-seq"),
            featureIDS = list(
                "RNA-seq" = "ENSMUSG00000024691",
                "DNase-seq" = "19_12574278_12574408"
            ))
```

The returned ggplot can be stored in a variable to customize other attributes.

```{r code18, echo=TRUE, eval=FALSE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE}
library(ggplot2)

# Store the plot in a variable
profile_plot <- plotProfile(multi_simulation,
            omics = c("RNA-seq", "DNase-seq"),
            featureIDS = list(
                "RNA-seq" = "ENSMUSG00000024691",
                "DNase-seq" = "19_12574278_12574408"
            ))

# Modify the title and print
profile_plot +
    ggtitle("My custom title") +
    theme_bw() +
    theme(legend.position="top")
```

## Advanced use cases

Most of the common users' needs should be covered by the previously showed examples, but this section describes some advanced settings as the variability of the negative binomial distribution that is used to generate replicates.


### Negative binomial variance

In a negative binomial distribution, the variance depends on the mean. In `MOSim`, the generated counts for a given condition (and/or time point) are taken as the mean of the distribution. To model the dependence between the negative binomial mean and variance for each omic, we analyzed several data sets and experiments, and observed a linear relationship between log-transformed count values of means and variances (R^2 > 0.95 for all models): sigma^2 = 10^a * (mu + 1)^b - 1. To assure a minimum variance we really used the maximum of this value and 0.03.
A regression model was applied to estimate coefficients a and b and these estimations were used as default values. The default values for `a` and `b` can be changed by users to increase or decrease the default variability in each omic data type.

### Transforming regulator data to 1/0 format

In some special cases, it may be necessary to transform a regulator matrix into
0/1 format (e.g. to simulate datasets counting presence/absence of an event). 
We can generate a dataframe of 1 and 0 by running:

```{r code19, echo=TRUE, eval=TRUE, tidy = FALSE, results = "hide", message=FALSE, warning=FALSE}
rnaseq_simulation <- mosim(omics = c("RNA-seq", "ChIP-seq"))
rnaseq_simulated <- omicResults(rnaseq_simulation, c("RNA-seq", "ChIP-seq"))
discrete_ChIP <- discretize(rnaseq_simulated, "ChIP-seq")
```


## Special simulation case: *Transcription Factors*

Transcription factors may be simulated using `MOSim`, but are a special case, as they represent a subset of the simulated RNA-seq data. They are the result of including parameter `TFtoGene = TRUE` in the simulation using `mosim` function. It is **important** to remember Transcription Factors are not simulated when included in the input list to `(omic)` parameter.

However, similar to other omic simulation results, the simulated dataframe for TF is extracted by default (if `TFtoGene = TRUE`) by `omicResults`, and the association list and regulator effect by `omicSettings`.

## How to cite `MOSim`

The `MOSim` package is published in Briefings in Bioinformatics:

Monzó C., Aguerralde-Martin M., Martínez-Mira C., Arzalluz-Luque A., Conesa A., Tarazona S. (2025) MOSim: bulk and single-cell multi-layer regulatory network simulator. Briefings in Bioinformatics, Volume 26, Issue 2. DOI: 10.1093/bib/bbaf110

(https://academic.oup.com/bib/article/26/2/bbaf110/8089935?utm_source=advanceaccess&utm_campaign=bib&utm_medium=email)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{associationList}
\alias{associationList}
\title{Data to showcase scRNA and scATAC-seq association}
\format{
A dataframe with two columns and rows according to gene/feature relationships
 \describe{
     \item{Peak_ID}{ATAC chromosomic positions associated to genes}
     \item{Gene_ID}{RNA genes associated to peaks}
     }
     
 @source {Created in-house to serve as an example}
}
\usage{
data("associationList")
}
\description{
Data to showcase scRNA and scATAC-seq association
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{omicResults}
\alias{omicResults}
\title{Retrieves the simulated data.}
\usage{
omicResults(simulation, omics = NULL, format = "data.frame")
}
\arguments{
\item{simulation}{A MOSimulation object.}

\item{omics}{List of the omics to retrieve the simulated data.}

\item{format}{Type of object to use for returning the results}
}
\value{
A list containing an element for every omic specifiec, with the
  simulation data in the format indicated, or a numeric matrix with simulated
  data if the omic name is directly provided.
}
\description{
Retrieves the simulated data.
}
\examples{

omic_list <- c("RNA-seq")
rnaseq_simulation <- mosim(omics = omic_list)
#' # This will be a data frame with RNA-seq counts
rnaseq_simulated <- omicResults(rnaseq_simulation, "RNA-seq")

#                    Group1.Time0.Rep1 Group1.Time0.Rep2 Group1.Time0.Rep3 ...
# ENSMUSG00000073155              4539              5374              5808 ...
# ENSMUSG00000026251                 0                 0                 0 ...
# ENSMUSG00000040472              2742              2714              2912 ...
# ENSMUSG00000021598              5256              4640              5130 ...
# ENSMUSG00000032348               421               348               492 ...
# ENSMUSG00000097226                16                14                 9 ...
# ENSMUSG00000027857                 0                 0                 0 ...
# ENSMUSG00000032081                 1                 0                 0 ...
# ENSMUSG00000097164               794               822               965 ...
# ENSMUSG00000097871                 0                 0                 0 ...

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{scatac}
\alias{scatac}
\title{Data to test scMOSim}
\format{
A seurat Object, subset from seuratData with ATAC
 \describe{
     \item{assays}{ATAC expression values}
     \item{meta.data}{annotations of celltypes}
     }
     
 @source {https://github.com/satijalab/seurat-data, we took 11 cells 
 from each of 4 celltypes}
}
\usage{
data("scatac")
}
\description{
Data to test scMOSim
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{sparsim_estimate_parameter_from_data}
\alias{sparsim_estimate_parameter_from_data}
\title{Estimate SPARSim simulation parameter from a given count table}
\usage{
sparsim_estimate_parameter_from_data(raw_data, norm_data, conditions)
}
\arguments{
\item{raw_data}{count matrix (gene on rows, samples on columns) containing raw count data}

\item{norm_data}{count matrix (gene on rows, samples on columns) containing normalized count data}

\item{conditions}{list where the i-th element of the list contains the column indices for i-th experimental conditions. List must be a named list.}
}
\value{
A SPARSim simulation parameters
}
\description{
Function to estimate SPARSim simulation parameters (intensity, variability and library sizes) from a real count table.
If the real count table contains more than one experimental condition, it is possible to estimate the parameters for each experimental condition.
}
\details{
This function is a copy of the `SPARSIM_estimate_parameter_from_data` function from the
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
under the GPL-3 license.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{simulate_hyper}
\alias{simulate_hyper}
\title{Simulate technical variability}
\usage{
simulate_hyper(avgAbund, seqdepth = NULL, digits, max_val)
}
\arguments{
\item{avgAbund}{array containing the intensity values for each feature. It describes the intensity of a single sample}

\item{seqdepth}{sequencing depth (i.e. sample size of the MH)}

\item{digits}{number of digits for random number generation}

\item{max_val}{max value for random number generation}
}
\value{
An array of \code{length(avgAbund)} elements representing the count values for the current sample
}
\description{
Function to simulate the technical variability (i.e. a multivariate hypergeometric on a gamma expression value array)
}
\details{
This function is a copy of the `simulate_hyper` function from the
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
under the GPL-3 license.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{mosim}
\alias{mosim}
\title{mosim}
\usage{
mosim(
  omics,
  omicsOptions,
  diffGenes,
  numberReps,
  numberGroups,
  times,
  depth,
  profileProbs,
  minMaxFC,
  TFtoGene
)
}
\arguments{
\item{omics}{Character vector containing the names of the omics to simulate,
which can be "RNA-seq", "miRNA-seq", "DNase-seq", "ChIP-seq" or
"Methyl-seq"  (e.g. c("RNA-seq", "miRNA-seq")). It can also be a list with
the omic names as names and their options as values, but we recommend to
use the argument omicSim to provide the options to simulated each omic.}

\item{omicsOptions}{List containing the options to simulate each omic. We
recommend to apply the helper method \link{omicSim} to create this list in
a friendly way, and the function \link{omicData} to provide custom data
(see the related sections for more information). Each omic may have
different configuration parameters, but the common ones are:
\describe{
    \item{simuData/idToGene}{Seed sample and association tables for
    regulatory omics. The helper function \link{omicData} should be used to
    provide this information (see the following section).}
    \item{regulatorEffect}{For regulatory omics. List containing the
    percentage of effect types (repressor, activator or no effect) over the
    total number of regulators. See vignette for more information.}
    \item{totalFeatures}{Number of features to simulate. By default, the
    total number of features in the seed dataset.}
    \item{depth}{Sequencing depth in millions of reads. If not provided,
    it takes the global parameter passed to \link{mosim} function.}
    \item{replicateParams}{List with parameters \emph{a} and \emph{b} for
    adjusting the variability in the generation of replicates using the
    negative binomial. See vignette for more information.}
 }}

\item{diffGenes}{Number of differentially expressed genes to simulate, given
in percentage (0 - 1) or in absolute number (> 1). By default 0.15}

\item{numberReps}{Number of replicates per experimetal condition (and time
point, if time series are to be generated). By default 3.}

\item{numberGroups}{Number of experimental groups or conditions to simulate.}

\item{times}{Vector of time points to consider in the experimental design.}

\item{depth}{Sequencing depth in millions of reads.}

\item{profileProbs}{Numeric vector with the probabilities to assign each of
the patterns. Defaults to 0.2 for each.}

\item{minMaxFC}{Numeric vector of length 2 with minimum and maximum fold-change
for differentially expressed features, respectively.}

\item{TFtoGene}{A logical value indicating if default transcription factors
data should be used (TRUE) or not (FALSE), or a 3 column data frame
containing custom associations. By default FALSE.}
}
\value{
Instance of class "MOSimulation" containing the multiomic simulation
  data.
}
\description{
Performs a multiomic simulation by chaining two actions: 1) Creating the
"MOSimulation" class with the provided params. 2) Calling "simulate" method on
the initialized object.
}
\examples{

 moSimulation <- mosim(
     omics = c("RNA-seq"),
     numberReps = 3,
     times = c(0, 2, 6, 12, 24)
 )

 # Retrieve simulated count matrix for RNA-seq
 dataRNAseq <- omicResults(moSimulation, "RNA-seq")


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_MOSim.R
\name{sc_param_estimation}
\alias{sc_param_estimation}
\title{sc_param_estimation}
\usage{
sc_param_estimation(
  omics,
  cellTypes,
  diffGenes = list(c(0.2, 0.2)),
  minFC = 0.25,
  maxFC = 4,
  numberCells = NULL,
  mean = NULL,
  sd = NULL,
  noiseGroup = 0.5,
  group = 1,
  genereggroup
)
}
\arguments{
\item{omics}{named list containing the omics to simulate as names, which can 
be "scRNA-seq" or "scATAC-seq".}

\item{cellTypes}{list where the i-th element of the list contains the column 
indices for i-th cell type. List must be a named list.}

\item{diffGenes}{If number groups > 1, Percentage DE genes to simulate.
List of vectors (one per group to compare to group 1) where the vector
contains absolute number of genes for Up and Down ex: c(250, 500) or a 
percentage for up, down ex: c(0.2, 0.2). The rest will be NE}

\item{minFC}{Threshold of FC below which are downregulated, by default 0.25}

\item{maxFC}{Threshold of FC above which are upregulated, by default 4}

\item{numberCells}{vector of numbers. The numbers correspond to the number 
of cells the user wants to simulate per each cell type. The length of the 
   vector must be the same as length of \code{cellTypes}.}

\item{mean}{vector of numbers of mean depth per each cell type. Must be specified 
just if \code{numberCells} is specified.}

\item{sd}{vector of numbers of standard deviation per each cell type. Must be 
specified just if \code{numberCells} is specified.}

\item{noiseGroup}{OPTIONAL. Number indicating the desired standard deviation
between treatment groups}

\item{group}{Group for which to estimate parameters}

\item{genereggroup}{List with information of genes, clusters and regulators
that must be related to each other}
}
\value{
a list of Seurat object, one per each omic.

a named list with simulation parameters for each omics as values.
}
\description{
Evaluate the users parameters for single cell simulation and use SPARSim
to simulate the main dataset. Internal function
}
\examples{
omicsList <- sc_omicData(list("scRNA-seq"))
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
'Memory_B' = c(31:40))
#estimated_params <- sc_param_estimation(omicsList, cell_types)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_MOSim.R
\name{sc_omicSettings}
\alias{sc_omicSettings}
\title{sc_omicSettings}
\usage{
sc_omicSettings(sim, TF = FALSE)
}
\arguments{
\item{sim}{a simulated object from sc_mosim function}

\item{TF}{OPTIONAL default is FALSE, if true, extract TF association matrix}
}
\value{
list of Association matrices explaining the effects of each
regulator to each gene
}
\description{
sc_omicSettings
}
\examples{

cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
'Memory_B' = c(31:40))
omicsList <- sc_omicData(list("scRNA-seq"))
sim <- sc_mosim(omicsList, cell_types)
res <- sc_omicSettings(sim)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TF_human}
\alias{TF_human}
\title{Data to extract human TF}
\format{
vector of gene names
 \describe{
     \item{data.frame}{gene names corresponding to TF and to Target genes}
     }
 @source {https://tflink.net/}
}
\usage{
data("TF_human")
}
\description{
Data to extract human TF
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R
\docType{class}
\name{MOSimulatorRegion-class}
\alias{MOSimulatorRegion-class}
\alias{SimRNAseq-class}
\alias{SimTF-class}
\alias{SimmiRNAseq-class}
\alias{SimChIPseq-class}
\alias{SimDNaseseq-class}
\alias{SimMethylseq-class}
\title{Virtual class containing general methods for simulators based on regions of
the chromosomes, like DNase-seq, ChIP-seq or Methyl-seq}
\description{
Virtual class containing general methods for simulators based on regions of
the chromosomes, like DNase-seq, ChIP-seq or Methyl-seq

Class to simulate RNA-seq data

Class to simulate transcription factor data

Class to simulate miRNA-seq

Class to simulate ChIP-seq data

Class to simulate DNase-seq data

Class to simulate Methyl-seq data.
}
\section{Slots}{

\describe{
\item{\code{locs}}{Vector containing the list of locations of the sites.}

\item{\code{locsName}}{Type of the site to simulate, only for debug.}

\item{\code{splitChar}}{Character symbol used to split identifiers in chr/start/end}

\item{\code{nCpG}}{numeric. Number of CpG sites to simulate.}

\item{\code{pSuccessMethReg}}{numeric. Probability of success in methylated region.}

\item{\code{pSuccessDemethReg}}{numeric. Probability of success in non methylated
region}

\item{\code{errorMethReg}}{numeric. Error rate in methylated region}

\item{\code{errorDemethReg}}{numeric. Error rate in methylated region}

\item{\code{nReadsMethReg}}{numeric. Mean number of reads in methylated region.}

\item{\code{nReadsDemethReg}}{numeric. Mean number of reads in non methylated
regions.}

\item{\code{phaseDiff}}{numeric. Phase difference in the differentially methylated
regions between two samples}

\item{\code{balanceHypoHyper}}{numeric. Balance of hypo/hyper methylation}

\item{\code{ratesHMMMatrix}}{numeric. Matrix of values that describes the exponential
decay functions that define the distances between CpG values.}

\item{\code{distType}}{character. Distribution used to generate replicates:}

\item{\code{transitionSize}}{numeric.}

\item{\code{PhiMeth}}{matrix. Transition matrix for CpG locations.}

\item{\code{PhiDemeth}}{matrix. <Not used>}

\item{\code{typesLocation}}{numeric. <Not used>}

\item{\code{returnValue}}{character. Selected column:}

\item{\code{betaThreshold}}{numeric. Beta threshold value used to calculate M values.}
}}

\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{match_gene_regulator}
\alias{match_gene_regulator}
\title{match_gene_regulator}
\usage{
match_gene_regulator(rna, atac, cell_types, associationList)
}
\arguments{
\item{rna}{dataframe of RNA expression}

\item{atac}{dataframe of ATAC expression}

\item{cell_types}{list of which cells belong to each celltype}

\item{associationList}{dataframe of two columns, Gene_ID and Peak_ID}
}
\description{
Helper function to make the most similar profiles possible between
gene and regulator
}
\examples{
rna <- data.frame(c1 = c(1.5, 15.5, 3.5, 20.5), c2 = c(2, 15, 4, 20), 
        c3 = c(10, 1, 12, 13), c4 = c(11, 1, 13, 14), c5 = c(7, 0, 0, 0), 
        c6 = c(8, 1, 1, 1), c7 = c(8, 1, 1, 1))
rownames(rna) <- c('GenB', 'GenA', 'GenC', 'GenD')
associationList <- data.frame(Gene_ID = c('GenA', 'GenB', 'GenC', 'GenA'),
        Peak_ID = c('PeakA', 'PeakB', 'PeakC', 'PeakD'))
cell_types <- list("ct1" = c(1,2), "ct2" = c(3, 4), "ct3" = c(5, 6), "ct4" = c(7))
atac <- data.frame(c1 = c(3,20, 1,15, 1, 7, 1), c2 = c(4,20, 2,15, 0, 5, 1.5), 
        c3 = c(10, 13, 1, 12, 1, 14, 9), c4 = c(11, 14, 1, 13, 1, 4, 12), 
        c5 = c(0, 0, 0, 7, 1, 6, 6), c6 = c(1, 1, 1, 8, 0, 5, 8), 
        c7 = c(1, 1, 1, 8, 1, 5, 7))
rownames(atac) <- c('PeakB', "PeakC", "PeakF", "PeakD", "PeakE", "PeakA", "PeakG")
match_gene_regulator(rna, atac, cell_types, associationList)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_MOSim.R
\name{sc_omicData}
\alias{sc_omicData}
\title{sc_omicData}
\usage{
sc_omicData(omics_types, data = NULL)
}
\arguments{
\item{omics_types}{A list of strings which can be either "scRNA-seq" or "scATAC-seq"}

\item{data}{A user input matrix with genes (peaks in case of scATAC-seq) as 
rows and cells as columns. By default, it loads the example data.
If a user input matrix is included, cell columns must be sorted by cell t
ype.}
}
\value{
a named list with omics type as name and the count matrix as value
}
\description{
Checks if the user defined data is in the correct format, or loads the default
multiomics pbmc dataset, a subset from SeuratData package
}
\examples{
# Simulate from PBMC
omicsList <- sc_omicData(list("scRNA-seq", "scATAC-seq"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{scrna}
\alias{scrna}
\title{Data to test scMOSim}
\format{
A seurat Object, subset from seuratData with RNA
 \describe{
     \item{assays}{RNA expression values}
     \item{meta.data}{annotations of celltypes}
     }
     
 @source {https://github.com/satijalab/seurat-data, we took 11 cells 
 from each of 4 celltypes}
 This is how:
 dat <- pbmcMultiome.SeuratData::pbmc.rna
 dat <- subset(x = dat, subset = seurat_annotations %in% c("CD4 TEM", 
                                                           "cDC", "Memory B", "Treg"))
 unique_cell_types <- unique(datATmeta.data$seurat_annotations)
 extracted_cells <- list()
 cellnames <- c()
 for (cell_type in unique_cell_types) {
   type_cells <- subset(dat, subset = seurat_annotations %in% cell_type)
   counts <- as.matrix(type_cellsATassays[["RNA"]]ATcounts)
   extracted_cells[[cell_type]] <- counts[, 1:10]
   cellnames <- append(cellnames, replicate(11, cell_type))
 }
 scrna <- Reduce(cbind, extracted_cells)
}
\usage{
data("scrna")
}
\description{
Data to test scMOSim
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{make_association_dataframe}
\alias{make_association_dataframe}
\title{make_association_dataframe}
\usage{
make_association_dataframe(
  group,
  genereggroup,
  numtotalgenes,
  numtotalpeaks,
  minFC,
  maxFC
)
}
\arguments{
\item{group}{Group from which we are generating the association dataframe}

\item{genereggroup}{list of elements to generate the association dataframe
such as clusters of each omic, indices of opposite clusters, which
genes are activated, repressed, behavior of the features etc.}

\item{numtotalgenes}{total number of genes}

\item{numtotalpeaks}{total number of peaks}

\item{minFC}{FC below which is downregulated}

\item{maxFC}{FC above which is upregulated}
}
\value{
a dataframe with all the information the user needs about each gene
     and the order of gene and peak names to rename them in the simulated
     datasets of the group
}
\description{
This function generates a dataframe containing the information of the 
relationship between ATAC and RNA, based on the cluster groups, and then
tells the order the genes and peaks should be in the simulated dataframe
of the group
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{sparsim_estimate_variability}
\alias{sparsim_estimate_variability}
\title{Estimate SPARSim "variability" parameter}
\usage{
sparsim_estimate_variability(data)
}
\arguments{
\item{data}{raw count data matrix (gene on rows, samples on columns)}
}
\value{
An array of variability values having \code{N_genes} elements (\code{N_genes = nrow(data)})
}
\description{
Function to estimate the variability values from the genes in \code{data}.
}
\details{
This function is a copy of the `SPARSIM_estimate_variability` function from the
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
under the GPL-3 license.
This function is used in \code{sparsim_estimate_parameter_from_data} to compute SPARSim "variability" parameter, given a real count table as input.
If the count table contains more than one experimental condition, then the function is applied to each experimental conditions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{discretize}
\alias{discretize}
\title{Discretize ChIP-Seq counts to simulate a binary dataset}
\usage{
discretize(df, omic)
}
\arguments{
\item{df}{A MOSimulated object}

\item{omic}{Character string of the omic to transform into binary data}
}
\value{
A regulator dataframe of 0 and 1
}
\description{
Discretize ChIP-Seq counts to simulate a binary dataset
}
\examples{
omic_list <- c("RNA-seq", "ChIP-seq")
rnaseq_simulation <- mosim(omics = omic_list, 
    omicsOptions = c(omicSim("ChIP-seq", totalFeatures = 2500)))
rnaseq_simulated <- omicResults(rnaseq_simulation, omic_list)
discrete_ChIP <- discretize(rnaseq_simulated, "ChIP-seq")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{simulate_coexpression}
\alias{simulate_coexpression}
\title{simulate coexpression}
\usage{
simulate_coexpression(
  sim_matrix,
  feature_no,
  cellTypes,
  patterns,
  cluster_size = NULL
)
}
\arguments{
\item{sim_matrix}{Matrix with rows as features and columns as cells}

\item{feature_no}{Total number of features to be distributed between the 
coexpression clusters}

\item{cellTypes}{list where the i-th element of the list contains the column 
indices for i-th experimental conditions. List must be a named list.}

\item{patterns}{Tibble with TRUE FALSE depicting the cluster patterns to
simulate. Generated by the user or by \code{make_cluster_patterns}.}

\item{cluster_size}{OPTIONAL. It may be inputted by the user. By default, 
its the number of features divided by the number of patterns to generate.}
}
\value{
the simulated coexpression
}
\description{
Adapted from ACORDE (https://github.com/ConesaLab/acorde) to adapt to our
data input type. Simulates coexpression of genes along celltypes
}
\details{
This function is a slightly modified copy of the `simulate_coexpression` function
from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
interpretable networks of isoform co-usage from single cell data. Nature communications
1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
GPL-3 license.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{make_cluster_patterns}
\alias{make_cluster_patterns}
\title{make_cluster_patterns}
\usage{
make_cluster_patterns(numcells = 4, clusters = 8)
}
\arguments{
\item{numcells}{Number of different celltypes we are simulating}

\item{clusters}{OPTIONAL. Number of co-expression patterns the user wants
to simulate}
}
\value{
A tibble with number of columns equal to number of celltypes, rows
 according to the number of TRUE/FALSE combinations corresponding to the
 gene expression patterns along the cells
}
\description{
Function to make the tibble with cluster combinations for the gene expression
patterns along the cells
This function is a slightly modified copy of the `make_cluster_patterns` function
from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
interpretable networks of isoform co-usage from single cell data. Nature communications
1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
GPL-3 license.
}
\examples{
patterns <- make_cluster_patterns(numcells = 4, clusters = 8)
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
'Memory_B' = c(31:40))
patterns <- make_cluster_patterns(numcells = length(cell_types), 
    clusters = 8)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{omicSim}
\alias{omicSim}
\title{Set the simulation settings for an omic.}
\usage{
omicSim(omic, depth = NULL, totalFeatures = NULL, regulatorEffect = NULL)
}
\arguments{
\item{omic}{Name of the omic to set the settings.}

\item{depth}{Sequencing depth in millions of counts. If not provided will
take the global parameter passed to mosim function.}

\item{totalFeatures}{Limit the number of features to simulate. By default
include all present in the dataset.}

\item{regulatorEffect}{only for regulatory omics. Associative list containing
the percentage of effects over the total number of regulator, including
repressor, association and no effect (NE).}
}
\value{
A list with the appropiate structure to be given as options in mosim
  function.
}
\description{
Set the simulation settings for an omic.
}
\examples{

omic_list <- c("RNA-seq", "miRNA-seq")

rnaseq_options <- c(omicSim("miRNA-seq", totalFeatures = 2500))

# The return value is an associative list compatible with
# 'omicsOptions'
rnaseq_simulation <- mosim(omics = omic_list,
                           omicsOptions = rnaseq_options)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/functions.R
\name{is.declared}
\alias{is.declared}
\title{Check if a variable is declared.}
\usage{
is.declared(object, key = NULL)
}
\arguments{
\item{object}{Variable name to check}

\item{key}{Optional key to check inside object.}
}
\value{
TRUE or FALSE indicating if the variable is initialized & non-empty.
}
\description{
Check if a variable is declared.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R
\docType{class}
\name{MOSimulation-class}
\alias{MOSimulation-class}
\title{This class manages the global simulation process, like associating genes with
gene classes, regulatory programs and other settings. Finally it will
initialize the simulators with their options that will use the previously
generated settings to simulate the data.}
\description{
This class manages the global simulation process, like associating genes with
gene classes, regulatory programs and other settings. Finally it will
initialize the simulators with their options that will use the previously
generated settings to simulate the data.
}
\section{Slots}{

\describe{
\item{\code{simulators}}{Vector containing either S4 initialized classes of
simulators or a list with the class name as keys, and its options as value,
see example.}

\item{\code{totalGenes}}{A number with the total number of genes including not
expressed. Overwritten if a genome reference is provided. Currently not used
as we force to provide real data.}

\item{\code{diffGenes}}{A number with the total number of differential genes (if
value > 1) or \% or total genes (if value < 1).}

\item{\code{numberReps}}{Number of replicates of the experiment.}

\item{\code{numberGroups}}{Number of samples considered on the experiment.}

\item{\code{times}}{Numeric vector containing the measured times. If numberGroups <
2, the number of times must be at least 2.}

\item{\code{geneNames}}{Read only. List containing the IDs of the genes. Overwrited
by the genome reference if provided. Currently not used as we force to
provide real data.}

\item{\code{simSettings}}{List of settings that overrides initializing the
configuration of the simulation by passing a previously generated list.
This could be used to tweak by hand the assigned profiles, genes,
regulatory programs, etc.}

\item{\code{noiseFunction}}{Noise function to apply when simulating counts. Must
accept the parameter 'n' and return a vector of the same length. Defaults
to `rnorm`}

\item{\code{profiles}}{Named list containing the patterns with their coefficients.}

\item{\code{profileProbs}}{Numeric vector with the probabilities to assign each of
the patterns. Defaults to 0.2 for each.}

\item{\code{noiseParams}}{Default noise parameters to be used with noise function.}

\item{\code{depth}}{Default depth to simulate.}

\item{\code{TFtoGene}}{Boolean (for default data) or 3 column data frame containing
Symbol-TFGene-LinkedGene}

\item{\code{minMaxQuantile}}{Numeric vector of length 2 indicating the quantiles to
use in order to retrieve the absolute minimum and maximum value that a
differentially expressed feature can have.}

\item{\code{minMaxFC}}{Numeric vector of length 2 indicating the minimum and maximum
fold-change that a differentially expressed feature can have.}
}}

\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_MOSim.R
\name{sc_mosim}
\alias{sc_mosim}
\title{sc_mosim}
\usage{
sc_mosim(
  omics,
  cellTypes,
  numberReps = 1,
  numberGroups = 1,
  diffGenes = NULL,
  minFC = 0.25,
  maxFC = 4,
  numberCells = NULL,
  mean = NULL,
  sd = NULL,
  noiseRep = 0.1,
  noiseGroup = 0.5,
  regulatorEffect = NULL,
  associationList = NULL,
  feature_no = 8000,
  clusters = 3,
  cluster_size = NULL,
  TF = FALSE,
  TFdf = NULL
)
}
\arguments{
\item{omics}{named list containing the omic to simulate as names, which can 
be "scRNA-seq" or "scATAC-seq".}

\item{cellTypes}{list where the i-th element of the list contains the column 
indices for i-th experimental conditions. List must be a named list.}

\item{numberReps}{OPTIONAL. Number of replicates per group}

\item{numberGroups}{OPTIONAL. number of different groups}

\item{diffGenes}{OPTIONAL. If number groups > 1, Percentage DE genes to simulate.
List of vectors (one per group to compare to group 1) where the vector
contains absolute number of genes for Up and Down ex: c(250, 500) or a 
percentage for up, down ex: c(0.2, 0.2). The rest will be NE}

\item{minFC}{OPTIONAL. Threshold of FC below which are downregulated, by 
default 0.25}

\item{maxFC}{OPTIONAL. Threshold of FC above which are upregulated, by default 4}

\item{numberCells}{OPTIONAL. Vector of numbers. The numbers correspond to the number of 
cells the user wants to simulate per each cell type. The length of the 
    vector must be the same as length of \code{cellTypes}.}

\item{mean}{OPTIONAL. Vector of numbers of mean depth per each cell type. Must be specified 
just if \code{numberCells} is specified.The length of the vector must be 
    the same as length of \code{cellTypes}.}

\item{sd}{OPTIONAL. Vector of numbers of standard deviation per each cell type. Must be 
specified just if \code{numberCells} is specified.The length of the vector 
    must be the same as length of \code{cellTypes}.}

\item{noiseRep}{OPTIONAL. Number indicating the desired standard deviation 
between biological replicates.}

\item{noiseGroup}{OPTIONAL. Number indicating the desired standard deviation
between treatment groups}

\item{regulatorEffect}{OPTIONAL. To simulate relationship scRNA-scATAC, list 
of vectors (one per group) where the vector contains absolute number of
regulators for Activator and repressor ex: c(150, 200) or a percentage
for Activator and repressor ex: c(0.2, 0.1). The rest will be NE. If not
provided, no table of association between scRNA and scATAC is outputted.}

\item{associationList}{REQUIRED A 2 columns dataframe reporting peak ids 
related to gene names. If user doesnt have one, load from package
data("associationList")}

\item{feature_no}{OPTIONAL. If only scRNA-seq to simulate or scRNA and scATAC
but no regulatory constraints, total number of features to be distributed 
between the coexpression clusters.}

\item{clusters}{OPTIONAL. Number of co-expression patterns the user wants
to simulate}

\item{cluster_size}{OPTIONAL. It may be inputted by the user. Recommended: 
by default, its the number of features divided by the number of patterns 
to generate.}

\item{TF}{OPTIONAL default is FALSE, if true, extract TF dataframe}

\item{TFdf}{OPTIONAL, default is NULL. If an association matrix of TF and 
Target_gene is given the TF expression values are extracted. If no data.frame
is given, using the association of human TF from 
{https://tflink.net/}}
}
\value{
a list of Seurat object, one per each omic.
}
\description{
Performs multiomic simulation of single cell datasets
}
\examples{
omic_list <- sc_omicData(list("scRNA-seq"))
cell_types <- list('Treg' = c(1:10),'cDC' = c(11:20),'CD4_TEM' = c(21:30),
'Memory_B' = c(31:40))
sim <- sc_mosim(omic_list, cell_types)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R
\docType{class}
\name{MOSimulator-class}
\alias{MOSimulator-class}
\title{Virtual class containing common methods and slots for child classes.}
\description{
Virtual class containing common methods and slots for child classes.
}
\section{Slots}{

\describe{
\item{\code{name}}{Name of the simulator to be used in messages.}

\item{\code{data}}{Data frame containing the initial sample to be used, with the
features IDs as rownames and only one column named "Counts".}

\item{\code{regulator}}{Boolean flag to indicate if the omic is a regulator or not.}

\item{\code{regulatorEffect}}{Possible regulation effects of the omic (enhancer,
repressor or both).}

\item{\code{idToGene}}{Data frame with the association table between genes and other
features. The structure must be 2 columns, one named "ID" and the other
"Gene".}

\item{\code{min}}{Minimum value allowed in the omic.}

\item{\code{max}}{Maximum value allowed in the omic.}

\item{\code{depth}}{Sequencing depth to simulate.}

\item{\code{depthRound}}{Number of decimal places to round when adjusting depth.}

\item{\code{depthAdjust}}{Boolean indicating whether to adjust by sequencing depth or
not.}

\item{\code{totalFeatures}}{Number of features to simulate. This will replace the
data with a subset.}

\item{\code{noiseFunction}}{Noise function to apply when simulating counts. Must
accept the parameter 'n' and return a vector of the same length. Defaults
to `rnorm`}

\item{\code{increment}}{Read-only. Minimum value to increase when simulating counts.}

\item{\code{simData}}{Contains the final simulated data.}

\item{\code{pregenerated}}{Indicates if the child class will generate the simulated
data instead of the general process.}

\item{\code{randData}}{Auxiliary vector containing the original count data in random
order with other adjustments.}

\item{\code{noiseParams}}{Noise parameters to be used with noise function.}

\item{\code{roundDigits}}{Number of digits to round the simulated count values.}

\item{\code{minMaxQuantile}}{Numeric vector of length 2 indicating the quantiles to
use in order to retrieve the absolute minimum and maximum value that a
differentially expressed feature can have.}

\item{\code{minMaxFC}}{Numeric vector of length 2 indicating the minimum and maximum
fold-change that a differentially expressed feature can have.}

\item{\code{minMaxDist}}{Named list containing different minimum and maximum
constraints values calculated at the beginning of the simulation process.}

\item{\code{replicateParams}}{Named list containing the parameters a and b to be used
in the replicates generation process, see the vignette for more info.}
}}

\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{calculate_mean_per_list_df}
\alias{calculate_mean_per_list_df}
\title{calculate_mean_per_list_df}
\usage{
calculate_mean_per_list_df(df, named_lists)
}
\arguments{
\item{df}{dataframe of expression where columns are cells}

\item{named_lists}{list of which cells belong to each celltype}
}
\description{
Helper function to calculate mean expression per celltype
}
\examples{
rna <- data.frame(c1 = c(1.5, 15.5, 3.5, 20.5), c2 = c(2, 15, 4, 20), 
          c3 = c(10, 1, 12, 13), c4 = c(11, 1, 13, 14))
cell_types <- list("ct1" = c(1,2), "ct2" = c(3, 4))
calculate_mean_per_list_df(rna, cell_types)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{omicData}
\alias{omicData}
\title{Set customized data for an omic.}
\usage{
omicData(omic, data = NULL, associationList = NULL)
}
\arguments{
\item{omic}{The name of the omic to provide data.}

\item{data}{Data frame with the omic identifiers as row names and just one
column named Counts containing numeric values used as initial sample for
the simulation.}

\item{associationList}{Only for regulatory omics, a data frame with 2
columns, the first called containing the regulator ID and the second called
Gene with the gene identifier.}
}
\value{
Initialized simulation object with the given data.
}
\description{
Set customized data for an omic.
}
\examples{

# Take a subset of the included dataset for illustration
# purposes. We could also load it from a csv file or RData,
# as long as we transform it to have 1 column named "Counts"
# and the identifiers as row names.

data(sampleData)

custom_rnaseq <- head(sampleData$SimRNAseq$data, 100)

# In this case, 'custom_rnaseq' is a data frame with
# the structure:
head(custom_rnaseq)
##                    Counts
## ENSMUSG00000000001   6572
## ENSMUSG00000000003      0
## ENSMUSG00000000028   4644
## ENSMUSG00000000031      8
## ENSMUSG00000000037      0
## ENSMUSG00000000049      0


# The helper 'omicData' returns an object with our custom data.
rnaseq_customdata <- omicData("RNA-seq", data = custom_rnaseq)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{random_unif_interval}
\alias{random_unif_interval}
\title{random_unif_interval
Function to call the C code
This function is a copy of the `random_unif_interval` function from the 
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo, 
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed 
under the GPL-3 license.}
\usage{
random_unif_interval(size, max_val)
}
\arguments{
\item{size}{from sparsim}

\item{max_val}{from sparsim}
}
\description{
random_unif_interval
Function to call the C code
This function is a copy of the `random_unif_interval` function from the 
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo, 
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed 
under the GPL-3 license.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{omicSettings}
\alias{omicSettings}
\title{Retrieves the settings used in a simulation}
\usage{
omicSettings(
  simulation,
  omics = NULL,
  association = FALSE,
  reverse = FALSE,
  only.linked = FALSE,
  prefix = FALSE,
  include.lagged = TRUE
)
}
\arguments{
\item{simulation}{A MOSimulation object.}

\item{omics}{List of omics to retrieve the settings.}

\item{association}{A boolean indicating if the association must also be
returned for the regulators.}

\item{reverse}{A boolean, swap the column order in the association list in
case we want to use the output directly and the program requires a
different ordering.}

\item{only.linked}{Return only the interactions that have an effect.}

\item{prefix}{Logical indicating if the name of the omic should prefix the
name of the regulator.}

\item{include.lagged}{Logical indicating if interactions with transitory
profile and different minimum/maximum time point between gene and regulator
should be included or not.}
}
\value{
A list containing a data frame with the settings used to simulate
  each of the indicated omics. If association is TRUE, it will be a list with
  3 keys: 'associations', 'settings' and 'regulators', with the first two
  keys being a list containing the information for the selected omics and the
  last one a global data frame giving the merged information.
}
\description{
Retrieves the settings used in a simulation
}
\examples{

omic_list <- c("RNA-seq", "miRNA-seq")
multi_simulation <- mosim(omics = omic_list)

# This will be a data frame with RNA-seq settings (DE flag, profiles)
rnaseq_settings <- omicSettings(multi_simulation, "RNA-seq")

# This will be a list containing all the simulated omics (RNA-seq
# and DNase-seq in this case)
all_settings <- omicSettings(multi_simulation)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\docType{package}
\name{MOSim-package}
\alias{MOSim}
\alias{MOSim-package}
\title{MOSim}
\description{
Multiomics simulation package.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/ConesaLab/MOSim}
  \item Report bugs at \url{https://github.com/ConesaLab/MOSim/issues}
}

}
\author{
\strong{Maintainer}: Sonia Tarazona \email{sotacam@gmail.com}

Authors:
\itemize{
  \item Carolina Monzó \email{carolmonzoc@gmail.com}
  \item Carlos Martínez \email{cmarmir@gmail.com}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{sparsim_create_simulation_parameter}
\alias{sparsim_create_simulation_parameter}
\title{Create SPARSim simulation parameter}
\usage{
sparsim_create_simulation_parameter(
  intensity,
  variability,
  library_size,
  feature_names = NA,
  sample_names = NA,
  condition_name = NA,
  intensity_2 = NULL,
  variability_2 = NULL,
  p_bimod = NULL
)
}
\arguments{
\item{intensity}{Array of gene expression intensity values}

\item{variability}{Array of gene expression variability values}

\item{library_size}{Array of library size values}

\item{feature_names}{Array of feature names. It must be of the same length of \code{intensity} array. If NA (default), feature will be automatically named "gene_1", "gene_2", ... "gene_<N>", where N = length(intensity)}

\item{sample_names}{Array of sample names. It must be of the same length of \code{library_size} array. If NA (defatul), sample will be automatically named "<condition_name>_cell1", "<condition_name>_cell2", ..., "<condition_name>_cell<M>", where M = length(library_size)}

\item{condition_name}{Name associated to the current experimental condition. If NA (default), it will be set to "cond<l1><l2>", where l1 and l2 are two random letters.}

\item{intensity_2}{Array of gene expression intensity values for the second expression mode, if simulating genes with bimodal gene expression. Entries containing \code{NAs} will be ignored. If NULL (default), no bimodal gene expression is simulated.}

\item{variability_2}{Array of gene expression variability values for the second expression mode, if simulating genes with bimodal gene expression. If NULL (default), no bimodal gene expression is simulated.}

\item{p_bimod}{Array of bimodal gene expression probabilities; the i-th value indicates the probability \code{p} of the i-th gene to be expressed in the first mode
(i.e. the one specified in the i-th entries of parameters \code{intensity} and \code{variability}); with probability \code{1-p} the i-th gene will be expressed in the second mode (i.e. the one specified in the i-th entries of parameters \code{intensity_2} and \code{variability_2})}
}
\value{
SPARSim simulation parameter describing one experimental condition
}
\description{
Function to create a SPARSim simulation parameter.
This function is a copy of the `SPARSIM_create_simulation_parameter` function from the 
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo, 
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed 
under the GPL-3 license.
To simulate N feature (e.g. genes), user must specify N values of gene expression level and gene expression variability in the function input parameters \code{intensity} and \code{variability}, respectively.
To simulate M samples (i.e. cells), user must specify M values of sample library size in the function input parameter \code{library_size}.
}
\details{
User can optionally specify the names to assign at the single feature and sample to simulate (function input parameters \code{feature_names} and \code{sample_names}, respectively,
as well as the name of the experimental condition (function input parameter \code{condition_name}). If the user does not specify such information, the function will set some default values.

To simulate T different experimental conditions in a single count table, then T different simulation parameters must be created.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{plotProfile}
\alias{plotProfile}
\title{Generate a plot of a feature's profile for one or two omics.}
\usage{
plotProfile(simulation, omics, featureIDS, drawReps = FALSE, groups = NULL)
}
\arguments{
\item{simulation}{A MOSimulation object}

\item{omics}{Character vector of the omics to simulate.}

\item{featureIDS}{List containing the feature to show per omic. Must have the
omics as the list names and the features as values.}

\item{drawReps}{Logical to enable/disable the representation of the
replicates inside the plot.}

\item{groups}{Character vector indicating the groups to plot in the form
"GroupX" (i.e. Group1)}
}
\value{
A ggplot2 object.
}
\description{
Generate a plot of a feature's profile for one or two omics.
}
\examples{
omic_list <- c("RNA-seq", "miRNA-seq")

rnaseq_options <- c(omicSim("miRNA-seq", totalFeatures = 2500))
rnaseq_simulation <- mosim(omics = omic_list,
                           omicsOptions = rnaseq_options)

#plotProfile(rnaseq_simulation,
#     omics = c("RNA-seq", "miRNA-seq"),
#   featureIDS = list("RNA-seq"="ENSMUSG00000007682", "miRNA-seq"="mmu-miR-320-3p")
#)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\docType{data}
\name{sampleData}
\alias{sampleData}
\title{Default data}
\format{
An object of class \code{list} of length 6.
}
\usage{
data("sampleData")
}
\description{
Dataset with base counts and id-gene tables.
}
\details{
List with 6 elements:
\describe{
  \item{SimRNAseq}{\describe{
  \item{data}{Dataframe with base counts with gene id as rownames.}
  \item{geneLength}{Length of every gene.}}}
  \item{SimChIPseq}{\describe{
  \item{data}{Dataframe with base counts with regions as rownames.}
  \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
  \item{SimDNaseseq}{\describe{
  \item{data}{Dataframe with base counts with regions as rownames.}
  \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
  \item{SimMiRNAseq}{\describe{
  \item{data}{Dataframe with base counts with miRNA id as rownames.}
  \item{idToGene}{Dataframe with miRNA as "ID" column and gene name on "Gene" column.}}}
  \item{SimMethylseq}{\describe{
  \item{idToGene}{Dataframe with region as "ID" column and gene name on "Gene" column.}}}
  \item{CpGisland}{Dataframe of CpG to be used as initialization data, located on "Region" column}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparsim_functions.R
\name{sparsim_simulation}
\alias{sparsim_simulation}
\title{Function to simulate a raw count table}
\usage{
sparsim_simulation(
  dataset_parameter,
  output_sim_param_matrices = FALSE,
  output_batch_matrix = FALSE,
  count_data_simulation_seed = NULL
)
}
\arguments{
\item{dataset_parameter}{list containing, the intensity, variability and lib sizes of each experimental condition. It is the return value of "estimate_parameter_from_data" or could be created by the users}

\item{output_sim_param_matrices}{boolean flag. If TRUE, the function will output two additional matrices, called abundance_matrix and variability_matrix, containing the gene intensities and gene variabilities used as simulation input. (Default: FALSE)}

\item{output_batch_matrix}{boolean flag. If TRUE, the function will output an additional matrix, called batch_factors_matrix, containing the multiplicative factors used in batch effect simulation. (Default: FALSE)}

\item{count_data_simulation_seed}{inherited from sparsim}
}
\value{
A list of 5 elements:

  - \code{count_matrix}: the simulated count matrix (genes on rows, samples on columns)

  - \code{gene_matrix}: the simulated gene expression levels (genes on rows, samples on columns)

  - \code{abundance_matrix}: the input gene intensity values provided as input (genes on rows, samples on columns), if \code{output_sim_param_matrices} = TRUE. NULL otherwise.

  - \code{variability_matrix}: the input gene variability values provided as input (genes on rows, samples on columns), if \code{output_sim_param_matrices} = TRUE. NULL otherwise.

  - \code{batch_factors_matrix}: the multiplicative factor used in batch generation (genes on rows, samples on columns), if \code{output_batch_matrix} = TRUE. NULL otherwise.
}
\description{
This function is a copy of the `SPARSIM_simulation` function from the
`SPARSim` package (v0.9.5), originally developed by Giacomo Baruzzo,
Ilaria Patuzzi, Barbara Di Camillo (2020). The original package is licensed
under the GPL-3 license.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{check_patterns}
\alias{check_patterns}
\title{check_patterns}
\usage{
check_patterns(patterns)
}
\arguments{
\item{patterns}{tibble of TRUE FALSE values}
}
\value{
list of indices where the rows are opposite
}
\description{
Function to check if the TRUE FALSE patterns have at least two rows that are
opposite, we need this to be able to generate repressor regulators
}
\examples{
patterns <- tibble::tibble(one = c(TRUE, FALSE, TRUE, FALSE), 
              two = c(TRUE, TRUE, TRUE, TRUE), 
              three = c(FALSE, TRUE, FALSE, TRUE), 
              four = c(FALSE, TRUE, TRUE, TRUE))
opposite_indices <- check_patterns(patterns)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sc_coexpression.R
\name{shuffle_group_matrix}
\alias{shuffle_group_matrix}
\title{shuffle_group_matrix, Reorder cell type-specific expression matrix during 
co-expression simulation. Copied from ACORDE (https://github.com/ConesaLab/acorde)
to facilitate stability and running within our scripts
This function is a slightly modified copy of the `shuffle_group_matrix` function
from the `Acorde` package (v1.0.0), originally developed by Arzalluz-Luque A, 
Salguero P, Tarazona S, Conesa A. (2022). acorde unravels functionally 
interpretable networks of isoform co-usage from single cell data. Nature communications
1828. DOI: 10.1038/s41467-022-29497-w. The original package is licensed under the 
GPL-3 license.}
\usage{
shuffle_group_matrix(sim_data, feature_ids, group_pattern, ngroups)
}
\arguments{
\item{sim_data}{A count matrix with features as rows and cells as columns.
Feature IDs must be included in an additional column named \code{feature}.}

\item{feature_ids}{A two-column \code{tibble} containing \code{top} and \code{bottom}
columns, each including the feature IDs of features to be used as highly or
lowly expressed when shuffling by the indicated expression pattern.}

\item{group_pattern}{A logical vector, containing \code{TRUE} to indicate that
high expression in that cell type is desired and \code{FALSE} if the opposite.
The vector must be ordered as the cell types in \code{sim_data}.}

\item{ngroups}{An integer indicating the number of groups that top and bottom
features should be divided into. It is computed by dividing the number
of features selected as highly/lowly expressed by the size of the clusters
that are to be generated.}
}
\value{
An expression matrix, with the same characteristics as \code{sim_data},
and a number of features defined as the total amount of top/bottom features
selected divided by the number of clusters for which co-expression patterns
where supplied.
}
\description{
This function is used internally by \code{acorde} to perform
the shuffling of simulated features for an individual cell type, as part of
the co-expression simulation process. The function is called recursively by
\code{\link[MOSim:simulate_coexpression]{simulate_coexpression()}} to
perform the simulation on a full scRNA-seq matrix.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOSim.R
\name{experimentalDesign}
\alias{experimentalDesign}
\title{Retrieves the experimental design}
\usage{
experimentalDesign(simulation)
}
\arguments{
\item{simulation}{A MOSimulation object}
}
\value{
A data frame containing the experimental design used to simulate the
  data.
}
\description{
Retrieves the experimental design
}
\examples{

omic_list <- c("RNA-seq")
rnaseq_simulation <- mosim(omics = omic_list)
# This will be a data frame with RNA-seq counts

design_matrix <- experimentalDesign(rnaseq_simulation)

}
